//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "About.h"
#include "perehdlg.h"
#include "strucfrm.h"
#include "nastrfrm.h"
#include "acpnastr.h"
#include "capnastr.h"
#include "statdlg.h"
#include "asmcode.h"
#include "welcomef.h"
#include "misc.h"
#include "progrdlg.h"
#include <stdio.h>
#include <IniFiles.hpp>
//---------------------------------------------------------------------------
#pragma link "PgSetup"
#pragma resource "*.dfm"
TMainForm *MainForm;
//---------------------------------------------------------------------------
__fastcall TMainForm::TMainForm(TComponent *Owner)
	: TForm(Owner)
{
    m_ini_name = ExtractFileDir(Application->ExeName) + "/Privod.ini";
    m_col_can_CAP = 2;
    Printer()->Orientation = Printers::poLandscape;
    ReadIniFile();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::APerehHarExecute(TObject *Sender)
{
    TextForm = new TTextForm(this);
    TextForm->RichEdit->Lines->LoadFromFile(ExtractFileDir(Application->ExeName) + "/Text/PerehDoc.rtf");
    if(TextForm->ShowModal() == mrOk)
    {
    	TPerDlg* dlg = new TPerDlg(this);
        dlg->ReadIniFile();
        if(dlg->ShowModal() == mrOk)
        {
         	dlg->SaveIniFile();
            if(dlg->m_coords_mask[0] != 0)
            {
	            TGraphFrm* frm = new TGraphFrm(this);
                frm->Caption = "  " + IntToStr(MDIChildCount);
    	        frm->m_graph.elp_time = ((double)dlg->m_thr->end_clock)/1000;
    	        frm->m_graph.m_coords_mask[0] = dlg->m_coords_mask[0];
        	    if(dlg->ChBAuto->Checked) frm->m_graph.m_coords_mask[1] = dlg->m_coords_mask[1];
	            else frm->m_graph.m_coords_mask[1] = 0;
    	        frm->m_graph.end_time = frm->m_graph.elp_time;
            	frm->m_graph.m_coords_to_show[0] = frm->m_graph.m_coords_mask[0];
            	frm->m_graph.m_coords_to_show[1] = 0;
	            frm->m_graph.m_file = dlg->m_file;
    	        frm->m_graph.m_file_orig = frm->m_graph.m_file;
    	        frm->m_graph.m_file_filter = frm->m_graph.m_file + "f";
            }
        }
    	delete dlg;
    }
    delete TextForm;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileOpenExecute(TObject *Sender)
{
    TForm* frm;
	if (OpenDialog->Execute())
    {
		try
        {
	    	AnsiString ext = ExtractFileExt(OpenDialog->FileName);
    	    if(ext == ".dta")
        	{
				frm = new TGraphFrm(this);
	            ((TGraphFrm*)frm)->LoadFromFile(OpenDialog->FileName);
            }
            else if(ext == ".str")
            {
             	frm = new TStructFrm(this);
                ((TStructFrm*)frm)->LoadFromFile(OpenDialog->FileName);
            }
        }
        catch(char* msg)
        {
	        frm->Close();
        	ShowMessage(AnsiString(msg));
        }
    }
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::HelpAboutExecute(TObject *Sender)
{
    TAboutBox* AboutBox = new TAboutBox(this);
	AboutBox->ShowModal();
    delete AboutBox;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FileExitExecute(TObject *Sender)
{
	Close();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AStructFrmExecute(TObject *Sender)
{
	TStructFrm* frm = new TStructFrm(Application);
	frm->Show();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AParamsExecute(TObject *Sender)
{
	TMainNastr* dlg = new TMainNastr(this);
    dlg->SetText(m_labels, m_razmern);
    dlg->SetPriority(ScanPriorClass, ScanThreadPrior, AppPriorClass, AppThreadPrior);
    dlg->ETzi->Text = FloatToStrF(m_Tzi, ffFixed, 10, 2);

    if(dlg->ShowModal() == mrOk)
    {
	    dlg->GetText(m_labels, m_razmern);
    	dlg->GetPriority(ScanPriorClass, ScanThreadPrior, AppPriorClass, AppThreadPrior);
        m_Tzi = myStrToFloat(dlg->ETzi->Text);
        SaveIniFile();
    }
    delete dlg;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ANastrACPExecute(TObject *Sender)
{
    int i;
	ACPDlg = new TACPDlg(this);
	ACPDlg->RGrChannel->Items->Clear();
	for(i=0; i<16; i++)
    {
    	ACPDlg->m_base[i] = m_base[0][i];
    	ACPDlg->m_real_base[i] = m_real_base[0][i];
		ACPDlg->m_offset[i] = m_offset[0][i];
		ACPDlg->RGrChannel->Items->Add(m_labels[0][i]);
        ACPDlg->RGrChannel->ItemIndex = 0;
    }
    ACPDlg->m_filter_mask = m_filter_mask;
	if(ACPDlg->ShowModal() == mrOk)
    {
	    for(i=0; i<16; i++)
    	{
    		m_base[0][i] = ACPDlg->m_base[i];
	    	m_real_base[0][i] = ACPDlg->m_real_base[i];
			m_offset[0][i] = ACPDlg->m_offset[i];
	    }
        m_filter_mask = ACPDlg->m_filter_mask;
        SaveIniFile();
    }
    delete ACPDlg;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AStaticHarExecute(TObject *Sender)
{
    TextForm = new TTextForm(this);
    TextForm->RichEdit->Lines->LoadFromFile(ExtractFileDir(Application->ExeName) + "/Text/StatDoc.rtf");
    if(TextForm->ShowModal() == mrOk)
    {
    	StaticDlg = new TStaticDlg(this);
        StaticDlg->ReadIniFile();
        if(StaticDlg->ShowModal() == mrOk)
        {
    	    StaticDlg->SaveIniFile();
        	if(StaticDlg->m_col_points > 1)
            {
	            TGraphFrm* frm = new TGraphFrm(this);
                frm->Caption = "  " + IntToStr(MDIChildCount);
        	    frm->m_graph.elp_time = StaticDlg->m_col_points;
            	frm->m_graph.m_coords_mask[0] = 0xffff;
	            frm->m_graph.m_coords_mask[1] = 0x0003;
    	        frm->m_graph.end_time = frm->m_graph.elp_time;
            	frm->m_graph.m_coords_to_show[0] = 0;
            	frm->m_graph.m_coords_to_show[1] = 0;
	            frm->m_graph.m_file = StaticDlg->m_file;
    	        frm->m_graph.m_file_orig = frm->m_graph.m_file;
            	frm->m_graph.m_file_filter = frm->m_graph.m_file + "f";
                frm->m_graph.m_static = true;
            }
	        else if(FileExists(StaticDlg->m_file)) DeleteFile(StaticDlg->m_file);
        }
        else if(FileExists(StaticDlg->m_file)) DeleteFile(StaticDlg->m_file);
        delete StaticDlg;
    }
    delete TextForm;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormShow(TObject *Sender)
{
	ResetCAP();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::FormClose(TObject *Sender, TCloseAction &Action)
{
	ResetCAP();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ResetCAP(short val_CAP[16])
{
TCursor Save_Cursor = Screen->Cursor;
Screen->Cursor = crHourGlass;
try
{
    unsigned long beg_clock, cur_clock;
    int val = 0;
	short channel, CAP_tmp[16], CAP_prv[16];
    double zi_step[16];
    for(channel=0; channel<m_col_can_CAP; channel++)
    {
    	val |= val_CAP[channel];
        if(val_CAP[channel] == 0) zi_step[channel] = 0;
        else
        {
			if(m_Tzi != 0) zi_step[channel] = m_real_base[1][channel]/m_base[1][channel]*511
    	    						/(m_Tzi*1000)*((double)val_CAP[channel]/(double)abs(val_CAP[channel]));
        	else zi_step[channel] = 1024;
        }
        CAP_prv[channel] = val_CAP[channel];
    }
	beg_clock = GetTickCount();
    while(val != 0)
    {
		val = 0;
		cur_clock = GetTickCount();
	    for(channel=0; channel<m_col_can_CAP; channel++)
    	{
			if(CAP_prv[channel] != 0) CAP_tmp[channel] = (short)((double)val_CAP[channel] - (zi_step[channel]*(double)(cur_clock-beg_clock)));
			if(CAP_tmp[channel] != 0)
            {
             	if((CAP_prv[channel]/CAP_tmp[channel]) < 0) CAP_tmp[channel] = 0;
                else if((CAP_tmp[channel]+m_offset[1][channel]) > 1023) CAP_tmp[channel] = 0;
                else if((CAP_tmp[channel]+m_offset[1][channel]) < 0) CAP_tmp[channel] = 0;
            }
	    	SendCAP(channel,(short)(CAP_tmp[channel]+m_offset[1][channel]));
            CAP_prv[channel] = CAP_tmp[channel];
			val |= CAP_tmp[channel];
	    }
    }
}
__finally
{
	Screen->Cursor = Save_Cursor;
}
}
//---------------------------------------------------------------------------

void __fastcall TMainForm::ResetCAP()
{
	short channel;
	for(channel=0; channel<m_col_can_CAP; channel++) SendCAP(channel, m_offset[1][channel]);
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ReadIniFile()
{
	TIniFile* RegFile = new TIniFile(m_ini_name);
    AnsiString strs1[16]      = {"Ica", "Uca", "Ipbc", "Upbc", "f1", "W",     "M",   "P1",  "P2",  "I", "K11", "K12", "K13", "K14", "K15", "K16"};
    AnsiString strs2[16]      = {"A",   "B",   "A",    "B",    "", "/", "*", "", "", "",  "",    "",    "",    "",    "",    ""};
    double base_def1[16]      = {15,    220,   15,     220,    100,  188,     25,    1,     1,     20,   1,     1,     1,     1,     1,     1};
    double real_base_def1[16] = {15,    220,   15,     220,    100,  188,     25,    1,     1,     20,   1,     1,     1,     1,     1,     1};
    AnsiString strs3[16]      = {"M",   "U", ".", "", "", "", "", "", "", "", "", "", "", "", "", ""};
    AnsiString strs4[16]      = {"*", "B", "", "", "", "", "", "", "", "", "", "", "", "", "", ""};
    double base_def2[16]  	  = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    double real_base_def2[16] = {1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1, 1};
    for(int i=0; i<16; i++)
    {
        m_labels[0][i] 		= RegFile->ReadString("  ","label"+IntToStr(i+1),strs1[i]);
        m_razmern[0][i] 	= RegFile->ReadString("  ","razmern"+IntToStr(i+1),strs2[i]);
        m_base[0][i]  	 	= RegFile->ReadFloat("Base","ACP_Base"+IntToStr(i+1),base_def1[i]);
        m_real_base[0][i] 	= RegFile->ReadFloat("real_Base","ACP_Base"+IntToStr(i+1),real_base_def1[i]);
        m_offset[0][i]   	= (short)RegFile->ReadInteger("Offset","ACP_Offset"+IntToStr(i+1),0);
    }
    for(int i=0; i<16; i++)
    {
        m_labels[1][i]    = RegFile->ReadString("  ","label"+IntToStr(i+1),strs3[i]);
        m_razmern[1][i]   = RegFile->ReadString("  ","razmern"+IntToStr(i+1),strs4[i]);
        m_base[1][i]      = RegFile->ReadFloat("Base","CAP_Base"+IntToStr(i+1),base_def2[i]);
        m_real_base[1][i] = RegFile->ReadFloat("real_Base","CAP_Base"+IntToStr(i+1),real_base_def2[i]);
        m_offset[1][i]    = (short)RegFile->ReadInteger("Offset","CAP_Offset"+IntToStr(i+1),511);
    }
   	ScanPriorClass  = RegFile->ReadInteger(" ","ScanPriorityClass",NORMAL_PRIORITY_CLASS);
   	ScanThreadPrior = RegFile->ReadInteger(" ","ScanThreadPriority",THREAD_PRIORITY_NORMAL);
   	AppPriorClass   = RegFile->ReadInteger(" ","AppPriorityClass",NORMAL_PRIORITY_CLASS);
   	AppThreadPrior  = RegFile->ReadInteger(" ","AppThreadPriority",THREAD_PRIORITY_NORMAL);
   	m_Tzi 			= RegFile->ReadFloat("defaults","",2);
	m_filter_mask 	= (short)RegFile->ReadInteger("defaults"," ",0x000f);
    delete RegFile;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::SaveIniFile()
{
	TIniFile* RegFile = new TIniFile(m_ini_name);
    for(int i=0; i<16; i++)
    {
    	RegFile->WriteString("  ","label"+IntToStr(i+1),m_labels[0][i]);
        RegFile->WriteString("  ","razmern"+IntToStr(i+1),m_razmern[0][i]);
        RegFile->WriteFloat("Base","ACP_Base"+IntToStr(i+1),m_base[0][i]);
        RegFile->WriteFloat("real_Base","ACP_Base"+IntToStr(i+1),m_real_base[0][i]);
        RegFile->WriteInteger("Offset","ACP_Offset"+IntToStr(i+1),m_offset[0][i]);
    }
    for(int i=0; i<m_col_can_CAP; i++)
    {
    	RegFile->WriteString("  ","label"+IntToStr(i+1),m_labels[1][i]);
        RegFile->WriteString("  ","razmern"+IntToStr(i+1),m_razmern[1][i]);
        RegFile->WriteFloat("Base","CAP_Base"+IntToStr(i+1),m_base[1][i]);
        RegFile->WriteFloat("real_Base","CAP_Base"+IntToStr(i+1),m_real_base[1][i]);
        RegFile->WriteInteger("Offset","CAP_Offset"+IntToStr(i+1),m_offset[1][i]);
    }
    RegFile->WriteInteger(" ","ScanPriorityClass",ScanPriorClass);
    RegFile->WriteInteger(" ","ScanThreadPriority",ScanThreadPrior);
   	RegFile->WriteInteger(" ","AppPriorityClass",AppPriorClass);
    RegFile->WriteInteger(" ","AppThreadPriority",AppThreadPrior);
   	RegFile->WriteFloat("defaults","",m_Tzi);
	RegFile->WriteInteger("defaults"," ",m_filter_mask);
    delete RegFile;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ANastrCAPExecute(TObject *Sender)
{
	ResetCAP();
    int i;
	CAPDlg = new TCAPDlg(this);
    CAPDlg->TabControl1->Tabs->Clear();
    for(i=0; i<m_col_can_CAP; i++) CAPDlg->TabControl1->Tabs->Add(m_labels[1][i]);
	for(i=0; i<16; i++)
    {
    	CAPDlg->m_base[i] = m_base[1][i];
    	CAPDlg->m_real_base[i] = m_real_base[1][i];
		CAPDlg->m_offset[i] = m_offset[1][i];
    }

	if(CAPDlg->ShowModal() == mrOk)
    {
    	CAPDlg->SaveFields();
	    for(i=0; i<16; i++)
    	{
    		m_base[1][i] = CAPDlg->m_base[i];
	    	m_real_base[1][i] = CAPDlg->m_real_base[i];
			m_offset[1][i] = CAPDlg->m_offset[i];
	    }
        SaveIniFile();
        ResetCAP(CAPDlg->m_urov);
    }
    delete CAPDlg;
	ResetCAP();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::ACalibrZeroExecute(TObject *Sender)
{
	short channel;
	unsigned long beg_clock, req_clock, col_points;
    long double tmp_double;
	ProgressDlg = new TProgressDlg(Application);
    ProgressDlg->ProgressBar->Max = 16;
    ProgressDlg->ProgressBar->Position = 0;
    ProgressDlg->Caption = "   ";
    ProgressDlg->Show();
	SetPriorityClass(GetCurrentProcess(),ScanPriorClass);
	SetThreadPriority(GetCurrentThread(),ScanThreadPrior);
    req_clock = 1*1000;
	for(channel=0; channel<16; channel++)
    {
	    tmp_double = 0;
    	col_points = 0;
	    beg_clock = GetTickCount();
    	do {
        	tmp_double += GetACP(channel);
	        col_points++;
    	} while((GetTickCount()-beg_clock) < req_clock);
		m_offset[0][channel] = (short)(-tmp_double/(double)col_points);
	    ProgressDlg->ProgressBar->StepIt();
    }
    SaveIniFile();
	SetPriorityClass(GetCurrentProcess(),AppPriorClass);
	SetThreadPriority(GetCurrentThread(),AppThreadPrior);
	delete ProgressDlg;
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::APrintSetupExecute(TObject *Sender)
{
	PrinterSetupDialog->Execute();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::AResetZeroExecute(TObject *Sender)
{
	int channel;
    for(channel=0; channel<16; channel++) m_offset[0][channel] = 0;
    SaveIniFile();
}
//---------------------------------------------------------------------------
void __fastcall TMainForm::APageSetupExecute(TObject *Sender)
{
	PageSetupDialog->Execute();
}
//---------------------------------------------------------------------------


