//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "acpnastr.h"
#include "asmcode.h"
#include "Main.h"
#include "misc.h"
#include <math.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TACPDlg *ACPDlg;
//---------------------------------------------------------------------------
__fastcall TACPDlg::TACPDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------

void __fastcall TACPDlg::UpdateFields()
{
    ChBFilter->Checked = (m_filter_mask >> RGrChannel->ItemIndex)&1;
    if(RGrNastr->ItemIndex == 0) m_ACP_val[RGrChannel->ItemIndex] = 1;
    else m_ACP_val[RGrChannel->ItemIndex] = GetACP_val((short)RGrChannel->ItemIndex,ChBFilter->Checked);
	EBase->Text = FloatToStrF(m_real_base[RGrChannel->ItemIndex],ffFixed,10,3);
    EStand->Text = FloatToStrF(m_ACP_val[RGrChannel->ItemIndex]*m_base[RGrChannel->ItemIndex],ffFixed,10,3);
    EACP->Text = FloatToStrF(m_ACP_val[RGrChannel->ItemIndex],ffFixed,10,3);
	EZero->Text = IntToStr(m_offset[RGrChannel->ItemIndex]);
    EBaseRazm->Text = ((TMainForm*)MainForm)->m_razmern[0][RGrChannel->ItemIndex];
    EStandRazm->Text = EBaseRazm->Text;
}
//---------------------------------------------------------------------------

void __fastcall TACPDlg::SaveFields()
{
    if(ChBFilter->Checked) m_filter_mask |= (short)(1 << RGrChannel->ItemIndex);
    else m_filter_mask &= (short)~(1 << RGrChannel->ItemIndex);
	m_real_base[RGrChannel->ItemIndex] = myStrToFloat(EBase->Text);
    if(RGrNastr->ItemIndex == 0)
    	m_base[RGrChannel->ItemIndex] = myStrToFloat(EStand->Text);
    else
    {
    	if(m_ACP_val[RGrChannel->ItemIndex] != 0)
    		m_base[RGrChannel->ItemIndex] = myStrToFloat(EStand->Text)/m_ACP_val[RGrChannel->ItemIndex];
	    else m_base[RGrChannel->ItemIndex] = 1;
    }
	m_offset[RGrChannel->ItemIndex] = (short)StrToInt(EZero->Text);
}
//---------------------------------------------------------------------------

void __fastcall TACPDlg::m_Update(TObject *Sender)
{
	UpdateFields();
}
//---------------------------------------------------------------------------

void __fastcall TACPDlg::BtnSaveClick(TObject *Sender)
{
	SaveFields();
    UpdateFields();
}
//---------------------------------------------------------------------------

double __fastcall TACPDlg::GetACP_val(short channel, bool fltr)
{
	short tmp_short;
	TCursor Save_Cursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
	try
	{
		SetPriorityClass(GetCurrentProcess(),((TMainForm*)MainForm)->ScanPriorClass);
		SetThreadPriority(GetCurrentThread(),((TMainForm*)MainForm)->ScanThreadPrior);
		unsigned long beg_clock, req_clock, col_points = 0;
    	long double tmp_double = 0;
	    req_clock = 1*1000;
    	beg_clock = GetTickCount();
	    do {
    	    tmp_short = (short)(GetACP(channel) + m_offset[channel]);
        	if(fltr) tmp_double += (tmp_short*tmp_short);
	        else tmp_double += tmp_short;
    	    col_points++;
	    } while((GetTickCount()-beg_clock) < req_clock);
    	if(fltr) tmp_short = (short)sqrt(tmp_double/(double)col_points);
	    else tmp_short = (short)(tmp_double/(double)col_points);
		SetPriorityClass(GetCurrentProcess(),((TMainForm*)MainForm)->AppPriorClass);
		SetThreadPriority(GetCurrentThread(),((TMainForm*)MainForm)->AppThreadPrior);
	}
	__finally
	{
		Screen->Cursor = Save_Cursor;
	}
	return (double)tmp_short/511;
}
//---------------------------------------------------------------------------

void __fastcall TACPDlg::BtnOffsetNullClick(TObject *Sender)
{
	SetPriorityClass(GetCurrentProcess(),((TMainForm*)MainForm)->ScanPriorClass);
	SetThreadPriority(GetCurrentThread(),((TMainForm*)MainForm)->ScanThreadPrior);
	unsigned long beg_clock, req_clock, col_points = 0;
    long double tmp_double = 0;
    req_clock = 1*1000;
    beg_clock = GetTickCount();
    do {
        tmp_double += GetACP((short)RGrChannel->ItemIndex);
        col_points++;
    } while((GetTickCount()-beg_clock) < req_clock);
	SetPriorityClass(GetCurrentProcess(),((TMainForm*)MainForm)->AppPriorClass);
	SetThreadPriority(GetCurrentThread(),((TMainForm*)MainForm)->AppThreadPrior);
	EZero->Text = IntToStr((short)(-tmp_double/(double)col_points));
}
//---------------------------------------------------------------------------

void __fastcall TACPDlg::ChBFilterClick(TObject *Sender)
{
    if(ChBFilter->Checked) m_filter_mask |= (short)(1 << RGrChannel->ItemIndex);
    else m_filter_mask &= (short)~(1 << RGrChannel->ItemIndex);
}
//---------------------------------------------------------------------------




