//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "block.h"
#include "strucfrm.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
__fastcall TBlock::TBlock(TForm* ParentForm)
	: TCustomControl(((TStructFrm*)ParentForm)->SB)
{
    int i;
    Parent = ((TStructFrm*)ParentForm)->SB;
	m_form = ParentForm;
	drag_fl = false;
    m_sel = false;
    m_rot = false;
    for(i=0; i<2; i++) m_out_per_chan[i] = 0;
    for(i=0; i<3; i++) m_arg[i] = 1;
}
//---------------------------------------------------------------------------

void __fastcall TBlock::MouseDown(TMouseButton Button, TShiftState Shift,
				int X, int Y)
{
	TStructFrm* frm = dynamic_cast<TStructFrm*>(m_form);
    if(!frm) return;
    if((Button == mbLeft)
    	&&((((!m_rot && m_have_in)||(m_rot && m_have_out))&&(X>7))
        ||(((!m_rot && !m_have_in)||(m_rot && !m_have_out))&&(X>0)))
        &&((((!m_rot && m_have_out)||(m_rot && m_have_in))&&(X<(Width-7)))
        ||(((!m_rot && !m_have_out)||(m_rot && !m_have_in))&&(X<Width))))
    {             // 
        BringToFront();
        MouseCapture = true;
		origin = TPoint(X,Y);
		drag_fl = true;
    }
    else if((Button == mbLeft)&&(((X>(Width-7))&& !m_rot)||((X<7)&& m_rot))
            &&(frm->TracingLine == NULL)&& m_have_out)
    {
        int i;
        for(i=0; i<CountOut; i++)
        	if(((m_Outp[i].y-5)<Y)&((m_Outp[i].y+5)>Y)) break;
        if(i<CountOut)
        {
            TConnectLine* Cntr = new TConnectLine(Owner,this,i);
            frm->TracingLine = Cntr;
            MouseCapture = false;
        }
    }
    if((Button == mbLeft)&&(((X<7)&& !m_rot)||((X>(Width-7))&& m_rot))
        &&(frm->TracingLine == NULL)&& m_have_in)
    {
        int i;
        for(i=0; i<CountIn; i++)
            if(((m_Inp[i].y-5)<Y)&((m_Inp[i].y+5)>Y)) break;
        if((i<CountIn) & m_selIn[i])
        {
			((TConnectLine*)m_InpLine[i])->m_EndBlock = NULL;
            m_selIn[i] = false;
            frm->TracingLine = ((TConnectLine*)m_InpLine[i]);
            m_InpLine[i] = NULL;
            Invalidate();
            frm->PB->Invalidate();
            MouseCapture = false;
        }
    }
    if(Button == mbRight) m_Nastr();
    if(Shift.Contains(ssShift)&&(Button == mbLeft))
    {
        m_sel = !m_sel;
        Invalidate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TBlock::MouseUp(TMouseButton Button, TShiftState Shift,
				int X, int Y)
{
	TStructFrm* frm = dynamic_cast<TStructFrm*>(m_form);
    if(!frm) return;
	if((Button == mbLeft) & drag_fl)
    {
    	MouseCapture = false;
        drag_fl = false;
    }
    else if((Button == mbLeft) & (((X<7) & !m_rot) | ((X>(Width-7)) & m_rot))
    	& (frm->TracingLine!=NULL) & m_have_in)
    {
    	int i;
        for(i=0; i<CountIn; i++)
        	if(((m_Inp[i].y-5)<Y)&((m_Inp[i].y+5)>Y)) break;
        if((i<CountIn) & !m_selIn[i])
    	{
			frm->TracingLine->m_EndBlock = this;
			frm->TracingLine->m_inCnt = i;
			frm->TracingLine->m_EndPt = m_Inp[i];
            m_InpLine[i] = frm->TracingLine;
			m_selIn[i] = true;
			frm->TracingLine = NULL;
			Invalidate();
        }
        else
        {
        	frm->TracingLine->m_StartBlock->m_out_per_chan[frm->TracingLine->m_outCnt] --;
			if(frm->TracingLine->m_StartBlock->m_out_per_chan[frm->TracingLine->m_outCnt] == 0)
            	frm->TracingLine->m_StartBlock->m_selOut[frm->TracingLine->m_outCnt] = false;
			frm->TracingLine->m_StartBlock->Invalidate();
			delete frm->TracingLine;
			frm->TracingLine = NULL;
        }
		frm->PB->Invalidate();
	}
	else if((Button == mbLeft) & (frm->TracingLine!=NULL))
	{
    	frm->TracingLine->m_StartBlock->m_out_per_chan[frm->TracingLine->m_outCnt] --;
        if(frm->TracingLine->m_StartBlock->m_out_per_chan[frm->TracingLine->m_outCnt] == 0)
        	frm->TracingLine->m_StartBlock->m_selOut[frm->TracingLine->m_outCnt] = false;
        frm->TracingLine->m_StartBlock->Invalidate();
		delete frm->TracingLine;
		frm->TracingLine = NULL;
        frm->PB->Invalidate();
	}
}
//---------------------------------------------------------------------------

void __fastcall TBlock::MouseMove(TShiftState Shift, int X, int Y)
{
	TStructFrm* frm = dynamic_cast<TStructFrm*>(m_form);
    if(!frm) return;
	m_SetCursor(X, Y);
 	if(drag_fl)
	{
		Left += X - origin.x;
		Top += Y - origin.y;
        frm->PB->Invalidate();
	}
    if(frm->TracingLine)
    {
        TPenMode oldMode = frm->Canvas->Pen->Mode;
        frm->PB->Canvas->Pen->Mode = pmNot;
        frm->PB->Canvas->Pen->Width = 3;
        frm->TracingLine->Paint(frm->PB->Canvas->Handle);
    	frm->TracingLine->m_EndPt = TPoint(Left+X-frm->PB->Left,Top+Y-frm->PB->Top);
        frm->TracingLine->Paint(frm->PB->Canvas->Handle);
        frm->PB->Canvas->Pen->Width = 1;
        frm->PB->Canvas->Pen->Mode = oldMode;
    }
}
//---------------------------------------------------------------------------

void __fastcall TBlock::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Caption = Hint;
	if(m_NastrCaption[0] != "")
    {
    	InputPar->Label1->Caption = m_NastrCaption[0];
	    InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,4);
    }
    else
    {
		InputPar->Label1->Visible = false;
        InputPar->Edit1->Visible = false;
    }
	if(m_NastrCaption[1] != "")
    {
	    InputPar->Label2->Caption = m_NastrCaption[1];
    	InputPar->Edit2->Text = FloatToStrF(m_arg[1],ffFixed,10,4);
    }
    else
    {
		InputPar->Label2->Visible = false;
        InputPar->Edit2->Visible = false;
    }
	if(m_NastrCaption[2] != "")
    {
	    InputPar->Label3->Caption = m_NastrCaption[2];
    	InputPar->Edit3->Text = FloatToStrF(m_arg[2],ffFixed,10,4);
	}
    else
    {
		InputPar->Label3->Visible = false;
        InputPar->Edit3->Visible = false;
    }

    if(InputPar->ShowModal() == mrOk)
    {
		if(m_NastrCaption[0] != "") m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
		if(m_NastrCaption[1] != "") m_arg[1] = myStrToFloat(InputPar->Edit2->Text);
		if(m_NastrCaption[2] != "") m_arg[2] = myStrToFloat(InputPar->Edit3->Text);
    }
    delete InputPar;
	SetText();
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TBlock::m_SetCursor(int X, int Y)
{
	if((((X<7) & !m_rot) | ((X>(Width-7)) & m_rot)) & m_have_in) Cursor = crHandPoint;
    else if((((X>(Width-7)) & !m_rot) | ((X<7) & m_rot)) & m_have_out) Cursor = crHandPoint;
    else Cursor = crDefault;
}
//---------------------------------------------------------------------------

void __fastcall TBlock::m_rotate()
{
    m_rot = !m_rot;
    UpdateInOut();
    Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TBlock::UpdateInOut()
{
	int i;
    if(m_rot)
    {
    	for(i=0; i<CountIn; i++) m_Inp[i].x = Width-1;
        for(i=0; i<CountOut; i++) m_Outp[i].x = 5;
    }
    else
    {
    	for(i=0; i<CountIn; i++) m_Inp[i].x = 5;
        for(i=0; i<CountOut; i++) m_Outp[i].x = Width-1;
    }
}
//---------------------------------------------------------------------------

void __fastcall TBlock::DrawInOut(TPoint& pnt, bool sel)
{
	TPoint pointsArray[4];
	if(!m_rot)
	{
     	pointsArray[0].x = pnt.x - 5; pointsArray[0].y = pnt.y - 5;
	    pointsArray[1].x = pnt.x;     pointsArray[1].y = pnt.y;
     	pointsArray[2].x = pnt.x - 5; pointsArray[2].y = pnt.y + 5;
     	pointsArray[3].x = pnt.x - 5; pointsArray[3].y = pnt.y - 5;
	}
	else
	{
     	pointsArray[0].x = pnt.x;     pointsArray[0].y = pnt.y - 5;
     	pointsArray[1].x = pnt.x - 5; pointsArray[1].y = pnt.y;
     	pointsArray[2].x = pnt.x;     pointsArray[2].y = pnt.y + 5;
     	pointsArray[3].x = pnt.x;     pointsArray[3].y = pnt.y - 5;
	}
    Canvas->Polyline(pointsArray,3);
    if(sel) Canvas->FloodFill(pnt.x-2,pnt.y,Canvas->Pen->Color,fsBorder);
}
//---------------------------------------------------------------------------
//uuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuuu
//---------------------------------------------------------------------------

__fastcall TConnectLine::TConnectLine(TComponent* Owner, TBlock* StartBlock, int outCnt)
	: TComponent(Owner)
{
	Visible = true;
	m_StartBlock = StartBlock;
    m_EndBlock = NULL;
	m_outCnt = outCnt;
    TStructFrm* frm = dynamic_cast<TStructFrm*>(m_StartBlock->m_form);
    if(frm)
    {
    	m_StartPt.x = m_StartBlock->Left + m_StartBlock->m_Outp[m_outCnt].x - frm->PB->Left;
        m_StartPt.y = m_StartBlock->Top + m_StartBlock->m_Outp[m_outCnt].y - frm->PB->Top;
    }
	m_EndPt = m_StartPt;
    m_StartBlock->m_selOut[m_outCnt] = true;
	m_StartBlock->m_out_per_chan[m_outCnt] ++;
    m_StartBlock->Invalidate();
}
//---------------------------------------------------------------------------

__fastcall TConnectLine::TConnectLine(TComponent* Owner, TBlock* StartBlock, int outCnt, TBlock* EndBlock, int inCnt)
	: TComponent(Owner)
{
	Visible = true;
	m_StartBlock = StartBlock;
	m_outCnt = outCnt;
    m_StartBlock->m_selOut[m_outCnt] = true;
	m_StartBlock->m_out_per_chan[m_outCnt] ++;
    m_EndBlock = EndBlock;
    m_inCnt = inCnt;
	m_EndBlock->m_InpLine[m_inCnt] = this;
    m_EndBlock->m_selIn[m_inCnt] = true;
}
//---------------------------------------------------------------------------

__fastcall TConnectLine::~TConnectLine()
{
}
//---------------------------------------------------------------------------

void __fastcall TConnectLine::Paint(HDC mDC)
{
    POINT pnts[6];
    int col_pnts;
	Recalc();
	if((m_StartPt.x == m_EndPt.x)&&(m_StartPt.y == m_EndPt.y)) return;
	if(m_StartPt.x <= m_EndPt.x)
	{
    	pnts[0].x = m_StartPt.x;                pnts[0].y = m_StartPt.y;
        if(m_StartBlock->m_rot) //   
        {
        	if(m_EndBlock)
            {
            	if(m_EndBlock->m_rot)
                {
                	pnts[1].x = m_StartPt.x-12;     pnts[1].y = m_StartPt.y;
                    pnts[2].x = m_StartPt.x-12;     pnts[2].y = (m_StartPt.y+m_EndPt.y)/2;
                    pnts[3].x = m_EndPt.x+12;       pnts[3].y = (m_StartPt.y+m_EndPt.y)/2;
                    pnts[4].x = m_EndPt.x+12;       pnts[4].y = m_EndPt.y;
                }
                else
                {
                	pnts[1].x = m_StartPt.x-12;     pnts[1].y = m_StartPt.y;
                    pnts[2].x = m_StartPt.x-12;     pnts[2].y = m_EndPt.y;
                    pnts[3].x = m_StartPt.x-12;     pnts[3].y = m_EndPt.y;
                    pnts[4].x = m_StartPt.x-12;     pnts[4].y = m_EndPt.y;
                }
            }
            else
            {
            	pnts[1].x = m_StartPt.x-12;     pnts[1].y = m_StartPt.y;
                pnts[2].x = m_StartPt.x-12;     pnts[2].y = m_EndPt.y;
                pnts[3].x = m_StartPt.x-12;     pnts[3].y = m_EndPt.y;
                pnts[4].x = m_StartPt.x-12;     pnts[4].y = m_EndPt.y;
            }
        }
        else //    
        {
        	if(m_EndBlock)
            {
            	if(m_EndBlock->m_rot)
                {
                	pnts[1].x = m_EndPt.x+12;       pnts[1].y = m_StartPt.y;
                    pnts[2].x = m_EndPt.x+12;       pnts[2].y = m_EndPt.y;
                    pnts[3].x = m_EndPt.x+12;       pnts[3].y = m_EndPt.y;
                    pnts[4].x = m_EndPt.x+12;       pnts[4].y = m_EndPt.y;
                }
                else
                {
                	pnts[1].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[1].y = m_StartPt.y;
                    pnts[2].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[2].y = m_EndPt.y;
                    pnts[3].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[3].y = m_EndPt.y;
                    pnts[4].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[4].y = m_EndPt.y;
                }
            }
            else
            {
            	pnts[1].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[1].y = m_StartPt.y;
                pnts[2].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[2].y = m_EndPt.y;
                pnts[3].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[3].y = m_EndPt.y;
                pnts[4].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[4].y = m_EndPt.y;
            }
        }
        pnts[5].x = m_EndPt.x;                  pnts[5].y = m_EndPt.y;
        col_pnts = 6;
	}
	else
	{
    	pnts[0].x = m_StartPt.x;                pnts[0].y = m_StartPt.y;
        if(m_StartBlock->m_rot) //   
        {
        	if(m_EndBlock)
            {
            	if(m_EndBlock->m_rot)
                {
                	pnts[1].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[1].y = m_StartPt.y;
                    pnts[2].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[2].y = m_EndPt.y;
                    pnts[3].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[3].y = m_EndPt.y;
                    pnts[4].x = (m_StartPt.x+m_EndPt.x)/2;  pnts[4].y = m_EndPt.y;
                }
                else
                {
                	pnts[1].x = m_EndPt.x-12;     pnts[1].y = m_StartPt.y;
                    pnts[2].x = m_EndPt.x-12;     pnts[2].y = m_EndPt.y;
                    pnts[3].x = m_EndPt.x-12;     pnts[3].y = m_EndPt.y;
                    pnts[4].x = m_EndPt.x-12;     pnts[4].y = m_EndPt.y;
                }
            }
            else
            {
            	pnts[1].x = m_EndPt.x-12;     pnts[1].y = m_StartPt.y;
                pnts[2].x = m_EndPt.x-12;     pnts[2].y = m_EndPt.y;
                pnts[3].x = m_EndPt.x-12;     pnts[3].y = m_EndPt.y;
                pnts[4].x = m_EndPt.x-12;     pnts[4].y = m_EndPt.y;
            }
        }
        else //    
        {
        	if(m_EndBlock)
            {
            	if(m_EndBlock->m_rot)
                {
                	pnts[1].x = m_StartPt.x+12;     pnts[1].y = m_StartPt.y;
                    pnts[2].x = m_StartPt.x+12;     pnts[2].y = m_EndPt.y;
                    pnts[3].x = m_StartPt.x+12;     pnts[3].y = m_EndPt.y;
                    pnts[4].x = m_StartPt.x+12;     pnts[4].y = m_EndPt.y;
                }
                else
                {
                	pnts[1].x = m_StartPt.x+12;     pnts[1].y = m_StartPt.y;
                    pnts[2].x = m_StartPt.x+12;     pnts[2].y = (m_StartPt.y+m_EndPt.y)/2;
                    pnts[3].x = m_EndPt.x-12;       pnts[3].y = (m_StartPt.y+m_EndPt.y)/2;
                    pnts[4].x = m_EndPt.x-12;       pnts[4].y = m_EndPt.y;
                }
            }
            else
            {
            	pnts[1].x = m_StartPt.x+12;     pnts[1].y = m_StartPt.y;
                pnts[2].x = m_StartPt.x+12;     pnts[2].y = (m_StartPt.y+m_EndPt.y)/2;
                pnts[3].x = m_EndPt.x-12;       pnts[3].y = (m_StartPt.y+m_EndPt.y)/2;
                pnts[4].x = m_EndPt.x-12;       pnts[4].y = m_EndPt.y;
            }
        }
        pnts[5].x = m_EndPt.x;                  pnts[5].y = m_EndPt.y;
        col_pnts = 6;
	}
    Polyline(mDC, pnts, col_pnts);
}
//---------------------------------------------------------------------------

void __fastcall TConnectLine::Recalc()
{
	if(m_StartBlock)
    {
		TStructFrm* frm = dynamic_cast<TStructFrm*>(m_StartBlock->m_form);
        if(frm)
        {
	    	m_StartPt.x = m_StartBlock->Left + m_StartBlock->m_Outp[m_outCnt].x - frm->PB->Left;
    	    m_StartPt.y = m_StartBlock->Top + m_StartBlock->m_Outp[m_outCnt].y - frm->PB->Top;
        }
    }
    if(m_EndBlock)
    {
		TStructFrm* frm = dynamic_cast<TStructFrm*>(m_EndBlock->m_form);
        if(frm)
        {
	    	m_EndPt.x = m_EndBlock->Left + m_EndBlock->m_Inp[m_inCnt].x - frm->PB->Left;
    	    m_EndPt.y = m_EndBlock->Top + m_EndBlock->m_Inp[m_inCnt].y - frm->PB->Top;
        }
	}
}
//---------------------------------------------------------------------------

