//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "blocks1.h"
#include "Main.h"
#include "misc.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
//---------------------------------------------------------------------------
//============  =====================================================

__fastcall TSumBlock::TSumBlock(TForm* ParentForm)
        : TBlock(ParentForm)
{
	SetBounds(0,0,50,40);
    CountIn = 2;
    CountOut = 1;
    m_Inp[0] = TPoint(5,Height/(CountIn+1));
    m_Inp[1] = TPoint(5,Height*2/(CountIn+1));
    m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
    m_selIn[0] = false;
    m_selIn[1] = false;
    m_selOut[0] = false;
    m_type = t_sumblk;
    m_blk_type = b_sumblk;
    m_have_in = true;
    m_have_out = true;
    m_flag = false;
}
//---------------------------------------------------------------------------

void __fastcall TSumBlock::Paint()
{
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
    Canvas->Rectangle(7,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
	if(m_rot)
	{
        Canvas->MoveTo(Width-6,4); Canvas->LineTo(Width,4);
        Canvas->MoveTo(Width-4,1); Canvas->LineTo(Width-4,8);
        Canvas->MoveTo(Width-6,Height-5); Canvas->LineTo(Width,Height-5);
        if(m_flag) {Canvas->MoveTo(Width-4,Height-8); Canvas->LineTo(Width-4,Height-1);}
	}
	else
	{
        Canvas->MoveTo(0,4); Canvas->LineTo(6,4);
        Canvas->MoveTo(3,1); Canvas->LineTo(3,8);
        Canvas->MoveTo(0,Height-5); Canvas->LineTo(6,Height-5);
        if(m_flag) {Canvas->MoveTo(3,Height-8); Canvas->LineTo(3,Height-1);}
	}
    Canvas->Ellipse(8,1,Width-8,Height-1);
    Canvas->MoveTo(Width-17,8);
    Canvas->LineTo(17,8);
    Canvas->LineTo(Width/2,Height/2);
    Canvas->LineTo(17, Height-8);
    Canvas->LineTo(Width-17,Height-8);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(7,0,Width-7,Height));
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Inp[0],m_selIn[0]);
    DrawInOut(m_Inp[1],m_selIn[1]);
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
}
//---------------------------------------------------------------------------

void __fastcall TSumBlock::m_Nastr()
{
	m_flag  = !m_flag; //  
    Invalidate();
}
//---------------------------------------------------------------------------
//=============  ================================================

__fastcall TMulBlock::TMulBlock(TForm* ParentForm)
        : TBlock(ParentForm)
{
	SetBounds(0,0,35,40);
    CountIn = 2;
    CountOut = 1;
    m_Inp[0] = TPoint(5,Height/(CountIn+1));
    m_Inp[1] = TPoint(5,Height*2/(CountIn+1));
    m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
    m_selIn[0] = false;
    m_selIn[1] = false;
    m_selOut[0] = false;
    m_type = t_mulblk;
    m_blk_type = b_mulblk;
    m_have_in = true;
    m_have_out = true;
}
//---------------------------------------------------------------------------

void __fastcall TMulBlock::Paint()
{
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
    Canvas->Rectangle(7,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->MoveTo(Width/3,Height/3);
    Canvas->LineTo(Width*2/3,Height*2/3);
    Canvas->MoveTo(Width*2/3,Height/3);
    Canvas->LineTo(Width/3,Height*2/3);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(7,0,Width-7,Height));
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Inp[0],m_selIn[0]);
    DrawInOut(m_Inp[1],m_selIn[1]);
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------
//=============  =========================================================

__fastcall TACPBlk::TACPBlk(TForm* ParentForm)
        : TBlock(ParentForm)
{
    CountIn = 0;
    CountOut = 1;
    m_selOut[0] = false;
    m_have_in = false;
    m_have_out = true;
    ch = 0;
	Height = 1.5 * Canvas->TextHeight("1");
	SetText();
	m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
	m_type = t_acp;
}
//---------------------------------------------------------------------------

void __fastcall TACPBlk::Paint()
{
	SetText();
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
	Canvas->Rectangle(0,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
    SetTextAlign(Canvas->Handle,TA_TOP|TA_CENTER);
    Canvas->TextOut(Width/2 - 7,(Height - Canvas->TextHeight("1"))/2,str[0]);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(0,0,Width-7,Height));
}
//---------------------------------------------------------------------------

void __fastcall TACPBlk::m_Nastr()
{
	ComboDlg = new TComboDlg(this);
    ComboDlg->ComboBox1->Items->Clear();
    for(int channel=0; channel<16; channel++)
    	ComboDlg->ComboBox1->Items->Add(((TMainForm*)MainForm)->m_labels[0][channel]);
    ComboDlg->Label1->Caption = "";	ComboDlg->ComboBox1->ItemIndex = ch;
    if(ComboDlg->ShowModal() == mrOk)
		ch = ComboDlg->ComboBox1->ItemIndex;
    delete ComboDlg;
	SetText();
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TACPBlk::SetText()
{
    str[0] = ((TMainForm*)MainForm)->m_labels[0][ch];
	Width = Canvas->TextWidth(str[0]) + 30;
    UpdateInOut();
}
//---------------------------------------------------------------------------
//=============  =========================================================

__fastcall TCAPBlk::TCAPBlk(TForm* ParentForm)
        : TBlock(ParentForm)
{
    CountIn = 1;
    CountOut = 0;
    m_selIn[0] = false;
    m_have_in = true;
    m_have_out = false;
    ch = 0;
	Height = 1.5 * Canvas->TextHeight("1");
	SetText();
	m_Inp[0] = TPoint(5,Height/(CountIn+1));
	m_type = t_cap;
}
//---------------------------------------------------------------------------

void __fastcall TCAPBlk::Paint()
{
	SetText();
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
	Canvas->Rectangle(7,0,Width,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Inp[0],m_selIn[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
    SetTextAlign(Canvas->Handle,TA_TOP|TA_CENTER);
    Canvas->TextOut(Width/2 + 7,(Height - Canvas->TextHeight("1"))/2,str[0]);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(7,0,Width,Height));
}
//---------------------------------------------------------------------------

void __fastcall TCAPBlk::m_Nastr()
{
	ComboDlg = new TComboDlg(this);
    ComboDlg->ComboBox1->Items->Clear();
    for(int channel=0; channel<(((TMainForm*)MainForm)->m_col_can_CAP); channel++)
    	ComboDlg->ComboBox1->Items->Add(((TMainForm*)MainForm)->m_labels[1][channel]);
    ComboDlg->Label1->Caption = "";	ComboDlg->ComboBox1->ItemIndex = ch;
    if(ComboDlg->ShowModal() == mrOk)
		ch = ComboDlg->ComboBox1->ItemIndex;
    delete ComboDlg;
	SetText();
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TCAPBlk::SetText()
{
    str[0] = ((TMainForm*)MainForm)->m_labels[1][ch];
	Width = Canvas->TextWidth(str[0]) + 30;
    UpdateInOut();
}
//---------------------------------------------------------------------------
//=============  - =============================================
//---------------------------------------------------------------------------

__fastcall TZiBlk::TZiBlk(TForm* ParentForm, TImageList* imgs, int img_index)
        : TBlock(ParentForm)
{
	m_imgs = imgs;
	m_img_index = img_index;
    CountIn = 1;
    CountOut = 1;
    m_selIn[0] = false;
    m_selOut[0] = false;
    m_have_in = true;
    m_have_out = true;
	m_type = t_ziblk;
	Height = 34;
    Width = 50;
	m_Inp[0] = TPoint(5,Height/(CountIn+1));
	m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
}
//---------------------------------------------------------------------------
void __fastcall TZiBlk::Paint()
{
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
	Canvas->Rectangle(7,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Inp[0],m_selIn[0]);
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
	m_imgs->Draw(Canvas,(Width-30)/2,(Height-30)/2,m_img_index,true);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(7,0,Width-7,Height));
}
//---------------------------------------------------------------------------

void __fastcall TZiBlk::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "T";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,2);
    InputPar->Label2->Visible = false;	InputPar->Edit2->Visible = false;
    InputPar->Label3->Visible = false;	InputPar->Edit3->Visible = false;
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
    }
    delete InputPar;
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------
//=============  =================================================
//---------------------------------------------------------------------------

__fastcall TOgrBlk::TOgrBlk(TForm* ParentForm, TImageList* imgs, int img_index)
        : TBlock(ParentForm)
{
	m_imgs = imgs;
	m_img_index = img_index;
    CountIn = 1;
    CountOut = 1;
    m_selIn[0] = false;
    m_selOut[0] = false;
    m_have_in = true;
    m_have_out = true;
	m_type = t_ogrblk;
	Height = 34;
    Width = 50;
	m_Inp[0] = TPoint(5,Height/(CountIn+1));
	m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
}
//---------------------------------------------------------------------------
void __fastcall TOgrBlk::Paint()
{
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
	Canvas->Rectangle(7,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Inp[0],m_selIn[0]);
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
	m_imgs->Draw(Canvas,(Width-30)/2,(Height-30)/2,m_img_index,true);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(7,0,Width-7,Height));
}
//---------------------------------------------------------------------------

void __fastcall TOgrBlk::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "Um";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,2);
    InputPar->Label2->Visible = false;	InputPar->Edit2->Visible = false;
    InputPar->Label3->Visible = false;	InputPar->Edit3->Visible = false;
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
    }
    delete InputPar;
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------

