//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "calc.h"
#include "Main.h"
//---------------------------------------------------------------------------
#pragma package(smart_init)
bool TestExpr(AnsiString& expr)
{
    double coord[2][16];
    int i,cnt;
    double num;
    while((i=expr.Pos(' '))!=0) expr.Delete(i,1);
    while((i=expr.Pos(','))!=0) expr[i]='.';
    for(i=1,cnt=0; i<=expr.Length(); i++)
    {
        if(expr[i] == '(') cnt++;
        if(expr[i] == ')') cnt--;
    }
    if(cnt != 0) expr = "skobki";//return false; // 
//    else
//    {
//        if((i=expr.Pos('('))!=0) expr=GetSubExpr(expr,i);
//    }

    if(calculate(expr,num,((TMainForm*)MainForm)->m_labels,0xffff,coord));
    expr = FloatToStr(num);
    return true;
}
//---------------------------------------------------------------------------
bool GetCoord(AnsiString& expr, int& index, int& coord, bool& flag,
                AnsiString labels[2][16], short coords_mask)
{
    if(index > expr.Length()) return false;
    int i, j;
    for(i=0,j=0; i<16; i++)
    {
        if((coords_mask>>i)&1)
        {
            if((index+labels[0][i].Length()) > expr.Length()) continue;
            if(expr.SubString(index,labels[0][i].Length()) == labels[0][i])
            {
                coord = j;
                index += labels[0][i].Length();
                flag = true;
                return true;
            }
            j++;
        }
    }
    flag = false;
    return true;
}
//---------------------------------------------------------------------------
bool GetNum(AnsiString& expr, int& index, double& num, bool& flag)
{
    if(index > expr.Length()) return false;
    int i;
    AnsiString tmp = "";
    if(expr[index]=='-')
    {
        tmp += '-';
        index++;
    }
    for(i=index; i<=expr.Length(); i++)
    {
        if(expr.IsDelimiter("0123456789.,",i)) tmp += expr[i];
        else break;
    }
    if(tmp!="")
    {
        num = atof(tmp.c_str());
        index += tmp.Length();
        flag = true;
    }
    else flag = false;
    return true;
}
//---------------------------------------------------------------------------
AnsiString GetSubExpr(AnsiString& expr, int& index)
{
    int i, j, cnt;
    int beg = index+1;
    for(i=beg,cnt=1,j=0; i<=expr.Length(),cnt!=0; i++,j++)
    {
        if(expr[i] == '(') cnt++;
        if(expr[i] == ')') cnt--;
    }
    index = beg+j;
    return expr.SubString(beg,j-1);
}
//---------------------------------------------------------------------------
bool calculate(AnsiString& expr, double& result, AnsiString labels[2][16],
                short coords_mask, double coord[2][16])
{
    int cnt1,cnt2;
    double num1,num2;
    cnt1 = 1;
    if(GetNext(expr,num1,cnt1,labels,coords_mask,coord))
    {
        cnt2 = cnt1+1;
        while(GetNext(expr,num2,cnt2,labels,coords_mask,coord))
        {
            if(cnt2<=expr.Length())
            {
                if(((expr[cnt1]=='+')||(expr[cnt1]=='-'))&&((expr[cnt2]=='*')||(expr[cnt2]=='/')))
                {
                    int i,j;
                    for(i=cnt1+1,j=0; i<=expr.Length(); i++,j++)
                        if((expr[i]=='+')||(expr[i]=='-')) break;
                    if(calculate(expr.SubString(cnt1+1,j),num2,labels,coords_mask,coord))
                        cnt2 = i;
                    else return false;
                }
            }
            switch(expr[cnt1])
            {
                case '+': num1 += num2; break;
                case '-': num1 -= num2; break;
                case '*': num1 *= num2; break;
                case '/': num1 /= num2; break;
                default: return false;
            }
            cnt1 = cnt2;
            cnt2++;
        }
    }
    else return false;
    result = num1;
    return true;
}
//---------------------------------------------------------------------------
bool GetNext(AnsiString& expr, double& result, int& cnt, AnsiString labels[2][16],
                short coords_mask, double coord[2][16])
{
    int i;
    bool flag;
    double num;
    if(GetNum(expr,cnt,num,flag))
        if(flag)
        {
            result = num;
            return true;
        }
    if(GetCoord(expr,cnt,i,flag,labels,coords_mask))
        if(flag)
        {
            result = coord[0][i];
            return true;
        }
    if(cnt <= expr.Length())
    {
        if(expr[cnt] == '(')
        {
            AnsiString SubExpr = GetSubExpr(expr,cnt);
            return calculate(SubExpr,result,labels,coords_mask,coord);
        }
    }
    return false;
}
//---------------------------------------------------------------------------

