//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "dynblks.h"
#include <algorithm>

#pragma package(smart_init)
//---------------------------------------------------------------------------

__fastcall TDynBlk::TDynBlk(TForm* ParentForm)
        : TBlock(ParentForm)
{
    CountIn = 1;
    CountOut = 1;
    m_selIn[0] = false;
    m_selOut[0] = false;
    m_have_in = true;
    m_have_out = true;
	SetText();
	Height = 2.5 * Canvas->TextHeight("1");
	m_Inp[0] = TPoint(5,Height/(CountIn+1));
	m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
	m_type = t_dynblk;
    m_arg[2] = 0;
    m_NastrCaption[0] = "  K";
    m_NastrCaption[1] = "  T";
    m_NastrCaption[2] = " ";
}
//---------------------------------------------------------------------------

void __fastcall TDynBlk::Paint()
{
    SetText();
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
	Canvas->Rectangle(7,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Inp[0],m_selIn[0]);
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
	if(str[1] != "")
    {
	    SetTextAlign(Canvas->Handle,TA_BOTTOM|TA_CENTER);
    	Canvas->TextOut(Width/2,Height/2,str[0]);
	    SetTextAlign(Canvas->Handle,TA_TOP|TA_CENTER);
    	Canvas->TextOut(Width/2,Height/2,str[1]);
        Canvas->MoveTo(12,Height/2);
        Canvas->LineTo(Width-12,Height/2);
    }
    else
    {
	    SetTextAlign(Canvas->Handle,TA_TOP|TA_CENTER);
    	Canvas->TextOut(Width/2,(Height - Canvas->TextHeight("1"))/2,str[0]);
    }
    if(m_sel) InvertRect(Canvas->Handle,&TRect(7,0,Width-7,Height));
}
//---------------------------------------------------------------------------
/*
void __fastcall TDynBlk::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "K";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,4);
    InputPar->Label2->Caption = "T";	InputPar->Edit2->Text = FloatToStrF(m_arg[1],ffFixed,10,4);
    InputPar->Label3->Caption = "NU";	InputPar->Edit3->Text = FloatToStrF(m_arg[2],ffFixed,10,4);
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
		m_arg[1] = myStrToFloat(InputPar->Edit2->Text);
		m_arg[2] = myStrToFloat(InputPar->Edit3->Text);
    }
    delete InputPar;
	SetText();
    Invalidate();
    Parent->Invalidate();
}*/
//---------------------------------------------------------------------------

void __fastcall TDynBlk::SetText()
{
	Width = max(Canvas->TextWidth(str[0]),Canvas->TextWidth(str[1])) + 30;
    UpdateInOut();
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TIntegr::TIntegr(TForm* ParentForm)
        : TDynBlk(ParentForm)
{
    m_blk_type = b_integr;
	Hint = "";
    m_NastrCaption[0] = "  T";
    m_NastrCaption[1] = " ";
    m_NastrCaption[2] = "";
}
//---------------------------------------------------------------------------
/*
void __fastcall TIntegr::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "T";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,4);
    InputPar->Label2->Caption = "NU";	InputPar->Edit2->Text = FloatToStrF(m_arg[2],ffFixed,10,4);
    InputPar->Label3->Visible = false;	InputPar->Edit3->Visible = false;
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
		m_arg[2] = myStrToFloat(InputPar->Edit2->Text);
//		m_arg[2] = myStrToFloat(InputPar->Edit3->Text);
    }
    delete InputPar;
	SetText();
    Invalidate();
    Parent->Invalidate();
} */
//---------------------------------------------------------------------------

void __fastcall TIntegr::SetText()
{
	str[0] = "1";//FloatToStrF(m_arg[0],ffFixed,10,4);
	str[1] = FloatToStrF(m_arg[0],ffFixed,10,4) + "p";
    TDynBlk::SetText();
}
//---------------------------------------------------------------------------

__fastcall TAperiod::TAperiod(TForm* ParentForm)
        : TDynBlk(ParentForm)
{
    m_blk_type = b_aperiod;
	Hint = " ";
}
//---------------------------------------------------------------------------

void __fastcall TAperiod::SetText()
{
	str[0] = FloatToStrF(m_arg[0],ffFixed,10,4);
	str[1] = "1 + " + FloatToStrF(m_arg[1],ffFixed,10,4) + "p";
    TDynBlk::SetText();
}
//---------------------------------------------------------------------------

__fastcall TPIReg::TPIReg(TForm* ParentForm)
        : TDynBlk(ParentForm)
{
    m_blk_type = b_pireg;
	Hint = "-";
}
//---------------------------------------------------------------------------

void __fastcall TPIReg::SetText()
{
	str[0] = "1 + " + FloatToStrF(m_arg[0]*m_arg[1],ffFixed,10,4) + "p";
	str[1] = FloatToStrF(m_arg[1],ffFixed,10,4) + "p";
    TDynBlk::SetText();
}
//---------------------------------------------------------------------------

__fastcall TProporc::TProporc(TForm* ParentForm)
        : TDynBlk(ParentForm)
{
	m_type = t_proporc;
    m_blk_type = b_proporc;
	Hint = " ";
    m_NastrCaption[0] = "  K";
    m_NastrCaption[1] = "";
    m_NastrCaption[2] = "";
}
//---------------------------------------------------------------------------
/*
void __fastcall TProporc::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "K";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,4);
    InputPar->Label2->Visible = false;	InputPar->Edit2->Visible = false;
    InputPar->Label3->Visible = false;	InputPar->Edit3->Visible = false;
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
    }
    delete InputPar;
	SetText();
    Invalidate();
    Parent->Invalidate();
} */
//---------------------------------------------------------------------------

void __fastcall TProporc::SetText()
{
	str[0] = FloatToStrF(m_arg[0],ffFixed,10,4);
	str[1] = "";
    TDynBlk::SetText();
}
//---------------------------------------------------------------------------

