//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "generat.h"
#include "misc.h"
#include <algorithm>

#pragma package(smart_init)
//------------ Generator --------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGenerator::TGenerator(TForm* ParentForm, TImageList* imgs, int img_index)
        : TBlock(ParentForm)
{
	m_imgs = imgs;
	m_img_index = img_index;
    CountIn = 0;
    CountOut = 1;
    m_selOut[0] = false;
    m_have_in = false;
    m_have_out = true;
	m_type = t_generator;
    SetText();
	Height = 34;
	m_Outp[0] = TPoint(Width-1,Height/(CountOut+1));
}
//---------------------------------------------------------------------------

void __fastcall TGenerator::Paint()
{
    SetText();
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
	Canvas->Rectangle(0,0,Width-7,Height);
    Canvas->Pen->Color = clBlue;
    Canvas->Brush->Color = clBlue;
    DrawInOut(m_Outp[0],m_selOut[0]);
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
    SetTextAlign(Canvas->Handle,TA_BOTTOM|TA_LEFT);
    Canvas->TextOut(5,Height/2,str[0]);
    SetTextAlign(Canvas->Handle,TA_TOP|TA_LEFT);
    Canvas->TextOut(5,Height/2,str[1]);
	m_imgs->Draw(Canvas,Width-37-(Height-30)/2,(Height-30)/2,m_img_index,true);
    if(m_sel) InvertRect(Canvas->Handle,&TRect(0,0,Width-7,Height));
}
//---------------------------------------------------------------------------

void __fastcall TGenerator::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "Um";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,2);
    InputPar->Label2->Caption = "T";	InputPar->Edit2->Text = FloatToStrF(m_arg[1],ffFixed,10,2);
    InputPar->Label3->Visible = false;	InputPar->Edit3->Visible = false;
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
		m_arg[1] = myStrToFloat(InputPar->Edit2->Text);
    }
    delete InputPar;
	SetText();
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGenerator::SetText()
{
	Width = max(Canvas->TextWidth(str[0]),Canvas->TextWidth(str[1])) + 50;
    UpdateInOut();
}
//---------------------------------------------------------------------------

//---------------------------------------------------------------------------
//------------ TGStep -------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGStep::TGStep(TForm* ParentForm, TImageList* imgs, int img_index)
        : TGenerator(ParentForm, imgs, img_index)
{
    m_blk_type = b_gstep;
}
//---------------------------------------------------------------------------

void __fastcall TGStep::SetText()
{
	str[0] = "Um = " + FloatToStrF(m_arg[0],ffFixed,10,2);
	str[1] = "T = " + FloatToStrF(m_arg[1],ffFixed,10,2);
	TGenerator::SetText();
}
//---------------------------------------------------------------------------
//------------ TGLine -------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGLine::TGLine(TForm* ParentForm, TImageList* imgs, int img_index)
        : TGenerator(ParentForm, imgs, img_index)
{
    m_blk_type = b_gline;
}
//---------------------------------------------------------------------------

void __fastcall TGLine::m_Nastr()
{
	InputPar = new TInputPar(this);
    InputPar->Label1->Caption = "K";	InputPar->Edit1->Text = FloatToStrF(m_arg[0],ffFixed,10,2);
    InputPar->Label2->Caption = "T";	InputPar->Edit2->Text = FloatToStrF(m_arg[1],ffFixed,10,2);
    InputPar->Label3->Visible = false;	InputPar->Edit3->Visible = false;
    if(InputPar->ShowModal() == mrOk)
    {
		m_arg[0] = myStrToFloat(InputPar->Edit1->Text);
		m_arg[1] = myStrToFloat(InputPar->Edit2->Text);
    }
    delete InputPar;
	SetText();
    Invalidate();
    Parent->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGLine::SetText()
{
	str[0] = "K = " + FloatToStrF(m_arg[0],ffFixed,10,2);
	str[1] = "T = " + FloatToStrF(m_arg[1],ffFixed,10,2);
	TGenerator::SetText();
}
//---------------------------------------------------------------------------
//------------ TGImp --------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGImp::TGImp(TForm* ParentForm, TImageList* imgs, int img_index)
        : TGenerator(ParentForm, imgs, img_index)
{
    m_blk_type = b_gimp;
}
//---------------------------------------------------------------------------

void __fastcall TGImp::SetText()
{
	str[0] = "Um = " + FloatToStrF(m_arg[0],ffFixed,10,2);
	str[1] = "T = " + FloatToStrF(m_arg[1],ffFixed,10,2);
	TGenerator::SetText();
}
//---------------------------------------------------------------------------
//------------ TGSinT -------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGSinT::TGSinT(TForm* ParentForm, TImageList* imgs, int img_index)
        : TGenerator(ParentForm, imgs, img_index)
{
    m_blk_type = b_gsint;
}
//---------------------------------------------------------------------------

void __fastcall TGSinT::SetText()
{
	str[0] = "Um = " + FloatToStrF(m_arg[0],ffFixed,10,2);
	str[1] = "T = " + FloatToStrF(m_arg[1],ffFixed,10,2);
	TGenerator::SetText();
}
//---------------------------------------------------------------------------
//------------ TGCosT -------------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGCosT::TGCosT(TForm* ParentForm, TImageList* imgs, int img_index)
        : TGenerator(ParentForm, imgs, img_index)
{
    m_blk_type = b_gcost;
}
//---------------------------------------------------------------------------

void __fastcall TGCosT::SetText()
{
	str[0] = "Um = " + FloatToStrF(m_arg[0],ffFixed,10,2);
	str[1] = "T = " + FloatToStrF(m_arg[1],ffFixed,10,2);
	TGenerator::SetText();
}
//---------------------------------------------------------------------------
//------------ TGMeandr -----------------------------------------------------
//---------------------------------------------------------------------------

__fastcall TGMeandr::TGMeandr(TForm* ParentForm, TImageList* imgs, int img_index)
        : TGenerator(ParentForm, imgs, img_index)
{
    m_blk_type = b_gmeandr;
}
//---------------------------------------------------------------------------

void __fastcall TGMeandr::SetText()
{
	str[0] = "Um = " + FloatToStrF(m_arg[0],ffFixed,10,2);
	str[1] = "T = " + FloatToStrF(m_arg[1],ffFixed,10,2);
	TGenerator::SetText();
}
//---------------------------------------------------------------------------

