//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "misc.h"
#include "gr_nastr.h"
#include "calc.h"
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TGrDlg *GrDlg;
//---------------------------------------------------------------------------
__fastcall TGrDlg::TGrDlg(TComponent* Owner)
	: TForm(Owner)
{
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::GetCoordsToShow(unsigned short coords_to_show[2])
{
    int i;
 	coords_to_show[0] = 0;
    for(i=0; i<(GroupBox2->ControlCount); i++)
    	if(((TCheckBox*)GroupBox2->Controls[i])->Checked) coords_to_show[0] |= (short)(1<<i);
    for(i=0; i<(GroupBox4->ControlCount); i++)
    	if(((TCheckBox*)GroupBox4->Controls[i])->Checked) coords_to_show[0] |= (short)(1<<(i+8));
 	coords_to_show[1] = 0;
    for(i=0; i<(GroupBox6->ControlCount); i++)
    	if(((TCheckBox*)GroupBox6->Controls[i])->Checked) coords_to_show[1] |= (short)(1<<i);
    for(i=0; i<(GroupBox8->ControlCount); i++)
    	if(((TCheckBox*)GroupBox8->Controls[i])->Checked) coords_to_show[1] |= (short)(1<<(i+8));
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetCoordsToShow(unsigned short coords_to_show[2])
{
    int i;
    for(i=0; i<(GroupBox2->ControlCount); i++)
    	((TCheckBox*)GroupBox2->Controls[i])->Checked = (coords_to_show[0]>>i)&1;
    for(i=0; i<(GroupBox4->ControlCount); i++)
    	((TCheckBox*)GroupBox4->Controls[i])->Checked = (coords_to_show[0]>>(i+8))&1;
    for(i=0; i<(GroupBox6->ControlCount); i++)
    	((TCheckBox*)GroupBox6->Controls[i])->Checked = (coords_to_show[1]>>i)&1;
    for(i=0; i<(GroupBox8->ControlCount); i++)
    	((TCheckBox*)GroupBox8->Controls[i])->Checked = (coords_to_show[1]>>(i+8))&1;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetCoordsMask(unsigned short coords_mask[2])
{
    int i;
    for(i=0; i<(GroupBox2->ControlCount); i++)
    	GroupBox2->Controls[i]->Enabled = (coords_mask[0]>>i)&1;
    for(i=0; i<(GroupBox4->ControlCount); i++)
    	GroupBox4->Controls[i]->Enabled = (coords_mask[0]>>(i+8))&1;
    for(i=0; i<(GroupBox6->ControlCount); i++)
    	GroupBox6->Controls[i]->Enabled = (coords_mask[1]>>i)&1;
    for(i=0; i<(GroupBox8->ControlCount); i++)
    	GroupBox8->Controls[i]->Enabled = (coords_mask[1]>>(i+8))&1;
    for(i=0; i<2; i++) orig_coords_mask[i] = coords_mask[i];
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::GetFuncs(int Funcs[8][3])
{
    int i;
  	for(i=0; i<(GroupBox10->ControlCount); i++)
    	Funcs[i][2] = ((TComboBox*)GroupBox10->Controls[i])->ItemIndex;
  	for(i=0; i<(GroupBox11->ControlCount); i++)
    	Funcs[i][1] = ((TComboBox*)GroupBox11->Controls[i])->ItemIndex;
  	for(i=0; i<(GroupBox12->ControlCount); i++)
    	Funcs[i][0] = ((TCheckBox*)GroupBox12->Controls[i])->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetFuncs(int Funcs[8][3])
{
    int i;
  	for(i=0; i<(GroupBox10->ControlCount); i++)
    	((TComboBox*)GroupBox10->Controls[i])->ItemIndex = Funcs[i][2];
  	for(i=0; i<(GroupBox11->ControlCount); i++)
    	((TComboBox*)GroupBox11->Controls[i])->ItemIndex = Funcs[i][1];
  	for(i=0; i<(GroupBox12->ControlCount); i++)
    	((TCheckBox*)GroupBox12->Controls[i])->Checked = Funcs[i][0];
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::ShapeMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
    ColorDialog1->Color = ((TShape*)Sender)->Brush->Color;
	ColorDialog1->Execute();
	((TShape*)Sender)->Brush->Color = ColorDialog1->Color;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::GetColors(COLORREF m_color[2][16], COLORREF m_funcs_color[8], COLORREF m_dop_color[4])
{
    int i;
    for(i=0; i<(GroupBox1->ControlCount); i++)
    	m_color[0][i] 	 = ((TShape*)GroupBox1->Controls[i])->Brush->Color;
    for(i=0; i<(GroupBox3->ControlCount); i++)
    	m_color[0][i+8]  = ((TShape*)GroupBox3->Controls[i])->Brush->Color;
    for(i=0; i<(GroupBox5->ControlCount); i++)
    	m_color[1][i] 	 = ((TShape*)GroupBox5->Controls[i])->Brush->Color;
    for(i=0; i<(GroupBox7->ControlCount); i++)
    	m_color[1][i+8]  = ((TShape*)GroupBox7->Controls[i])->Brush->Color;
    for(i=0; i<(GroupBox9->ControlCount); i++)
    	m_funcs_color[i] = ((TShape*)GroupBox9->Controls[i])->Brush->Color;
        m_dop_color[0] = DopShape1->Brush->Color;
        m_dop_color[1] = DopShape2->Brush->Color;
        m_dop_color[2] = DopShape3->Brush->Color;
        m_dop_color[3] = DopShape4->Brush->Color;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetColors(COLORREF m_color[2][16], COLORREF m_funcs_color[8], COLORREF m_dop_color[4])
{
    int i;
    for(i=0; i<(GroupBox1->ControlCount); i++)
    	((TShape*)GroupBox1->Controls[i])->Brush->Color = (TColor)m_color[0][i];
    for(i=0; i<(GroupBox3->ControlCount); i++)
    	((TShape*)GroupBox3->Controls[i])->Brush->Color = (TColor)m_color[0][i+8];
    for(i=0; i<(GroupBox5->ControlCount); i++)
    	((TShape*)GroupBox5->Controls[i])->Brush->Color = (TColor)m_color[1][i];
    for(i=0; i<(GroupBox7->ControlCount); i++)
    	((TShape*)GroupBox7->Controls[i])->Brush->Color = (TColor)m_color[1][i+8];
    for(i=0; i<(GroupBox9->ControlCount); i++)
    	((TShape*)GroupBox9->Controls[i])->Brush->Color = (TColor)m_funcs_color[i];
        DopShape1->Brush->Color = (TColor)m_dop_color[0];
        DopShape2->Brush->Color = (TColor)m_dop_color[1];
        DopShape3->Brush->Color = (TColor)m_dop_color[2];
        DopShape4->Brush->Color = (TColor)m_dop_color[3];
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetCaptions(AnsiString m_labels[2][16], unsigned short coords_mask[2])
{
    int i, channel;
    for(i=0; i<(GroupBox2->ControlCount); i++)
    	((TCheckBox*)GroupBox2->Controls[i])->Caption = m_labels[0][i];
    for(i=0; i<(GroupBox4->ControlCount); i++)
    	((TCheckBox*)GroupBox4->Controls[i])->Caption = m_labels[0][i+8];
    for(i=0; i<(GroupBox6->ControlCount); i++)
    	((TCheckBox*)GroupBox6->Controls[i])->Caption = m_labels[1][i];
    for(i=0; i<(GroupBox8->ControlCount); i++)
    	((TCheckBox*)GroupBox8->Controls[i])->Caption = m_labels[1][i+8];

    TStringList* strs = new TStringList();
    strs->Clear();
    for(i=0; i<2; i++)
    	for(channel=0; channel<16; channel++)
        	if ((coords_mask[i]>>channel)&1) strs->Add(m_labels[i][channel]);
  	for(i=0; i<(GroupBox10->ControlCount); i++)
    	((TComboBox*)GroupBox10->Controls[i])->Items->Assign(strs);
  	for(i=0; i<(GroupBox11->ControlCount); i++)
    	((TComboBox*)GroupBox11->Controls[i])->Items->Assign(strs);
    delete strs;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetMaxMin(double Xmax, double Ymax, double Xmin, double Ymin)
{
	EXmin->Text = FloatToStrF(Xmin,ffFixed,10,2);
	EXmax->Text = FloatToStrF(Xmax,ffFixed,10,2);
	EYmin->Text = FloatToStrF(Ymin,ffFixed,10,2);
	EYmax->Text = FloatToStrF(Ymax,ffFixed,10,2);
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SpeedButton1Click(TObject *Sender)
{
    SetMaxMin(1.2,1.2,-1.2,-1.2);
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SpeedButton2Click(TObject *Sender)
{
    SetMaxMin(1.2,1.2,0,-1.2);
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SpeedButton3Click(TObject *Sender)
{
    SetMaxMin(1.2,1.2,0,0);
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::GetOsi(double &Xmin, double &Xmax, double &Ymin, double &Ymax,
    							double &tmin, double &tmax, TPoint &col_del)
{
	Xmin = myStrToFloat(EXmin->Text);		Xmax = myStrToFloat(EXmax->Text);
	Ymin = myStrToFloat(EYmin->Text);		Ymax = myStrToFloat(EYmax->Text);
	tmin = myStrToFloat(Etmin->Text);		tmax = myStrToFloat(Etmax->Text);
    col_del.x = UpDownX->Position;		col_del.y = UpDownY->Position;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetOsi(double &Xmin, double &Xmax, double &Ymin, double &Ymax,
    							double &tmin, double &tmax, TPoint &col_del, bool m_static)
{
	GroupBox15->Visible = !m_static;
	EXmin->Text = FloatToStrF(Xmin,ffFixed,10,2); 	EXmax->Text = FloatToStrF(Xmax,ffFixed,10,2);
	EYmin->Text = FloatToStrF(Ymin,ffFixed,10,2); 	EYmax->Text = FloatToStrF(Ymax,ffFixed,10,2);
	Etmin->Text = FloatToStrF(tmin,ffFixed,10,2); 	Etmax->Text = FloatToStrF(tmax,ffFixed,10,2);
    UpDownX->Position = (short)col_del.x;           UpDownY->Position = (short)col_del.y;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::OpenFileClick(TObject *Sender)
{
	TDateTime m_time;
    TDateTime m_date;
    bool m_static;
    double elp_time;
    short m_coords_mask[2];
    short m_coords_to_show[2];
    int m_funcs[8][3];
    double m_base[2][16];
    double m_real_base[2][16];
    TPoint m_col_del;
    double beg_time;
    double end_time;
   	double m_Y_max;
    double m_Y_min;
    double m_X_max;
	double m_X_min;
    int m_legend_w;
	bool m_legend_pr;
    AnsiString m_labels[2][16];
    AnsiString m_razmern[2][16];
    AnsiString m_file;

	if(OpenDialog->Execute())
    {
		AnsiString str4 = "VisPrivod v1.3 file ";
    	char tmp[200];
	    int i, k, length, count;
		short temp[0xffff];
	    unsigned long j;
    	FILE* data_file = fopen(OpenDialog->FileName.c_str(),"rb");
	    fgets(tmp, str4.Length() + 1, data_file);
    	if(AnsiString(tmp) == str4) //--------------------------------------
	    {
		    for(k=0; k<2; k++)
    		{
	    		for(i=0; i<16; i++)
	    		{
	    	        length = _getw(data_file);
    				fgets(tmp, length + 1, data_file);
        	        m_labels[k][i] = AnsiString(tmp);
    	    	    length = _getw(data_file);
    				fgets(tmp, length + 1, data_file);
	                m_razmern[k][i] = AnsiString(tmp);
			    }
	    	}
	        count = _getw(data_file);
    	    for(i=0; i<count; i++)
        	{
   	        	length = _getw(data_file);
				fgets(tmp, length + 1, data_file);
        	}
	        fread(&m_time, sizeof(TDateTime), 1, data_file);
    	    fread(&m_date, sizeof(TDateTime), 1, data_file);
        	fread(&m_static, sizeof(bool), 1, data_file);
	        fread(&elp_time, sizeof(double), 1, data_file);
    	    fread(m_coords_mask, sizeof(short), 2, data_file);
        	fread(m_coords_to_show, sizeof(short), 2, data_file);
		    fread(m_funcs, sizeof(int), 8*3, data_file);
		    fread(m_base, sizeof(double), 2*16, data_file);
    		fread(m_real_base, sizeof(double), 2*16, data_file);
		    fread(&m_col_del, sizeof(TPoint), 1, data_file);
  		  	fread(&beg_time, sizeof(double), 1, data_file);
	    	fread(&end_time, sizeof(double), 1, data_file);
	    	fread(&m_Y_max, sizeof(double), 1, data_file);
		    fread(&m_Y_min, sizeof(double), 1, data_file);
    		fread(&m_X_max, sizeof(double), 1, data_file);
		    fread(&m_X_min, sizeof(double), 1, data_file);
    		fread(&m_legend_w, sizeof(int), 1, data_file);
	    	fread(&m_legend_pr, sizeof(bool), 1, data_file);

            if((m_coords_mask[0] == orig_coords_mask[0])&&(m_coords_mask[1] == orig_coords_mask[1]))
            {
		        m_file = _tempnam("","Prv");
    	    	FILE* dest_file = fopen(m_file.c_str(),"wb");
	    	    while((j = fread(temp, sizeof(short), 0xffff, data_file)) != 0)
    	    		fwrite(temp, sizeof(short), j, dest_file);
	        	fclose(dest_file);
            }
            else
            {
             	fclose(data_file);
                ShowMessage("");
                return;
            }
	    }
    	else //------------------------------------------------------------------
	    {
    	    fclose(data_file);
    		ShowMessage("   ");
            return;
	    }
//		for(i=0; i<2; i++) m_coords_to_show[i] &= m_coords_mask[i];
	    fclose(data_file);

		if(((TComponent*)Sender)->Name == "SBFile1")
        {
			if(EFile1->Text != "")
            	if(FileExists(m_comp_file[0])) DeleteFile(m_comp_file[0]);
	        EFile1->Text = OpenDialog->FileName;            m_comp_file[0] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile2")
        {
			if(EFile2->Text != "")
            	if(FileExists(m_comp_file[1])) DeleteFile(m_comp_file[1]);
	        EFile2->Text = OpenDialog->FileName;            m_comp_file[1] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile3")
        {
			if(EFile3->Text != "")
            	if(FileExists(m_comp_file[2])) DeleteFile(m_comp_file[2]);
	        EFile3->Text = OpenDialog->FileName;            m_comp_file[2] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile4")
        {
			if(EFile4->Text != "")
            	if(FileExists(m_comp_file[3])) DeleteFile(m_comp_file[3]);
	        EFile4->Text = OpenDialog->FileName;            m_comp_file[3] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile5")
        {
			if(EFile5->Text != "")
            	if(FileExists(m_comp_file[4])) DeleteFile(m_comp_file[4]);
	        EFile5->Text = OpenDialog->FileName;            m_comp_file[4] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile6")
        {
			if(EFile6->Text != "")
            	if(FileExists(m_comp_file[5])) DeleteFile(m_comp_file[5]);
	        EFile6->Text = OpenDialog->FileName;            m_comp_file[5] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile7")
        {
			if(EFile7->Text != "")
            	if(FileExists(m_comp_file[6])) DeleteFile(m_comp_file[6]);
	        EFile7->Text = OpenDialog->FileName;            m_comp_file[6] = m_file;
        }
		else if(((TComponent*)Sender)->Name == "SBFile8")
        {
			if(EFile8->Text != "")
            	if(FileExists(m_comp_file[7])) DeleteFile(m_comp_file[7]);
	        EFile8->Text = OpenDialog->FileName;            m_comp_file[7] = m_file;
        }
    }
    UpdateCompFiles();
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetCompFiles(AnsiString comp_FileName[8], AnsiString comp_file[8], bool show_comp_file[8])
{
	EFile1->Text = comp_FileName[0];
	EFile2->Text = comp_FileName[1];
	EFile3->Text = comp_FileName[2];
	EFile4->Text = comp_FileName[3];
	EFile5->Text = comp_FileName[4];
	EFile6->Text = comp_FileName[5];
	EFile7->Text = comp_FileName[6];
	EFile8->Text = comp_FileName[7];
    CBFile1->Checked = show_comp_file[0];
    CBFile2->Checked = show_comp_file[1];
    CBFile3->Checked = show_comp_file[2];
    CBFile4->Checked = show_comp_file[3];
    CBFile5->Checked = show_comp_file[4];
    CBFile6->Checked = show_comp_file[5];
    CBFile7->Checked = show_comp_file[6];
    CBFile8->Checked = show_comp_file[7];
	for(int i=0; i<8; i++) m_comp_file[i] = comp_file[i];
    UpdateCompFiles();
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::GetCompFiles(AnsiString comp_FileName[8], AnsiString comp_file[8], bool show_comp_file[8])
{
	comp_FileName[0] = EFile1->Text;
	comp_FileName[1] = EFile2->Text;
	comp_FileName[2] = EFile3->Text;
	comp_FileName[3] = EFile4->Text;
	comp_FileName[4] = EFile5->Text;
	comp_FileName[5] = EFile6->Text;
	comp_FileName[6] = EFile7->Text;
	comp_FileName[7] = EFile8->Text;
    show_comp_file[0] = CBFile1->Checked;
    show_comp_file[1] = CBFile2->Checked;
    show_comp_file[2] = CBFile3->Checked;
    show_comp_file[3] = CBFile4->Checked;
    show_comp_file[4] = CBFile5->Checked;
    show_comp_file[5] = CBFile6->Checked;
    show_comp_file[6] = CBFile7->Checked;
    show_comp_file[7] = CBFile8->Checked;
	for(int i=0; i<8; i++) comp_file[i] = m_comp_file[i];
}
//---------------------------------------------------------------------------
void TGrDlg::UpdateCompFiles()
{
	CBFile1->Enabled = (EFile1->Text != "");    EFile1->Enabled = (EFile1->Text != "");
	CBFile2->Enabled = (EFile2->Text != "");    EFile2->Enabled = (EFile2->Text != "");
	CBFile3->Enabled = (EFile3->Text != "");    EFile3->Enabled = (EFile3->Text != "");
	CBFile4->Enabled = (EFile4->Text != "");    EFile4->Enabled = (EFile4->Text != "");
	CBFile5->Enabled = (EFile5->Text != "");    EFile5->Enabled = (EFile5->Text != "");
	CBFile6->Enabled = (EFile6->Text != "");    EFile6->Enabled = (EFile6->Text != "");
	CBFile7->Enabled = (EFile7->Text != "");    EFile7->Enabled = (EFile7->Text != "");
	CBFile8->Enabled = (EFile8->Text != "");    EFile8->Enabled = (EFile8->Text != "");
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::GetDopCoords(AnsiString dopName[4], AnsiString dopExpr[4], bool show_dop_coord[4])
{
	dopName[0] = ExprName1->Text;	dopExpr[0] = Expr1->Text;	show_dop_coord[0] = DopCheckBox1->Checked;
	dopName[1] = ExprName2->Text;	dopExpr[1] = Expr2->Text;	show_dop_coord[1] = DopCheckBox2->Checked;
	dopName[2] = ExprName3->Text;	dopExpr[2] = Expr3->Text;	show_dop_coord[2] = DopCheckBox3->Checked;
	dopName[3] = ExprName4->Text;	dopExpr[3] = Expr4->Text;	show_dop_coord[3] = DopCheckBox4->Checked;
}
//---------------------------------------------------------------------------
void __fastcall TGrDlg::SetDopCoords(AnsiString dopName[4], AnsiString dopExpr[4], bool show_dop_coord[4])
{
	ExprName1->Text = dopName[0];	Expr1->Text = dopExpr[0];	DopCheckBox1->Checked = show_dop_coord[0];
	ExprName2->Text = dopName[1];	Expr2->Text = dopExpr[1];	DopCheckBox2->Checked = show_dop_coord[1];
	ExprName3->Text = dopName[2];	Expr3->Text = dopExpr[2];	DopCheckBox3->Checked = show_dop_coord[2];
	ExprName4->Text = dopName[3];	Expr4->Text = dopExpr[3];	DopCheckBox4->Checked = show_dop_coord[3];
}
//---------------------------------------------------------------------------


