//---------------------------------------------------------------------------
#ifndef graphtplH
#define graphtplH
//---------------------------------------------------------------------------
#include "gr_nastr.h"
#include "tablfrm.h"
#include "dselcrd2.h"
#include "progrdlg.h"
#include <Printers.hpp>
#include <stdio.h>
#include <math.h>
#include <stdlib.h>
#include <io.h>
#include <registry.hpp>
//---------------------------------------------------------------------------
template <class T>
class TGraph
{
private:
    TPoint Old;
    TPoint Beg;
    bool sel_fl;
    bool sel_X;
    int m_col_can[2];
    int col_can;
//	long col_points;
	double col_points;
    bool m_funcs_pr;
    TStringList* m_memo;
    TDateTime m_date;
    TDateTime m_time;
public:
	unsigned short m_coords_mask[2];
    unsigned short m_coords_to_show[2];
    bool m_show_comp_file[8];
    bool m_static;
    bool m_filtered;
    int m_funcs[8][3];
    AnsiString m_file;
	AnsiString m_file_orig;
	AnsiString m_file_filter;
    AnsiString m_comp_file[8];
    AnsiString m_comp_FileName[8];
    AnsiString m_labels[2][16];
    AnsiString m_razmern[2][16];
	AnsiString dopName[4];
    AnsiString dopExpr[4];
    bool show_dop_coord[4];
    TPoint m_col_del;
    int m_col_osi_Y;
    double max_val;
    double elp_time;
    double beg_time;
    double end_time;
    double m_Y_max;
    double m_Y_min;
    double m_X_max;
    double m_X_min;
    double m_base[2][16];
    double m_real_base[2][16];
    COLORREF m_color[2][16];
	COLORREF m_funcs_color[8];
    COLORREF m_dop_color[4];
	__fastcall TGraph()
    {
    	m_memo = new TStringList();
        m_Init();
    }
	__fastcall ~TGraph()
    {
        m_DeleteFiles();
    	delete m_memo;
    }
	AnsiString __fastcall m_BaseVals();
	void __fastcall m_Setka(TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall m_Osi(TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall m_Text(TCanvas* Canvas, TRect clrect, TRect mg);
	void __fastcall m_Labels(TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall m_NullOsi(TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall m_Legend(TCanvas* Canvas, TRect clRect);
	void __fastcall MouseDown(TMouseButton Button, TShiftState Shift, int X, int Y, TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall MouseMove(TShiftState Shift, int X, int Y, TCanvas* Canvas, TRect clRect, TRect mg);
	bool __fastcall MouseUp(TMouseButton Button, TShiftState Shift, int X, int Y, TCanvas* Canvas, TRect clRect, TRect mg);

	void __fastcall m_Graphs(TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall m_Funcs(TCanvas* Canvas, TRect clRect, TRect mg);
	void __fastcall m_DrawData(TCanvas* Canvas, TRect clRect, TRect mg);

    void __fastcall m_ExpSmooth(unsigned short coords_to_filter);
    void __fastcall m_Vipr(unsigned short coords_to_filter);
    void __fastcall m_SrKwad(unsigned short coords_to_filter);
    void __fastcall m_Hanning(unsigned short coords_to_filter);
    void __fastcall m_Sort(unsigned short channel);
    void __fastcall m_SaveFiltered();

    void __fastcall m_MinMax(unsigned short coords_to_filter[2], double& m_min, double& m_max);
	void __fastcall m_GetVisibleCoords(AnsiString os, unsigned short coords_dest[2]);
	void __fastcall m_GetAllVisibleCoords(unsigned short coords_dest[2]);
    void __fastcall m_DeleteFiles();
    void __fastcall m_Init();
    void __fastcall m_NastrDlg();
    void __fastcall m_Draw(TCanvas* Canvas, TPoint legend_wh, TPoint graphs_wh,
    	TPoint base_wh, TPoint captn_wh, TRect mg, TRect gr_mg);
    void __fastcall LoadFromFile(AnsiString FileName);
    void __fastcall SaveToFile(AnsiString FileName);
    void __fastcall ShowTabl(TComponent* AOwner);
    void __fastcall UpdateColPoints();
    TForm* m_gridFrm;
};
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_Setka(TCanvas* Canvas, TRect clRect, TRect mg)
{
	HPEN pen2;
    int i;
    HDC mDC = Canvas->Handle;
    if(Printer()->Printing) pen2 = CreatePen(PS_DOT,0,clBlack);
    else pen2 = CreatePen(PS_DOT,0,clLtGray);
    HPEN old_pen = SelectObject(mDC,pen2);
    for(i=1; i<m_col_del.y; i++)
    {
    	MoveToEx(mDC, clRect.Left+mg.Left, clRect.Top+mg.Top+
        	i*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/m_col_del.y, NULL);
    	LineTo(mDC, clRect.Right-mg.Right, clRect.Top+mg.Top+
        	i*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/m_col_del.y);
    }
    for(i=1; i<m_col_del.x; i++)
    {
    	MoveToEx(mDC, clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
        	(mg.Right+mg.Left))/m_col_del.x, clRect.Top+mg.Top,NULL);
        LineTo(mDC, clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
        	(mg.Right+mg.Left))/m_col_del.x, clRect.Bottom-mg.Bottom);
    }
    SelectObject(mDC,old_pen);
    DeleteObject(pen2);
    TPoint pnt[5] = {TPoint(clRect.Left+mg.Left-1, clRect.Top+mg.Top-1),
    				 TPoint(clRect.Right-mg.Right, clRect.Top+mg.Top-1),
                     TPoint(clRect.Right-mg.Right, clRect.Bottom-mg.Bottom),
                     TPoint(clRect.Left+mg.Left-1, clRect.Bottom-mg.Bottom),
                     TPoint(clRect.Left+mg.Left-1, clRect.Top+mg.Top-1)};
	Polyline(mDC, pnt, 5);
}
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_Text(TCanvas* Canvas, TRect clRect, TRect mg)
{
	double num;
    int i;
    AnsiString tmp_str;
    RECT rct;
    SIZE sz;
	HDC mDC = Canvas->Handle;
    SetTextColor(mDC,clBlack);
    SetTextAlign(mDC, TA_LEFT|TA_TOP);
    GetTextExtentPoint32(mDC, "1", 1, &sz);
    int otstup = sz.cy*0.5;
    if(m_coords_to_show[0] || m_coords_to_show[1])
    {
        for(num=beg_time,i=0; i<=m_col_del.x; num+=(end_time-beg_time)/m_col_del.x,i++)
        {
            tmp_str = FloatToStrF(num, ffFixed, 10, 2);
			GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
            rct.left = clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
            	(mg.Left+mg.Right))/m_col_del.x-sz.cx/2;
            rct.right = rct.left+sz.cx;
			rct.top = clRect.Bottom-mg.Bottom+otstup;
            rct.bottom = rct.top+sz.cy;
	        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
            	DT_CENTER|DT_VCENTER|DT_SINGLELINE);
        }
        if(m_funcs_pr)
        {
            for(num=m_X_min,i=0; i<=m_col_del.x; num+=(m_X_max-m_X_min)/m_col_del.x,i++)
            {
                tmp_str = FloatToStrF(num, ffFixed, 10, 2);
				GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
            	rct.left = clRect.Left+mg.Left+i*(clRect.Right-clRect.left-
                	(mg.Left+mg.Right))/m_col_del.x-sz.cx/2;
	            rct.right = rct.left+sz.cx;
        	    rct.bottom = clRect.Top+mg.Top-otstup;
				rct.top = rct.bottom-sz.cy;
		        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
                	DT_CENTER|DT_VCENTER|DT_SINGLELINE);
            }
        }
    }
    else
    {
        for(num=m_X_min,i=0; i<=m_col_del.x; num+=(m_X_max-m_X_min)/m_col_del.x,i++)
        {
            tmp_str = FloatToStrF(num, ffFixed, 10, 2);
			GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
            rct.left = clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
            	(mg.Left+mg.Right))/m_col_del.x-sz.cx/2;
            rct.right = rct.left+sz.cx;
			rct.top = clRect.Bottom-mg.Bottom+otstup;
            rct.bottom = rct.top+sz.cy;
	        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
            	DT_CENTER|DT_VCENTER|DT_SINGLELINE);
        }
    }
    for(num=m_Y_max,i=0; i<=m_col_del.y; num-=(m_Y_max-m_Y_min)/m_col_del.y,i++)
    {
        tmp_str = FloatToStrF(num, ffFixed, 10, 2);
		GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
    	rct.right = clRect.Left+mg.Left-otstup;
        rct.left = rct.right-sz.cx;
		rct.top = clRect.Top+mg.Top+i*(clRect.Bottom-clRect.Top-
        	(mg.Top+mg.Bottom))/m_col_del.y-sz.cy/2;
        rct.bottom = rct.top+sz.cy;
        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
        	DT_RIGHT|DT_VCENTER|DT_SINGLELINE);
    }
}
//---------------------------------------------------------------------------
template <class T>
AnsiString __fastcall TGraph<T>::m_BaseVals()
{
	int i, j;
    bool first = true;
	unsigned short coords[2] = {0,0};
	m_GetVisibleCoords("X", coords);
	m_GetVisibleCoords("Y", coords);
	AnsiString tmp_str = " \n";
	for(j=0; j<2; j++)
	    for(i=0; i<16; i++)
    		if((coords[j]>>i)&1)
	        {
    	    	if(!first) tmp_str += "; ";
        	    if(m_razmern[j][i] != "")
                	tmp_str += m_labels[j][i]+" = "+
                    FloatToStrF(m_real_base[j][i], ffFixed,10,2)+" "+m_razmern[j][i];
                else tmp_str += m_labels[j][i]+" = "+
                    FloatToStrF(m_real_base[j][i], ffFixed,10,2);
            	if(first) first = false;
	        }
	return tmp_str;
}
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_Labels(TCanvas* Canvas, TRect clRect, TRect mg)
{
    AnsiString tmp_str;
    RECT rct;
    SIZE sz;
    HDC mDC = Canvas->Handle;
    SetTextColor(mDC,clBlack);
    SetTextAlign(mDC, TA_LEFT|TA_TOP);
    GetTextExtentPoint32(mDC, "1", 1, &sz);
    int otstup = sz.cy*0.5;
    if(m_coords_to_show[0] || m_coords_to_show[1])
    {
        tmp_str = "t,c";
		GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
        rct.left = clRect.Right-mg.Right-(clRect.Right-clRect.Left-
        	(mg.Left+mg.Right))/(m_col_del.x*2)-sz.cx/2;
    	rct.right = rct.left+sz.cx;
		rct.top = clRect.Bottom-mg.Bottom+otstup;
        rct.bottom = rct.top+sz.cy;
        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
        	DT_CENTER|DT_VCENTER|DT_SINGLELINE);
        if(m_funcs_pr)
        {
  	      	tmp_str = "X,o.e.";
			GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
        	rct.left = clRect.Right-mg.Right-(clRect.Right-
            	clRect.Left-(mg.Left+mg.Right))/(m_col_del.x*2)-sz.cx/2;
	    	rct.right = rct.left+sz.cx;
        	rct.bottom = clRect.Top+mg.Top-otstup;
			rct.top = rct.bottom-sz.cy;
	        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
            	DT_CENTER|DT_VCENTER|DT_SINGLELINE);
        }
    }
    else
    {
        tmp_str = "X,o.e.";
		GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
        rct.left = clRect.Right-mg.Right-(clRect.Right-clRect.Left-
        	(mg.Left+mg.Right))/(m_col_del.x*2)-sz.cx/2;
    	rct.right = rct.left+sz.cx;
		rct.top = clRect.Bottom-mg.Bottom+otstup;
        rct.bottom = rct.top+sz.cy;
        DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
        	DT_CENTER|DT_VCENTER|DT_SINGLELINE);
    }
    tmp_str = "Y,o.e.";
    GetTextExtentPoint32(mDC, tmp_str.c_str(), tmp_str.Length(), &sz);
    rct.right = clRect.Left+mg.Left-otstup;
    rct.left = rct.right-sz.cx;
    rct.top = clRect.Top+mg.Top+(clRect.Bottom-clRect.Top-
    	(mg.Top+mg.Bottom))/(m_col_del.y*2)-sz.cy/2;
    rct.bottom = rct.top+sz.cy;
    DrawText(mDC, tmp_str.c_str(), tmp_str.Length(), &rct,
    	DT_RIGHT|DT_VCENTER|DT_SINGLELINE);
}
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_Osi(TCanvas* Canvas, TRect clRect, TRect mg)
{
	int i, j;
    HPEN pen2;
    HDC mDC = Canvas->Handle;
	pen2 = CreatePen(PS_DOT,2,clBlack);
    HPEN old_pen = SelectObject(mDC,pen2);
    SIZE sz;
    GetTextExtentPoint32(mDC, "1", 1, &sz);
    int tick_h = sz.cy*0.5;
    if(m_coords_to_show[0] || m_coords_to_show[1])
    {
        if(m_funcs_pr)
        {
		    MoveToEx(mDC, clRect.Left+mg.Left, clRect.Top+mg.Top, NULL);
		    LineTo(mDC, clRect.Right-mg.Right, clRect.Top+mg.Top);
		    for(i=0; i<=m_col_del.x; i++)
		    {
		    	MoveToEx(mDC, clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
                	(mg.Left+mg.Right))/m_col_del.x, clRect.Top+mg.Top, NULL);
		        LineTo(mDC, clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
                	(mg.Left+mg.Right))/m_col_del.x, clRect.Top+mg.Top+tick_h);
		    }
		    for(i=0; i<m_col_del.x; i++)
		    {
		    	MoveToEx(mDC, clRect.Left+mg.Left+(i+0.5)*(clRect.Right-clRect.Left-
                	(mg.Left+mg.Right))/m_col_del.x, clRect.Top+mg.Top, NULL);
		        LineTo(mDC, clRect.Left+mg.Left+(i+0.5)*(clRect.Right-clRect.Left-
                	(mg.Left+mg.Right))/m_col_del.x, clRect.Top+mg.Top+tick_h/2);
		    }
        }
    }
    MoveToEx(mDC, clRect.Left+mg.Left, clRect.Bottom-mg.Bottom, NULL);
    LineTo(mDC, clRect.Right-mg.Right, clRect.Bottom-mg.Bottom);
    for(i=0; i<=m_col_del.x; i++)
    {
    	MoveToEx(mDC, clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
        	(mg.Left+mg.Right))/m_col_del.x, clRect.Bottom-mg.Bottom, NULL);
        LineTo(mDC, clRect.Left+mg.Left+i*(clRect.Right-clRect.Left-
        	(mg.Left+mg.Right))/m_col_del.x, clRect.Bottom-mg.Bottom-tick_h);
    }
    for(i=0; i<m_col_del.x; i++)
    {
    	MoveToEx(mDC, clRect.Left+mg.Left+(i+0.5)*(clRect.Right-clRect.Left-
        	(mg.Left+mg.Right))/m_col_del.x, clRect.Bottom-mg.Bottom, NULL);
        LineTo(mDC, clRect.Left+mg.Left+(i+0.5)*(clRect.Right-clRect.Left-
        	(mg.Left+mg.Right))/m_col_del.x, clRect.Bottom-mg.Bottom-tick_h/2);
    }
    for(j=0; j<m_col_osi_Y; j++)
    {
     	MoveToEx(mDC, clRect.Left+mg.Left-j*mg.Left/m_col_osi_Y, clRect.Top+mg.Top, NULL);
        LineTo(mDC, clRect.Left+mg.Left-j*mg.Left/m_col_osi_Y, clRect.Bottom-mg.Bottom);
	    for(i=0; i<=m_col_del.y; i++)
    	{
    		MoveToEx(mDC, clRect.Left+mg.Left-j*mg.Left/m_col_osi_Y,
            	clRect.Top+mg.Top+i*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/m_col_del.y, NULL);
	        LineTo(mDC, clRect.Left+mg.Left-j*mg.Left/m_col_osi_Y+tick_h,
            	clRect.Top+mg.Top+i*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/m_col_del.y);
    	}
	    for(i=0; i<m_col_del.y; i++)
    	{
    		MoveToEx(mDC, clRect.Left+mg.Left-j*mg.Left/m_col_osi_Y,
            	clRect.Top+mg.Top+(i+0.5)*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/m_col_del.y, NULL);
	        LineTo(mDC, clRect.Left+mg.Left-j*mg.Left/m_col_osi_Y+tick_h/2,
            	clRect.Top+mg.Top+(i+0.5)*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/m_col_del.y);
	    }
    }
    SelectObject(mDC,old_pen);
    DeleteObject(pen2);
}
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_NullOsi(TCanvas* Canvas, TRect clRect, TRect mg)
{
	HDC mDC = Canvas->Handle;
    HPEN pen2;
	pen2 = CreatePen(PS_DOT,2,clBlack);
    HPEN old_pen = SelectObject(mDC,pen2);
    if(m_coords_to_show[0] || m_coords_to_show[1])
    {
        if(m_funcs_pr)
        {
			if((m_X_max > 0)&&(m_X_min <0))
    	    {
	    	    MoveToEx(mDC, clRect.Left+mg.Left+m_X_min*(clRect.Right-
                	clRect.Left-(mg.Left+mg.Right))/(m_X_min-m_X_max),
                    clRect.Top+mg.Top, NULL);
         		LineTo(mDC, clRect.Left+mg.Left+m_X_min*(clRect.Right-
                	clRect.Left-(mg.Left+mg.Right))/(m_X_min-m_X_max),
                    clRect.Bottom-mg.Bottom);
	        }
        }
    }
    else
    {
		if((m_X_max > 0)&&(m_X_min <0))
        {
	        MoveToEx(mDC, clRect.Left+mg.Left+m_X_min*(clRect.Right-
                	clRect.Left-(mg.Left+mg.Right))/(m_X_min-m_X_max),
                    clRect.Top+mg.Top, NULL);
         	LineTo(mDC, clRect.Left+mg.Left+m_X_min*(clRect.Right-
                	clRect.Left-(mg.Left+mg.Right))/(m_X_min-m_X_max),
                    clRect.Bottom-mg.Bottom);
        }
    }
	if((m_Y_max > 0)&&(m_Y_min <0))
	{
    	MoveToEx(mDC, clRect.Left+mg.Left, clRect.Top+mg.Top+m_Y_max*
        	(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/(m_Y_max-m_Y_min), NULL);
        LineTo(mDC, clRect.Right-mg.Right, clRect.Top+mg.Top+
        	m_Y_max*(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/(m_Y_max-m_Y_min));
    }
    SelectObject(mDC,old_pen);
    DeleteObject(pen2);
}
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_Legend(TCanvas* Canvas, TRect clRect)
{
	HDC mDC = Canvas->Handle;
    int channel, j, i=1;
    AnsiString str;
    SIZE sz;
    GetTextExtentPoint32(mDC, "1", 1, &sz);
    int h_step = sz.cy*1.2;
	for(j=0; j<2; j++)
	    for(channel=0; channel<16; channel++)
    		if((m_coords_mask[j]>>channel)&1)
        	    if((m_coords_to_show[j]>>channel)&1)
            	{
                	if(Printer()->Printing) SetTextColor(mDC,clBlack);
	                else SetTextColor(mDC,m_color[j][channel]);
    	            str = m_labels[j][channel] + "(t)";
        	        TextOut(mDC, clRect.Left+h_step/2, clRect.Top+i*h_step, str.c_str(), str.Length());
            	    i++;
	            }
    for(j=0; j<8; j++)
        if(m_funcs[j][0])
        {
        	if(Printer()->Printing) SetTextColor(mDC,clBlack);
            else SetTextColor(mDC,m_funcs_color[j]);
            if(m_funcs[j][2]<m_col_can[0]) str =  m_labels[0][m_funcs[j][2]] + "(";
            else str =  m_labels[1][m_funcs[j][2]-m_col_can[0]] + "(";
            if(m_funcs[j][1]<m_col_can[0]) str += m_labels[0][m_funcs[j][1]] + ")";
            else str += m_labels[1][m_funcs[j][1]-m_col_can[0]] + ")";
            TextOut(mDC, clRect.Left+h_step/2, clRect.Top+i*h_step, str.c_str(), str.Length());
            i++;
        }
}
//---------------------------------------------------------------------------
template <class T>
void __fastcall TGraph<T>::m_Graphs(TCanvas* Canvas, TRect clRect, TRect mg)
{
    Application->ProcessMessages();
    TCursor Save_Cursor = Screen->Cursor;
    Screen->Cursor = crHourGlass;
try
{
    double x_scale, y_scale, y_mid, y_pred;
    unsigned long counter, beg_cnt, end_cnt;
    int cnt;
    fpos_t filepos;
	HDC mDC = Canvas->Handle;
    beg_cnt = floor(col_points*beg_time/elp_time);
    end_cnt = floor(col_points*end_time/elp_time)-1;
    y_scale = (double)(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/((m_Y_max-m_Y_min)*max_val);
    x_scale = (double)(clRect.Right-clRect.Left-(mg.Right+mg.Left))/(end_cnt-beg_cnt);
    int col_otr = 1000;
    if((unsigned int)col_otr>(end_cnt-beg_cnt)) col_otr = end_cnt-beg_cnt;
    int i, j, channel;
    HPEN pen[2][16];
    T beg_pnt[32];
//    double dop_beg_pnt[4];
    POINT* pnts = (POINT*)calloc(col_otr+1,sizeof(POINT));
    T* tmp_arr  = (T*)calloc(col_can*col_otr,sizeof(T));
    y_mid = clRect.Top+((clRect.Bottom-mg.Bottom)-(clRect.Top-mg.Top))/2;
    y_pred = (m_Y_min+m_Y_max)/2*max_val;
    double y_to_base[2][16];
    for(i=0; i<2; i++) for(channel=0; channel<16; channel++) y_to_base[i][channel] = m_base[i][channel]/m_real_base[i][channel];
    for(i=0; i<2; i++) for(j=0; j<16; j++) pen[i][j] = CreatePen(PS_SOLID,1,m_color[i][j]*(!(Printer()->Printing)));
    HPEN old_pen = SelectObject(mDC,pen[0]);
	FILE* data_file;
    if((data_file=fopen(m_file.c_str(),"rb"))!= NULL)
    {
	    fseek(data_file,sizeof(T)*beg_cnt*col_can,SEEK_SET);
    	fread(beg_pnt,sizeof(T),col_can,data_file);
	    fgetpos(data_file,&filepos);
    	fclose(data_file);
    }
	for(counter=0; counter<(end_cnt-beg_cnt); counter+=col_otr)
    {
        if((col_points-counter)<col_otr) col_otr = col_points-counter-1;
		if((data_file=fopen(m_file.c_str(),"rb"))!= NULL)
        {
			fsetpos(data_file,&filepos);
    	    fread(tmp_arr,sizeof(T),col_otr*col_can,data_file);
        	fgetpos(data_file,&filepos);
	        fclose(data_file);
        }
        for(j=0; j<=col_otr; j++) pnts[j].x = clRect.Left+mg.Left+(int)(x_scale*(double)(counter+j));
	    for(i=0,cnt=0; i<2; i++)
    	{
        	for(channel=0; channel<16; channel++)
            {
            	if((m_coords_mask[i] >> channel)& 1)
                {
                	if((m_coords_to_show[i] >> channel)& 1)
                    {
                    	SelectObject(mDC,pen[i][channel]);
                        pnts[0].y = (int)(y_mid-((double)beg_pnt[cnt]*y_to_base[i][channel]-y_pred)*y_scale);
                        for(j=1; j<=col_otr; j++)
                        	pnts[j].y = (int)(y_mid-((double)tmp_arr[cnt+(j-1)*col_can]*y_to_base[i][channel]-y_pred)*y_scale);
                        beg_pnt[cnt] = tmp_arr[cnt+(col_otr-1)*col_can];
                        Polyline(mDC,pnts,col_otr+1);
                    }
                    cnt++;
                }
            }
        }
/*		double coord[2][16];
        double result;
        for(i=0; i<4; i++)
        {
         	if(show_dop_coord[i])
            {
				calculate(dopExpr[i], result, m_labels, m_coords_mask[0], coord);
				dop_beg_pnt[i] = result;
            }
        }*/
//		MSG msg;
//		while(PeekMessage(&msg,NULL,WM_MOUSEFIRST,WM_MOUSELAST,PM_REMOVE)) DispatchMessage(&msg);
//		while(PeekMessage(&msg,NULL,WM_PAINT,WM_PAINT,PM_REMOVE)) DispatchMessage(&msg);
	}
    SelectObject(mDC,old_pen);
    for(i=0; i<2; i++) for(int j=0; j<16; j++) DeleteObject(pen[i][j]);
    free(pnts);
    free(tmp_arr);
}
__finally
{
    Screen->Cursor = Save_Cursor;
}
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_Funcs(TCanvas* Canvas, TRect clRect, TRect mg)
{
    Application->ProcessMessages();
    TCursor Save_Cursor = Screen->Cursor;
    Screen->Cursor = crHourGlass;
try
{
    double x_scale, y_scale, x_mid, y_mid, x_pred, y_pred;
    unsigned long counter, beg_cnt, end_cnt;
	HDC mDC = Canvas->Handle;
	beg_cnt = floor(col_points*beg_time/elp_time);
    end_cnt = floor(col_points*end_time/elp_time)-1;
    y_scale = (double)(clRect.Bottom-clRect.Top-(mg.Top+mg.Bottom))/((m_Y_max-m_Y_min)*max_val);
    x_scale = (double)(clRect.Right-clRect.Left-(mg.Right+mg.Left))/((m_X_max-m_X_min)*max_val);
    int col_otr = 1000; if((unsigned int)col_otr>(end_cnt-beg_cnt)) col_otr = end_cnt-beg_cnt;
    int i, j, channel, cnt;
    fpos_t filepos;
    HPEN pen[5];
    POINT* pnts = (POINT*)calloc(col_otr+1,sizeof(POINT));
    T* tmp_arr = (T*)calloc(col_can*col_otr,sizeof(T));
    T beg_pnt[32];
    T beg_pt[8][2];
    y_mid = clRect.Top+((clRect.Bottom-mg.Bottom)-(clRect.Top-mg.Top))/2;
    x_mid = clRect.Left+((clRect.Right-mg.Right)-(clRect.Left-mg.Left))/2;
    y_pred = (m_Y_min+m_Y_max)/2*max_val;
    x_pred = (m_X_min+m_X_max)/2*max_val;
    double y_to_base[32];
    for(i=0,cnt=0; i<2; i++)
    {
        for(channel=0; channel<16; channel++)
        {
        	if((m_coords_mask[i]>>channel)&1)
            {
                y_to_base[cnt] = m_base[i][channel]/m_real_base[i][channel];
                cnt++;
            }
        }
    }
    for(int i=0; i<8; i++) pen[i] = CreatePen(PS_SOLID,1,m_funcs_color[i]*(!(Printer()->Printing)));
    HPEN old_pen = SelectObject(mDC,pen[0]);
	FILE* data_file;
    if((data_file=fopen(m_file.c_str(),"rb"))!= NULL)
    {
	    fseek(data_file,sizeof(T)*beg_cnt*col_can,SEEK_SET);
    	fread(beg_pnt,sizeof(T),col_can,data_file);
	    fgetpos(data_file,&filepos);
        fclose(data_file);
    }
	for(int jj=0; jj<8; jj++)
    {
        if(m_funcs[jj][0])
        {
        	beg_pt[jj][0] = beg_pnt[m_funcs[jj][1]];
            beg_pt[jj][1] = beg_pnt[m_funcs[jj][2]];
        }
    }
    for(counter=0; counter<(end_cnt-beg_cnt); counter+=col_otr)
    {
        if((col_points-counter)<col_otr) col_otr = col_points-counter-1;
		if((data_file=fopen(m_file.c_str(),"rb"))!= NULL)
        {
	    	fsetpos(data_file,&filepos);
	        fread(tmp_arr,sizeof(T),col_otr*col_can,data_file);
   		    fgetpos(data_file,&filepos);
            fclose(data_file);
        }
        for(int jj=0; jj<8; jj++)
        {
            if(m_funcs[jj][0])
            {
                SelectObject(mDC,pen[jj]);
                pnts[0].x = (int)(x_mid + ((double)beg_pt[jj][0]*y_to_base[m_funcs[jj][1]] - x_pred)*x_scale);
                for(j=1; j<=col_otr; j++) pnts[j].x = (int)(x_mid + ((double)tmp_arr[m_funcs[jj][1]+(j-1)*col_can]*y_to_base[m_funcs[jj][1]] - x_pred)*x_scale);
                pnts[0].y = (int)(y_mid - ((double)beg_pt[jj][1]*y_to_base[m_funcs[jj][2]] - y_pred)*y_scale);
                for(j=1; j<=col_otr; j++) pnts[j].y = (int)(y_mid - ((double)tmp_arr[m_funcs[jj][2]+(j-1)*col_can]*y_to_base[m_funcs[jj][2]] - y_pred)*y_scale);
                beg_pt[jj][0] = tmp_arr[m_funcs[jj][1]+(col_otr-1)*col_can];
                beg_pt[jj][1] = tmp_arr[m_funcs[jj][2]+(col_otr-1)*col_can];
                Polyline(mDC,pnts,col_otr+1);
            }
        }
    }
    SelectObject(mDC,old_pen);
    for(int i=0; i<8; i++) DeleteObject(pen[i]);
    free(pnts);
    free(tmp_arr);
}
__finally
{
    Screen->Cursor = Save_Cursor;
}
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_DrawData(TCanvas* Canvas, TRect clRect, TRect mg)
{
    if(m_coords_to_show[0] || m_coords_to_show[1]) m_Graphs(Canvas, clRect, mg);
    if(m_funcs_pr) m_Funcs(Canvas, clRect, mg);
    AnsiString old_file = m_file;
	int i;
    for(i=0; i<8; i++)
    {
		if(m_show_comp_file[i])
        {
        	if(m_comp_file[i] != "")
            {
				m_file = m_comp_file[i];
                UpdateColPoints();
			    if(m_coords_to_show[0] || m_coords_to_show[1]) m_Graphs(Canvas, clRect, mg);
			    if(m_funcs_pr) m_Funcs(Canvas, clRect, mg);
            }
        }
    }
    m_file = old_file;
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_Draw(TCanvas* Canvas, TPoint legend_wh, TPoint graphs_wh,
	TPoint base_wh, TPoint captn_wh, TRect mg, TRect gr_mg)
{
    TRect GraphsRect = TRect(mg.Left, mg.Top, mg.Left+graphs_wh.x, mg.Top+graphs_wh.y);
    TRect BaseRect 	 = TRect(mg.Left, mg.Top+graphs_wh.y, mg.Left+base_wh.x, mg.Top+graphs_wh.y+base_wh.y);
    TRect LegendRect = TRect(mg.Left+graphs_wh.x, mg.Top, mg.Left+graphs_wh.x+legend_wh.x, mg.Top+legend_wh.y);
    TRect CaptnRect  = TRect(mg.Left, mg.Top+graphs_wh.y+base_wh.y, mg.Left+captn_wh.x, mg.Top+graphs_wh.y+base_wh.y+captn_wh.y);
	TRect PlotRect	 = TRect(GraphsRect.Left+gr_mg.Left, GraphsRect.Top+gr_mg.Top, GraphsRect.Right-gr_mg.Right, GraphsRect.Bottom-gr_mg.Bottom);
    UpdateColPoints();
	m_Setka(Canvas, GraphsRect, gr_mg);
	m_Osi(Canvas, GraphsRect, gr_mg);
	m_NullOsi(Canvas, GraphsRect, gr_mg);
	m_Text(Canvas, GraphsRect, gr_mg);
	m_Labels(Canvas, GraphsRect, gr_mg);
	m_Legend(Canvas, LegendRect);
    SelectClipRgn(Canvas->Handle,CreateRectRgnIndirect(&PlotRect));
    m_DrawData(Canvas, GraphsRect, gr_mg);
    SelectClipRgn(Canvas->Handle,NULL);
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_ExpSmooth(unsigned short coords_to_filter)
{
    AnsiString InputVal = FloatToStr(0.3);
	if(InputQuery(" ."," -  (0<k<1)",InputVal))
    {
		m_file = m_file_orig;
		UpdateColPoints();
	    unsigned long counter;
    	unsigned short cnt, channel;
	    double k = StrToFloat(InputVal);
        ProgressDlg = new TProgressDlg(Application);
        ProgressDlg->Caption = " .";
		ProgressDlg->Show();
		FILE* data_file = fopen(m_file_orig.c_str(),"rb");
		FILE* filter_file = fopen(m_file_filter.c_str(),"wb");
	    T prv_data[32];
    	T cur_data[32];
	    fread(prv_data,sizeof(T),col_can,data_file);
    	fwrite(prv_data,sizeof(T),col_can,filter_file);
//		{
        	for(counter=1; counter<col_points; counter++)
    		{
	    		fread(cur_data,sizeof(T),col_can,data_file);
	        	for(channel=0, cnt=0; channel<16; channel++)
		        {
    		    	if((m_coords_mask[0] >> channel)& 1)
        		    {
            			if((coords_to_filter >> channel)& 1)
	                	{
	    	            	cur_data[cnt] = k*cur_data[cnt]+(1-k)*prv_data[cnt];
    	    	        }
        	    	    cnt++;
	        	    }
	    	    }
		        fwrite(cur_data,sizeof(T),col_can,filter_file);
    		    for(int i=0; i<col_can; i++) prv_data[i] = cur_data[i];
				if((ProgressDlg->ProgressBar->Max*counter/col_points)>(ProgressDlg->ProgressBar->Position))
    	        	ProgressDlg->ProgressBar->StepIt();
		    }
//		}
    	fclose(data_file);
	    fclose(filter_file);
    	m_file = m_file_filter;
        m_filtered = true;
        delete ProgressDlg;
    }
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_Vipr(unsigned short coords_to_filter)
{
	m_file = m_file_orig;
	UpdateColPoints();
    unsigned long counter;
    unsigned short cnt, channel;
    T temp[32];
    ProgressDlg = new TProgressDlg(Application);
    ProgressDlg->Caption = "  ";
    ProgressDlg->Show();
	FILE* data_file = fopen(m_file_orig.c_str(),"rb");
	FILE* filter_file = fopen(m_file_filter.c_str(),"wb");
//	{
	    for(counter=0; counter<col_points; counter++)
  	  	{
    		fread(temp,sizeof(T),col_can,data_file);
        	for (channel=0, cnt=0; channel<16; channel++)
        	{
        		if((m_coords_mask[0] >> channel) & 1)
	            {
    	        	if((coords_to_filter >> channel) & 1)
        	        {
            	    	if(temp[cnt]<0) temp[cnt] *= (T)-1;
                	}
	                cnt++;
    	        }
        	}
	        fwrite(temp,sizeof(T),col_can,filter_file);
			if((ProgressDlg->ProgressBar->Max*counter/col_points)>(ProgressDlg->ProgressBar->Position))
            	ProgressDlg->ProgressBar->StepIt();
    	}
//	}
	fclose(data_file);
	fclose(filter_file);
    m_file = m_file_filter;
    m_filtered = true;
    delete ProgressDlg;
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_SrKwad(unsigned short coords_to_filter)
{
    AnsiString InputVal = "200";
	if(InputQuery("  ","  , ",InputVal))
    {
		m_file = m_file_orig;
		UpdateColPoints();
	    unsigned __int64 counter, temp;
	    int ii, cnt;
    	int rep = StrToInt(InputVal);
    	double step;
	    rep = (int)((double)rep/(elp_time*1000)*(double)col_points);
    	T* buf = (T*) calloc(rep*(col_can),sizeof(T));
	    T xm1, xm2, xm2_prv[32];
        ProgressDlg = new TProgressDlg(Application);
        ProgressDlg->Caption = "  ";
        ProgressDlg->ProgressBar->Max = col_points/rep;
		ProgressDlg->Show();
		FILE* data_file = fopen(m_file_orig.c_str(),"rb");
		FILE* filter_file = fopen(m_file_filter.c_str(),"wb");
	    rewind(data_file);
    	rewind(filter_file);
	    for (counter=0; counter<col_points; counter+=rep)
    	{
    		cnt = 0;
	        fread(buf,2,rep*col_can,data_file);
    	    for (int channel=0; channel<16; channel++)
        	{
	        	if((m_coords_mask[0] >> channel) & 1)
    	        {
        	    	if((coords_to_filter >> channel) & 1)
            	    {
	                	temp = 0;
    	                for(ii=0; ii<rep; ii++)
        	            {
            	        	if((counter+ii)<col_points)
                	        {
                    	    	xm1 = buf[cnt+ii*col_can];
                        	    temp += xm1*xm1;
	                        }
    	                    else break;
        	            }
            	        xm2 = (T)sqrt((double)(temp/ii));
                	    for(ii=0; ii<rep; ii++)
                    	{
	                    	if((counter+ii)<col_points)
    	                    {
        	                	if(counter == 0) buf[cnt+ii*col_can] = xm2;
            	                else
                	            {
                    	        	step = (double)(xm2-xm2_prv[cnt])/rep;
                        	        buf[cnt+ii*col_can] = xm2_prv[cnt]+(double)(ii+1)*step;
                            	}
	                        }
    	                    else break;
        	            }
            	        xm2_prv[cnt] = xm2;
                	}
	                cnt++;
    	        }
        	}
    	    fwrite(buf,sizeof(T),ii*col_can,filter_file);
            ProgressDlg->ProgressBar->StepIt();
	    }
	    free(buf);
    	fclose(data_file);
	    fclose(filter_file);
    	m_file = m_file_filter;
        m_filtered = true;
        delete ProgressDlg;
	}
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_Hanning(unsigned short coords_to_filter)
{
    unsigned long counter;
    unsigned short cnt, channel;
    T temp[32], xm1[32], xm2[32], xnt[32];
    m_file = m_file_orig;
	UpdateColPoints();
    ProgressDlg = new TProgressDlg(Application);
    ProgressDlg->Caption = " ";
    ProgressDlg->Show();
	FILE* data_file = fopen(m_file_orig.c_str(),"rb");
	FILE* filter_file = fopen(m_file_filter.c_str(),"wb");
    fread(xm2,sizeof(T),col_can,data_file);
    fread(xm1,sizeof(T),col_can,data_file);
    fwrite(xm2,sizeof(T),col_can,filter_file);
    fwrite(xm1,sizeof(T),col_can,filter_file);
    for(counter=2; counter<col_points; counter++)
    {
    	fread(xnt,sizeof(T),col_can,data_file);
        cnt = 0;
        for (channel=0; channel<16; channel++)
        {
        	if((m_coords_mask[0] >> channel) & 1)
            {
            	if((coords_to_filter >> channel) & 1)
                {
                	temp[cnt] = (T)((xnt[cnt]+(xm1[cnt]<<1)+xm2[cnt])/4);
                    xm2[cnt] = xm1[cnt];
                    xm1[cnt] = xnt[cnt];
                }
                else temp[cnt] = xnt[cnt];
                cnt++;
            }
        }
        temp[cnt] = xnt[cnt];
        temp[cnt+1] = xnt[cnt+1];
        fwrite(temp,sizeof(T),col_can,filter_file);
        if((ProgressDlg->ProgressBar->Max*counter/col_points)>(ProgressDlg->ProgressBar->Position))
        	ProgressDlg->ProgressBar->StepIt();
    }
    fclose(data_file);
    fclose(filter_file);
    m_file = m_file_filter;
    m_filtered = true;
    delete ProgressDlg;
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_Sort(unsigned short channel)
{
    TCursor Save_Cursor = Screen->Cursor;
    Screen->Cursor = crHourGlass;
	try
	{
    	T tmp[18], t1;
	    int i, j, t2;
    	int tt = 18*1024;
	    long counter;
    	UpdateColPoints();
	    if(tt > col_points*col_can) tt = col_points*col_can;
    	T* temp = (T*)calloc(tt,sizeof(T));
	    T* arr1 = (T*)calloc(col_points,sizeof(T));
    	int* arr2 = (int*)calloc(col_points,sizeof(int));
	    FILE* data_file = fopen(m_file_orig.c_str(),"rb");
    	for(i=0; i < col_points; i++)
	    {
    	    fread(tmp,sizeof(T),col_can,data_file);
        	arr1[i] = tmp[channel];
	        arr2[i] = i;
    	}
	    for(i=0; i < (col_points-1); i++)
    	{
        	for(j=(col_points-1); j > i; j--)
	        {
    	        if(arr1[i] > arr1[j])
        	    {
            	    t1 = arr1[i];       t2 = arr2[i];
                	arr1[i] = arr1[j];  arr2[i] = arr2[j];
	                arr1[j] = t1;       arr2[j] = t2;
    	        }
        	}
	    }
	    FILE* filter_file = fopen(m_file_filter.c_str(),"wb");
    	rewind(filter_file);
	    for(i=0; i<col_points; i++)
    	{
        	fseek(data_file,sizeof(T)*arr2[i]*col_can,SEEK_SET);
	        fread(tmp,sizeof(T),col_can,data_file);
    	    fwrite(tmp,sizeof(T),col_can,filter_file);
	    }
    	fclose(data_file);
	    fclose(filter_file);
	    data_file = fopen(m_file_orig.c_str(),"wb");
    	filter_file = fopen(m_file_filter.c_str(),"rb");
	    while((counter=fread(temp,sizeof(T),tt,filter_file)) != 0) fwrite(temp,sizeof(T),counter,data_file);
    	fclose(data_file);
	    fclose(filter_file);
    	free(arr2);
	    free(arr1);
    	free(temp);
	    DeleteFile(m_file_filter);
    	m_file = m_file_orig;
        m_filtered = false;
    }
	__finally
	{
    	Screen->Cursor = Save_Cursor;
	}
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_SaveFiltered()
{
	int tt = 18*1024;
    long counter;
    T* temp = (T*)calloc(tt,sizeof(T));
    FILE* data_file = fopen(m_file_orig.c_str(),"wb");
    FILE* filter_file = fopen(m_file_filter.c_str(),"rb");
    while((counter=fread(temp,sizeof(T),tt,filter_file)) != 0) fwrite(temp,sizeof(T),counter,data_file);
    fclose(data_file);
    fclose(filter_file);
    free(temp);
    DeleteFile(m_file_filter);
    m_file = m_file_orig;
    m_filtered = false;
}
//---------------------------------------------------------------------------
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_MinMax(unsigned short coords_to_filter[2], double& m_min, double& m_max)
{
TCursor Save_Cursor = Screen->Cursor;
Screen->Cursor = crHourGlass;
try
{
	UpdateColPoints();
	FILE* data_file = fopen(m_file.c_str(),"rb");
    unsigned long counter;
    unsigned short cnt, channel;
	int i;
    bool m_first = true;
	double tmp_val;
    T temp[32];
    for(counter=0; counter<col_points; counter++)
    {
    	fread(temp,sizeof(T),col_can,data_file);
        cnt = 0;
		for(i=0; i<2; i++)
        {
	        for (channel=0; channel<16; channel++)
    	    {
        		if((m_coords_mask[i]>>channel)&1)
            	{
            		if((coords_to_filter[i]>>channel)&1)
	                {
                   		tmp_val = (double)temp[cnt]/511*m_base[i][channel]/m_real_base[i][channel];
						if(m_first)
                        {
                        	m_max = m_min = tmp_val;
                            m_first = false;
                        }
                        if(tmp_val > m_max) m_max = tmp_val;
                        if(tmp_val < m_min) m_min = tmp_val;
        	        }
            	    cnt++;
                }
            }
        }
    }
    fclose(data_file);
}
__finally
{
	Screen->Cursor = Save_Cursor;
}
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_GetVisibleCoords(AnsiString os, unsigned short coords_dest[2])
{
	int i, j, cnt;
	if(os == "X")
    {
        for(j=0; j<8; j++)
        {
            if(m_funcs[j][0])
            {
            	if(m_funcs[j][1]<m_col_can[0])
                {
                	for(i=0, cnt=0; i<16; i++)
                    {
                        cnt += (m_coords_mask[0]>>i)&1;
                    	if(cnt > m_funcs[j][1]) break;
                    }
	                coords_dest[0] |= (unsigned short)(1<<i);
                }
                else
                {
                	for(i=0, cnt=m_col_can[0]; i<16; i++)
                    {
                    	cnt += (m_coords_mask[1]>>i)&1;
                    	if(cnt > m_funcs[j][1]) break;
                    }
	                coords_dest[1] |= (unsigned short)(1<<i);
                }
            }
        }
    }
    if(os == "Y")
    {
        for(j=0; j<8; j++)
        {
            if(m_funcs[j][0])
            {
            	if(m_funcs[j][2]<m_col_can[0])
                {
                	for(i=0, cnt=0; i<16; i++)
					{
                    	cnt += (m_coords_mask[0]>>i)&1;
                    	if(cnt > m_funcs[j][2]) break;
                    }
	                coords_dest[0] |= (unsigned short)(1<<i);
                }
                else
                {
                	for(i=0, cnt=m_col_can[0]; i<16; i++)
					{
                    	cnt += (m_coords_mask[1]>>i)&1;
                    	if(cnt > m_funcs[j][2]) break;
                    }
	                coords_dest[1] |= (unsigned short)(1<<i);
                }
            }
        }
        coords_dest[0] |= m_coords_to_show[0];
        coords_dest[1] |= m_coords_to_show[1];
    }
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_GetAllVisibleCoords(unsigned short coords_dest[2])
{
	ZeroMemory(coords_dest, sizeof(coords_dest));
    m_GetVisibleCoords("X", coords_dest);
    m_GetVisibleCoords("Y", coords_dest);
}
//---------------------------------------------------------------------------
/////////////////////////////////////////////////////////////////////////////

template <class T>
void __fastcall TGraph<T>::MouseDown(TMouseButton Button, TShiftState Shift,
	int X, int Y, TCanvas* Canvas, TRect clRect, TRect mg)
{
	if(Button == mbLeft)
    {
        if(X<(clRect.Left+mg.Left)) X = clRect.Left+mg.Left;
        if(X>(clRect.Right-mg.Right)) X = clRect.Right-mg.Right;
        if(Y<(clRect.Top+mg.Top)) Y = clRect.Top+mg.Top;
        if(Y>(clRect.Bottom-mg.Bottom)) Y = clRect.Bottom-mg.Bottom;
        Old.x = X; Old.y = Y;
        Beg.x = X; Beg.y = Y;
        sel_fl = true; sel_X = true;
    }
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::MouseMove(TShiftState Shift, int X, int Y,
	TCanvas* Canvas, TRect clRect, TRect mg)
{
    HDC mDC = Canvas->Handle;
	if(sel_fl)
    {
        if(X<(clRect.Left+mg.Left)) X = clRect.Left+mg.Left;
        if(X>(clRect.Right-mg.Right)) X = clRect.Right-mg.Right;
        if(Y<(clRect.Top+mg.Top)) Y = clRect.Top+mg.Top;
        if(Y>(clRect.Bottom-mg.Bottom)) Y = clRect.Bottom-mg.Bottom;
        if((abs(X-Beg.x)>abs(Y-Beg.y))&&!sel_X)
        {
            sel_X = true;
            InvertRect(mDC,&TRect(clRect.Left+mg.Left,Beg.y,clRect.Right-clRect.Left-mg.Right,Old.y));
            InvertRect(mDC,&TRect(Beg.x,clRect.Top+mg.Top,Old.x,clRect.Bottom-clRect.Top-mg.Bottom));
        }
        if((abs(X-Beg.x)<abs(Y-Beg.y))&&sel_X)
        {
            sel_X = false;
            InvertRect(mDC,&TRect(Beg.x,clRect.Top+mg.Top,Old.x,clRect.Bottom-clRect.Top-mg.Bottom));
            InvertRect(mDC,&TRect(clRect.Left+mg.Left,Beg.y,clRect.Right-clRect.Left-mg.Right,Old.y));
        }
        if(sel_X)  InvertRect(mDC,&TRect(Old.x,clRect.Top+mg.Top,X,clRect.Bottom-clRect.Top-mg.Bottom));
        if(!sel_X) InvertRect(mDC,&TRect(clRect.Left+mg.Left,Old.y,clRect.Right-clRect.Left-mg.Right,Y));
        Old.x = X; Old.y = Y;
    }
}
//---------------------------------------------------------------------------

template <class T>
bool __fastcall TGraph<T>::MouseUp(TMouseButton Button, TShiftState Shift,
	int X, int Y, TCanvas* Canvas, TRect clRect, TRect mg)
{
	if(sel_fl)
    {
        sel_fl = false;
        if(sel_X&&(m_coords_to_show[0]||m_coords_to_show[1]))
        {
            if(Beg.x<Old.x)
            {
                double tmp_time;
                tmp_time = floor((beg_time+(double)(Beg.x-(clRect.Left+mg.Left))*
                	(end_time-beg_time)/(double)(clRect.Right-clRect.Left-
                    (mg.Right+mg.Left)))*10)/10;
                end_time = ceil((beg_time+(double)(Old.x-(clRect.Left+mg.Left))*
                	(end_time-beg_time)/(double)(clRect.Right-clRect.Left-
                    (mg.Right+mg.Left)))*10)/10;
                beg_time = tmp_time;
                if(end_time>elp_time) end_time = elp_time;
                if(beg_time<0) beg_time = 0;
            }
            else if(Beg.x>Old.x)
            {
                beg_time = 0;
                end_time = elp_time;
            }
        }
        else if(sel_X)
        {
            if((Beg.x<Old.x)&((m_X_max-m_X_min)>0.1))
            {
                double m_X_tmp;
                m_X_tmp = ceil((m_X_min+(double)(Old.x-(clRect.Left+mg.Left))*
                	(m_X_max-m_X_min)/(double)(clRect.Right-clRect.Left-
                    (mg.Right+mg.Left)))*10)/10;
                m_X_min = floor((m_X_min+(double)(Beg.x-(clRect.Left+mg.Left))*
                	(m_X_max-m_X_min)/(double)(clRect.Right-clRect.Left-
                    (mg.Right+mg.Left)))*10)/10;
                m_X_max = m_X_tmp;
            }
            else if(Beg.x>Old.x)
            {
				unsigned short coords[2] = {0,0};
                m_GetVisibleCoords("X", coords);
				m_MinMax(coords, m_X_min, m_X_max);
                if(m_X_min == m_X_max)
                {
                 	m_X_max += 0.1;
                    m_X_min -= 0.1;
                }
            }
        }
        else
        {
            if((Beg.y < Old.y)&((m_Y_max-m_Y_min)>0.1))
            {
                double m_Y_tmp;
                m_Y_tmp = ceil((m_Y_max-(double)(Beg.y-(clRect.Top+mg.Top))*
                	(m_Y_max-m_Y_min)/(double)(clRect.Bottom-clRect.Top-
                    (mg.Top+mg.Bottom)))*10)/10;
                m_Y_min = floor((m_Y_max-(double)(Old.y-(clRect.Top+mg.Top))*
                	(m_Y_max-m_Y_min)/(double)(clRect.Bottom-clRect.Top-
                    (mg.Top+mg.Bottom)))*10)/10;
                m_Y_max = m_Y_tmp;
            }
            else if(Beg.y > Old.y)
            {
				unsigned short coords[2] = {0,0};
                m_GetVisibleCoords("Y", coords);
				m_MinMax(coords, m_Y_min, m_Y_max);
                if(m_Y_min == m_Y_max)
                {
                 	m_Y_max += 0.1;
                    m_Y_min -= 0.1;
                }
            }
        }
        return true;
    }
    return false;
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_DeleteFiles()
{
	if(FileExists(m_file_orig)) DeleteFile(m_file_orig);
	if(FileExists(m_file_filter)) DeleteFile(m_file_filter);
	for(int i=0; i<8; i++) if(FileExists(m_comp_file[i])) DeleteFile(m_comp_file[i]);
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_Init()
{
    int i, j;
    m_time = TDateTime::CurrentTime();
    m_date = TDateTime::CurrentDate();
    TColor defColor1[16] = {clMaroon,clGreen,clOlive,clNavy,clPurple,clTeal,clGreen,clBlack,clRed,clFuchsia,clBlue,clBlack,clGreen,clAqua,clLime,clBlack};
    TColor defColor2[16] = {clMaroon,clGreen,clOlive,clNavy,clPurple,clTeal,clGreen,clBlack,clRed,clFuchsia,clBlue,clBlack,clGreen,clAqua,clLime,clBlack};
	TColor defColor3[8]  = {clMaroon,clGreen,clOlive,clNavy,clPurple,clTeal,clGreen,clBlack};
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
    for(i=0; i<16; i++) m_color[0][i]  	 = StringToColor(RegFile->ReadString("Colors", "color"+IntToStr(i+1), ColorToString(defColor1[i])));
	for(i=0; i<16; i++) m_color[1][i] 	 = StringToColor(RegFile->ReadString("Colors", "CAP_color"+IntToStr(i+1), ColorToString(defColor2[i])));
    for(i=0; i<8; i++) m_funcs_color[i]  = StringToColor(RegFile->ReadString("Colors", "funcs_color"+IntToStr(i+1), ColorToString(defColor3[i])));
    delete RegFile;

    for(j=0; j<2; j++)
	    for(i=0; i<16; i++)
    	{
        	m_labels[j][i] 		= ((TMainForm*)MainForm)->m_labels[j][i];
	        m_razmern[j][i] 	= ((TMainForm*)MainForm)->m_razmern[j][i];
    	    m_base[j][i] 		= ((TMainForm*)MainForm)->m_base[j][i];
        	m_real_base[j][i] 	= ((TMainForm*)MainForm)->m_real_base[j][i];
	    }

    for(i=0; i<8; i++)
    {
		m_comp_file[i] = "";
		m_comp_FileName[i] = "";
     	m_show_comp_file[i] = false;
    }

    for(i=0; i<8; i++) for(j=0; j<3; j++) m_funcs[i][j] = 0;

	m_col_del = TPoint(5,6);
    m_Y_max = 1.2;
    m_Y_min = -1.2;
    m_X_max = 1.2;
    m_X_min = -1.2;
    max_val = 511;
    sel_fl = false;
    sel_X = false;
    m_gridFrm = NULL;
    m_static = false;
    m_filtered = false;
    beg_time = 0;
    m_coords_mask[0] = 0;
    m_coords_mask[1] = 0;
    col_can = 0;
    m_col_osi_Y = 1;
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::m_NastrDlg()
{
	TGrDlg* dlg = new TGrDlg(Application);
    dlg->SetCaptions(m_labels, m_coords_mask);
    dlg->SetCoordsToShow(m_coords_to_show);
    dlg->SetCoordsMask(m_coords_mask);
    dlg->SetFuncs(m_funcs);
    dlg->SetColors(m_color, m_funcs_color, m_dop_color);
    dlg->Memo->Lines->Assign(m_memo);
    dlg->TimePicker->Time = m_time;
    dlg->DatePicker->Date = m_date;
    dlg->SetOsi(m_X_min, m_X_max, m_Y_min, m_Y_max, beg_time, end_time, m_col_del, m_static);
	dlg->SetCompFiles(m_comp_FileName, m_comp_file, m_show_comp_file);
	dlg->SetDopCoords(dopName, dopExpr, show_dop_coord);
	if(m_static)
    {
		dlg->PageControl1->ActivePage = dlg->TabSheet3;
	    dlg->TabSheet1->TabVisible = false;
    	dlg->TabSheet2->TabVisible = false;
    }

    if(dlg->ShowModal() == mrOk)
    {
    	dlg->GetCoordsToShow(m_coords_to_show);
		dlg->GetFuncs(m_funcs);
    	dlg->GetColors(m_color, m_funcs_color, m_dop_color);
		dlg->GetCompFiles(m_comp_FileName, m_comp_file, m_show_comp_file);
		dlg->GetDopCoords(dopName, dopExpr, show_dop_coord);
    	m_memo->Assign(dlg->Memo->Lines);
	    m_time = dlg->TimePicker->Time;
    	m_date = dlg->DatePicker->Date;
    	dlg->GetOsi(m_X_min, m_X_max, m_Y_min, m_Y_max, beg_time, end_time, m_col_del);
        if(beg_time < 0) beg_time = 0;
        if(end_time > elp_time) end_time = elp_time;
        if((beg_time == end_time)||(beg_time > end_time))
        {
        	beg_time = 0;
            end_time = elp_time;
        }
        int i;
		TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
   	 	for(i=0; i<16; i++) RegFile->WriteString("Colors", "color"+IntToStr(i+1), ColorToString((TColor)m_color[0][i]));
		for(i=0; i<16; i++) RegFile->WriteString("Colors", "CAP_color"+IntToStr(i+1), ColorToString((TColor)m_color[1][i]));
	    for(i=0; i<8; i++) RegFile->WriteString("Colors", "funcs_color"+IntToStr(i+1), ColorToString((TColor)m_funcs_color[i]));
    	delete RegFile;
    }
    delete dlg;
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::LoadFromFile(AnsiString FileName)
{
//	AnsiString str1 = "VisPrivod v1.0 file ";
//	AnsiString str2 = "VisPrivod v1.1 file ";
//	AnsiString str3 = "VisPrivod v1.2 file ";
	AnsiString str4 = "VisPrivod v1.3 file ";
    char tmp[200];
    int i, k, length, count;
	short temp[0xffff];
    unsigned long j;
    FILE* data_file = fopen(FileName.c_str(),"rb");
    fgets(tmp, str4.Length() + 1, data_file);
    if(AnsiString(tmp) == str4) //--------------------------------------
    {
	    for(k=0; k<2; k++)
    	{
	    	for(i=0; i<16; i++)
	    	{
    	        length = _getw(data_file);
    			fgets(tmp, length + 1, data_file);
                m_labels[k][i] = AnsiString(tmp);
    	        length = _getw(data_file);
    			fgets(tmp, length + 1, data_file);
                m_razmern[k][i] = AnsiString(tmp);
		    }
	    }
        count = _getw(data_file);
        for(i=0; i<count; i++)
        {
   	        length = _getw(data_file);
			fgets(tmp, length + 1, data_file);
            m_memo->Add(tmp);
        }
        fread(&m_time, sizeof(TDateTime), 1, data_file);
        fread(&m_date, sizeof(TDateTime), 1, data_file);
        fread(&m_static, sizeof(bool), 1, data_file);
        fread(&elp_time, sizeof(double), 1, data_file);
        fread(m_coords_mask, sizeof(short), 2, data_file);
        fread(m_coords_to_show, sizeof(short), 2, data_file);
	    fread(m_funcs, sizeof(int), 8*3, data_file);
	    fread(m_base, sizeof(double), 2*16, data_file);
    	fread(m_real_base, sizeof(double), 2*16, data_file);
	    fread(&m_col_del, sizeof(TPoint), 1, data_file);
    	fread(&beg_time, sizeof(double), 1, data_file);
	    fread(&end_time, sizeof(double), 1, data_file);
    	fread(&m_Y_max, sizeof(double), 1, data_file);
	    fread(&m_Y_min, sizeof(double), 1, data_file);
    	fread(&m_X_max, sizeof(double), 1, data_file);
	    fread(&m_X_min, sizeof(double), 1, data_file);
//====================
		int m_legend_width;
        bool m_show_legend;
    	fread(&m_legend_width, sizeof(int), 1, data_file);
	    fread(&m_show_legend, sizeof(bool), 1, data_file);
//====================
        m_file = _tempnam("","Prv");
        m_file_orig = m_file;
		m_file_filter = m_file + "f";
        FILE* dest_file = fopen(m_file.c_str(),"wb");
        while((j = fread(temp, sizeof(short), 0xffff, data_file)) != 0)
        	fwrite(temp, sizeof(short), j, dest_file);
        fclose(dest_file);
    }
    else //------------------------------------------------------------------
    {
        fclose(data_file);
    	throw "   ";
    }
	for(i=0; i<2; i++) m_coords_to_show[i] &= m_coords_mask[i];
    fclose(data_file);
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::SaveToFile(AnsiString FileName)
{
    int i, k;
	T temp[0xffff];
    unsigned long j;
	AnsiString str = "VisPrivod v1.3 file ";
    FILE* dest_file = fopen(FileName.c_str(),"wb");
    fputs(str.c_str(), dest_file);
    for(k=0; k<2; k++)
    {
	    for(i=0; i<16; i++)
    	{
            _putw(m_labels[k][i].Length(), dest_file);
    		fputs(m_labels[k][i].c_str(), dest_file);
            _putw(m_razmern[k][i].Length(), dest_file);
    		fputs(m_razmern[k][i].c_str(), dest_file);
	    }
    }
	_putw(m_memo->Count, dest_file);
    for(i=0; i<(m_memo->Count); i++)
    {
    	_putw(m_memo->Strings[i].Length(), dest_file);
        fputs(m_memo->Strings[i].c_str(), dest_file);
    }
    fwrite(&m_time, sizeof(TDateTime), 1, dest_file);
    fwrite(&m_date, sizeof(TDateTime), 1, dest_file);
    fwrite(&m_static, sizeof(bool), 1, dest_file);
    fwrite(&elp_time, sizeof(double), 1, dest_file);
    fwrite(m_coords_mask, sizeof(short), 2, dest_file);
    fwrite(m_coords_to_show, sizeof(short), 2, dest_file);
    fwrite(m_funcs, sizeof(int), 8*3, dest_file);
    fwrite(m_base, sizeof(double), 2*16, dest_file);
    fwrite(m_real_base, sizeof(double), 2*16, dest_file);
    fwrite(&m_col_del, sizeof(TPoint), 1, dest_file);
    fwrite(&beg_time, sizeof(double), 1, dest_file);
    fwrite(&end_time, sizeof(double), 1, dest_file);
    fwrite(&m_Y_max, sizeof(double), 1, dest_file);
    fwrite(&m_Y_min, sizeof(double), 1, dest_file);
    fwrite(&m_X_max, sizeof(double), 1, dest_file);
    fwrite(&m_X_min, sizeof(double), 1, dest_file);
//====================
    int m_legend_width;
    bool m_show_legend;
    fwrite(&m_legend_width, sizeof(int), 1, dest_file);
    fwrite(&m_show_legend, sizeof(bool), 1, dest_file);
//====================
//	unsigned long m;
//	short short_temp[0xffff];
    FILE* data_file = fopen(m_file.c_str(),"rb");
//	if(sizeof(T) == sizeof(short))
//    {
	    while((j = fread(temp, sizeof(T), 0xffff, data_file)) != 0)
    		fwrite(temp, sizeof(T), j, dest_file);
//    }
//    else
//    {
//     	while((j = fread(temp, sizeof(T), 0xffff, data_file)) != 0)
//        {
//			for(m=0; m<j; m++) short_temp[m] = (short)(temp[m]*511);
//            fwrite(short_temp, sizeof(short), j, dest_file);
//        }
//    }
//====================
    fclose(data_file);
    fclose(dest_file);
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::ShowTabl(TComponent* AOwner)
{
    int i, j, k;
    unsigned short tmp_coords_mask[2];
    if(m_gridFrm == NULL)
    {
		SelCoord2 = new TSelCoord2(Application);
		m_GetAllVisibleCoords(tmp_coords_mask);
        SelCoord2->SetCaptions(m_labels, m_coords_mask, tmp_coords_mask);
		if(SelCoord2->ShowModal() == mrOk)
        {
            SelCoord2->GetCoordsToShow(tmp_coords_mask);
			for(i=0; i<2; i++) tmp_coords_mask[i] &= m_coords_mask[i];
			if((tmp_coords_mask[0]|tmp_coords_mask[1]) == 0) return;
			UpdateColPoints();
            int tmp_col_can = 0;
            for(j=0; j<2; j++)
	           	for(i=0; i<16; i++)
					if((tmp_coords_mask[j]>>i)&1) tmp_col_can++;
    		GridFrm = new TGridFrm(AOwner);
	        GridFrm->Grid->RowCount = col_points+1;
        	GridFrm->Grid->ColCount = tmp_col_can+1;
    	    k = 0;
        	for(j=0; j<2; j++)
		        for(i=0; i<16; i++)
        			if((tmp_coords_mask[j]>>i)&1)
            		{
	                	GridFrm->m_labels[k] = m_labels[j][i];
		                GridFrm->m_razmern[k] = m_razmern[j][i];
    		            GridFrm->m_base[k] = m_base[j][i];
        		        k++;
            		}
        	GridFrm->m_file = m_file;
            for(i=0; i<2; i++)
            {
	            GridFrm->m_coords_to_show[i] = tmp_coords_mask[i];
	            GridFrm->m_coords_mask[i] = m_coords_mask[i];
            }
	        GridFrm->col_can = col_can;
    	    GridFrm->m_tstep = elp_time/(col_points-1);
        	GridFrm->m_static = m_static;
	        m_gridFrm = GridFrm;
    	    GridFrm->Show();
		}
        delete SelCoord2;
    }
    else m_gridFrm->BringToFront();
}
//---------------------------------------------------------------------------

template <class T>
void __fastcall TGraph<T>::UpdateColPoints()
{
    int i, channel;
    for(i=0; i<2; i++)
    {
        m_col_can[i] = 0;
        for (channel=0; channel<16; channel++)
        	m_col_can[i] += (m_coords_mask[i]>>channel)&1;
    }
    m_funcs_pr = 0;
    for(i=0; i<8; i++) m_funcs_pr |= m_funcs[i][0];
    col_can = m_col_can[0] + m_col_can[1];
    FILE* tmp;
    if((col_can != 0)&&(tmp=fopen(m_file.c_str(),"rb"))!= NULL)
    {
    	col_points = filelength(fileno(tmp))/(sizeof(T)*col_can);
	    fclose(tmp);
    }
}
//---------------------------------------------------------------------------
typedef TGraph<short> TShortGraph;
typedef TGraph<double> TDoubleGraph;
#endif
