//---------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "graphunt.h"
#include "dselcord.h"
#include <clipbrd.hpp>
//---------------------------------------------------------------------
#pragma resource "*.dfm"
//---------------------------------------------------------------------
__fastcall TGraphFrm::TGraphFrm(TComponent *Owner)
	: TForm(Owner)
{
	mg = TRect(60,20,20,20);
//    m_graph.m_mg = TRect(-4*Font->Height, -3*Font->Height, -1.5*Font->Height, -2*Font->Height);
    m_FileName = "";
}
//---------------------------------------------------------------------
__fastcall TGraphFrm::~TGraphFrm()
{
}
//---------------------------------------------------------------------
void __fastcall TGraphFrm::FormClose(TObject *Sender, TCloseAction &Action)
{
    if((m_FileName == "")&&(FileExists(m_graph.m_file_orig)))
    {
		switch(Application->MessageBox("   ?", "Privod", MB_YESNOCANCEL))
        {
			case IDYES: 	if(SaveDialog1->Execute()) SaveToFile(SaveDialog1->FileName);
            				else {Action = caNone; break;}
            case IDNO: 		Action = caFree; break;
            case IDCANCEL:  Action = caNone; break;
        }
    }
    else Action = caFree;
}
//---------------------------------------------------------------------
void __fastcall TGraphFrm::FormPaint(TObject *Sender)
{
    MBase->Lines->Text = m_graph.m_BaseVals();
    MBase->ClearUndo();
	GraphPaintBox->Repaint();
    LegendPaintBox->Repaint();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::FormResize(TObject *Sender)
{
	Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::AGrNastExecute(TObject *Sender)
{
	m_graph.m_NastrDlg();
    Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::UpdateAll()
{
	if(m_graph.m_gridFrm)
	{
		((TGridFrm*)m_graph.m_gridFrm)->m_file = m_graph.m_file;
		((TGridFrm*)m_graph.m_gridFrm)->Grid->Invalidate();
	}
	Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::LoadFromFile(AnsiString FileName)
{
	m_graph.LoadFromFile(FileName);
    m_graph.UpdateColPoints();
    if(m_graph.m_static) Caption = "  [" + FileName + "]";
    else Caption = "  [" + FileName + "]";
    m_FileName = FileName;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::SaveToFile(AnsiString FileName)
{
	m_graph.SaveToFile(FileName);
    if(m_graph.m_static) Caption = "  [" + FileName + "]";
    else Caption = "  [" + FileName + "]";
    m_FileName = FileName;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ASaveExecute(TObject *Sender)
{
	if(m_FileName == "")
    {
    	if(SaveDialog1->Execute())
        {
			SaveToFile(SaveDialog1->FileName);
        }
    }
    else SaveToFile(m_FileName);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ASaveAsExecute(TObject *Sender)
{
	if(SaveDialog1->Execute())
	{
        SaveToFile(SaveDialog1->FileName);
	}
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ATableExecute(TObject *Sender)
{
	m_graph.ShowTabl(this);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::AHanningExecute(TObject *Sender)
{
	unsigned short coords[2];
	m_graph.m_GetAllVisibleCoords(coords);
	SelCoord = new TSelCoord(Application);
    SelCoord->SetCaptions(m_graph.m_labels, m_graph.m_coords_mask[0], coords[0]);
    if(SelCoord->ShowModal() == mrOk)
    {
		m_graph.m_Hanning(SelCoord->GetCoordsToFilter());
		UpdateAll();
    }
    delete SelCoord;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ASrKwadExecute(TObject *Sender)
{
	unsigned short coords[2];
	m_graph.m_GetAllVisibleCoords(coords);
	SelCoord = new TSelCoord(Application);
    SelCoord->SetCaptions(m_graph.m_labels, m_graph.m_coords_mask[0], coords[0]);
    if(SelCoord->ShowModal() == mrOk)
    {
		m_graph.m_SrKwad(SelCoord->GetCoordsToFilter());
		UpdateAll();
    }
    delete SelCoord;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::AViprExecute(TObject *Sender)
{
	unsigned short coords[2];
	m_graph.m_GetAllVisibleCoords(coords);
	SelCoord = new TSelCoord(Application);
    SelCoord->SetCaptions(m_graph.m_labels, m_graph.m_coords_mask[0], coords[0]);
    if(SelCoord->ShowModal() == mrOk)
    {
		m_graph.m_Vipr(SelCoord->GetCoordsToFilter());
		UpdateAll();
    }
    delete SelCoord;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::AExpSmoothExecute(TObject *Sender)
{
	unsigned short coords[2];
	m_graph.m_GetAllVisibleCoords(coords);
	SelCoord = new TSelCoord(Application);
    SelCoord->SetCaptions(m_graph.m_labels, m_graph.m_coords_mask[0], coords[0]);
    if(SelCoord->ShowModal() == mrOk)
    {
		m_graph.m_ExpSmooth(SelCoord->GetCoordsToFilter());
		UpdateAll();
    }
    delete SelCoord;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ASortExecute(TObject *Sender)
{
if(Application->MessageBox("    ","",MB_OKCANCEL|MB_ICONWARNING)==IDOK)
{
	ComboDlg = new TComboDlg(this);
    ComboDlg->Label1->Visible = true;		ComboDlg->Label2->Visible = false;
    ComboDlg->ComboBox1->Visible = true;	ComboDlg->ComboBox2->Visible = false;
    ComboDlg->Label1->Caption = ".";
    TStringList* strs = new TStringList();
    strs->Clear();
    for(int i=0; i<2; i++)
	    for(int channel=0; channel<16; channel++)
    		if ((m_graph.m_coords_mask[i]>>channel)&1)
            	strs->Add(((TMainForm*)MainForm)->m_labels[i][channel]);
    ComboDlg->ComboBox1->Items->Assign(strs);
    ComboDlg->ComboBox1->ItemIndex = 0;
	if(ComboDlg->ShowModal() == mrOk)
    {
		m_graph.m_Sort((short)ComboDlg->ComboBox1->ItemIndex);
    	UpdateAll();
    }
    delete strs;
    delete ComboDlg;
}
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::APrintExecute(TObject *Sender)
{
    Printer()->Title = Caption;
    Printer()->BeginDoc();
    TRect pr_mg;
    TRect gr_mg;
    pr_mg.Left = (double)((TMainForm*)MainForm)->PageSetupDialog->Margins->Left/
    	(double)((TMainForm*)MainForm)->PageSetupDialog->PaperSize->X*(double)Printer()->PageWidth;
    pr_mg.Right = (double)((TMainForm*)MainForm)->PageSetupDialog->Margins->Right/
    	(double)((TMainForm*)MainForm)->PageSetupDialog->PaperSize->X*(double)Printer()->PageWidth;
    pr_mg.Top = (double)((TMainForm*)MainForm)->PageSetupDialog->Margins->Top/
    	(double)((TMainForm*)MainForm)->PageSetupDialog->PaperSize->Y*(double)Printer()->PageHeight;
    pr_mg.Bottom = (double)((TMainForm*)MainForm)->PageSetupDialog->Margins->Bottom/
    	(double)((TMainForm*)MainForm)->PageSetupDialog->PaperSize->Y*(double)Printer()->PageHeight;
    gr_mg.Left   = (double)mg.Left/(double)ClientWidth*(double)Printer()->PageWidth;
    gr_mg.Right  = (double)mg.Right/(double)ClientWidth*(double)Printer()->PageWidth;
    gr_mg.Top 	 = (double)mg.Top/(double)ClientHeight*(double)Printer()->PageHeight;
    gr_mg.Bottom = (double)mg.Bottom/(double)ClientHeight*(double)Printer()->PageHeight;

    TPoint legend_wh;
    TPoint graphs_wh;
    TPoint base_wh;
    TPoint captn_wh;
    TPoint wh;
    wh.x = Printer()->PageWidth-(pr_mg.Right+pr_mg.Left);
    wh.y = Printer()->PageHeight-(pr_mg.Bottom+pr_mg.Top);
    legend_wh.x = (double)wh.x*(1-(double)Splitter_legend->Left/(double)ClientWidth);
	legend_wh.y = (double)wh.y*(double)Splitter_caption->Top/(double)ClientHeight;
    graphs_wh.x = (double)wh.x*(double)Splitter_legend->Left/(double)ClientWidth;
	graphs_wh.y = (double)wh.y*(double)Splitter_base->Top/(double)ClientHeight;
    base_wh.x 	= (double)wh.x*(double)Splitter_legend->Left/(double)ClientWidth;
	base_wh.y 	= (double)wh.y*(double)(Splitter_caption->Top-Splitter_base->Top)/ClientHeight;
    captn_wh.x 	= wh.x;
	captn_wh.y 	= (double)wh.y*(1-(double)Splitter_caption->Top/(double)ClientHeight);

    m_graph.m_Draw(Printer()->Canvas, legend_wh, graphs_wh, base_wh, captn_wh, pr_mg, gr_mg);

	TFont* oldFont = new TFont();
    TRect BaseRect  = TRect(pr_mg.Left, pr_mg.Top+graphs_wh.y, pr_mg.Left+base_wh.x, pr_mg.Top+graphs_wh.y+base_wh.y);
    TRect CaptnRect = TRect(pr_mg.Left, pr_mg.Top+graphs_wh.y+base_wh.y, pr_mg.Left+captn_wh.x, pr_mg.Top+graphs_wh.y+base_wh.y+captn_wh.y);
    oldFont->Assign(Printer()->Canvas->Font);
    Printer()->Canvas->Font->Assign(MBase->Font);
	DrawText(Printer()->Canvas->Handle, MBase->Lines->Text.c_str(), MBase->Lines->Text.Length(), &BaseRect, DT_CENTER|DT_WORDBREAK);
    Printer()->Canvas->Font->Assign(MCaption->Font);
	DrawText(Printer()->Canvas->Handle, MCaption->Lines->Text.c_str(), MCaption->Lines->Text.Length(), &CaptnRect, DT_CENTER|DT_WORDBREAK);
    Printer()->Canvas->Font->Assign(oldFont);
    delete oldFont;
    Printer()->EndDoc();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::GraphPaintBoxPaint(TObject *Sender)
{
    TRect clRect = GraphPaintBox->ClientRect;
    TCanvas* Canvas = GraphPaintBox->Canvas;
    m_graph.UpdateColPoints();
	m_graph.m_Setka(Canvas, clRect, mg);
	m_graph.m_Osi(Canvas, clRect, mg);
	m_graph.m_NullOsi(Canvas, clRect, mg);
	m_graph.m_Text(Canvas, clRect, mg);
	m_graph.m_Labels(Canvas, clRect, mg);
	TRect graphsRect(GraphPaintBox->BoundsRect.Left+mg.Left,
    				 GraphPaintBox->BoundsRect.Top+mg.Top,
                     GraphPaintBox->BoundsRect.Right-mg.Right,
                     GraphPaintBox->BoundsRect.Bottom-mg.Bottom);
	SelectClipRgn(Canvas->Handle,CreateRectRgnIndirect(&graphsRect));
	m_graph.m_DrawData(Canvas, clRect, mg);
    graphsRect = GraphPaintBox->BoundsRect;
    SelectClipRgn(Canvas->Handle,CreateRectRgnIndirect(&graphsRect));
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::LegendPaintBoxPaint(TObject *Sender)
{
	m_graph.m_Legend(LegendPaintBox->Canvas, LegendPaintBox->ClientRect);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::GraphPaintBoxMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	m_graph.MouseDown(Button, Shift, X, Y, GraphPaintBox->Canvas, GraphPaintBox->ClientRect, mg);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::GraphPaintBoxMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
	m_graph.MouseMove(Shift, X, Y, GraphPaintBox->Canvas, GraphPaintBox->ClientRect, mg);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::GraphPaintBoxMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if(m_graph.MouseUp(Button, Shift, X, Y, GraphPaintBox->Canvas, GraphPaintBox->ClientRect, mg))
    	Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::SelFontBaseClick(TObject *Sender)
{
	FontDialog->Font->Assign(MBase->Font);
    if(FontDialog->Execute())
    	MBase->Font->Assign(FontDialog->Font);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::SelFontCaptionClick(TObject *Sender)
{
	FontDialog->Font->Assign(MCaption->Font);
    if(FontDialog->Execute())
    	MCaption->Font->Assign(FontDialog->Font);
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ACopyExecute(TObject *Sender)
{
    Application->ProcessMessages();
	Graphics::TBitmap *FormImage = GetFormImage();
	Clipboard()->Assign(FormImage);
    delete FormImage;
}
//---------------------------------------------------------------------------
//-------- TGraphBlock ------------------------------------------------------
//---------------------------------------------------------------------------
__fastcall TGraphBlk::TGraphBlk(TForm* ParentForm)
        : TBlock(ParentForm)
{
	int i, j;
    for(j=0; j<2; j++)
	    for(i=0; i<16; i++)
    	{
        	m_graph.m_labels[j][i] 	= " " + IntToStr(i+1);
	        m_graph.m_razmern[j][i] 	= "";
    	    m_graph.m_base[j][i] 		= 1;
        	m_graph.m_real_base[j][i] 	= 1;
	    }
//    m_graph.m_mg = TRect(-4*Font->Height+7, -2*Font->Height+17, -1.5*Font->Height, -2*Font->Height);
//    m_graph.m_IniPath = ((TMainForm*)MainForm)->m_ini_name;
    m_graph.m_file = _tempnam("","Prv");
    m_graph.m_file_orig = m_graph.m_file;
    m_graph.m_file_filter = m_graph.m_file + "f";
//    m_graph.m_show_legend = false;
//    m_graph.m_show_base = false;
//    m_graph.m_show_caption = false;
    m_graph.m_col_del = TPoint(4,4);
    m_graph.max_val = 1;
	SetBounds(20,20,300,200);
    CountIn = 16;
    CountOut = 0;
    for(i=0; i<CountIn; i++)
    {
    	m_Inp[i] = TPoint(5,Height*(i+1)/(CountIn+1));
    	m_selIn[i] = false;
    }
    m_type = t_graph;
    m_blk_type = b_graph;
    m_have_in = true;
    m_have_out = false;
    m_resize = false;
   	FILE* data_file = NULL;
    if(m_graph.m_file != NULL) data_file = fopen(m_graph.m_file.c_str(),"wb");
    if(data_file != NULL) fclose(data_file);
}
//---------------------------------------------------------------------------
__fastcall TGraphBlk::~TGraphBlk()
{
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::Paint()
{
/////////////////////////////////////////////////////////////////////////////
    int i;
	TColor pen_color = Canvas->Pen->Color;
    TColor brush_color = Canvas->Brush->Color;
    Canvas->Pen->Color = clRed;
    Canvas->Brush->Color = clWhite;
    Canvas->Rectangle(7,0,Width,Height);
	Canvas->Pen->Color = clActiveCaption;
	Canvas->Rectangle(7,0,Width,19);
	Canvas->Brush->Color = clBtnFace;
    Canvas->Pen->Color = clBlack;
  	Canvas->Rectangle(Width-17,2,Width-2,17);
    Canvas->Pen->Color = clRed;
    if(Align == alNone)	Canvas->Rectangle(Width-15,4,Width-4,15);
    else Canvas->Rectangle(Width-12,7,Width-7,12);
	Canvas->Pen->Color = clActiveCaption;
	Canvas->Brush->Color = clActiveCaption;
    Canvas->Rectangle(9,2,Width-19,17);
    for(i=0; i<CountIn; i++)
    {
	    Canvas->Pen->Color = (TColor)m_graph.m_color[0][i];
    	Canvas->Brush->Color = (TColor)m_graph.m_color[0][i];
    	DrawInOut(m_Inp[i],m_selIn[i]);
    }
    Canvas->Pen->Color = pen_color;
    Canvas->Brush->Color = brush_color;
/////////////////////////////////////////////////////////////////////////////
    TRect mg = TRect(7,19,0,0);
    TRect gr_mg = TRect(50,10,20,25);
    TPoint wh = TPoint(ClientWidth,ClientHeight);
    TPoint legend_wh = TPoint(0,0);
    TPoint graphs_wh = TPoint(wh.x-(mg.Left+mg.Right),wh.y-(mg.Top+mg.Bottom));
    TPoint base_wh = TPoint(0,0);
    TPoint captn_wh = TPoint(0,0);
    m_graph.m_Draw(Canvas, legend_wh, graphs_wh, base_wh, captn_wh, mg, gr_mg);
/////////////////////////////////////////////////////////////////////////////
    if(m_sel) InvertRect(Canvas->Handle,&TRect(8,20,Width-1,Height-1));
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::DblClick()
{
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::m_Print()
{
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::MouseDown(TMouseButton Button, TShiftState Shift, int X, int Y)
{
    if(Button == mbRight)
    {
     	m_graph.m_NastrDlg();
        Invalidate();
    }
	else if(Button == mbLeft)
    {
		if(Align == alNone)
        {
		    if((X>(Width-7))&&(X<Width)&&(Y>(Height-7))&&(Y<Height))
    		{
    			m_XY.x = X;	m_XY.y = Y;
	        	m_resize = true;
    		}
		    else if((X>(Width-17))&&(X<(Width-2))&&(Y<17)&&(Y>2))
    		{
    			m_place.Left = Left;			m_place.Top = Top;
		        m_place.Right = Left + Width;	m_place.Bottom = Top + Height;
    		    BringToFront();			        Align = alClient;
	    	}
	    	else TBlock::MouseDown(Button, Shift, X, Y);
        }
    	else
		{
			if((X>(Width-17))&&(X<(Width-2))&&(Y<17)&&(Y>2))
            {
	    		Align = alNone;
	    	    BoundsRect = m_place;
            }
	        else if((X>7)&&(Y>19))
    	    {
//				m_graph.Client = TPoint(ClientWidth, ClientHeight);
//    			m_graph.MouseDown(Button, Shift, X, Y, Canvas);
	        }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::MouseUp(TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if((m_resize)&&(Align == alNone))
    {
    	if(X<(m_XY.x + 40 - Width)) X = m_XY.x + 40 - Width;
        if(Y<(m_XY.y + (16*Canvas->TextHeight("1")) - Height)) Y = m_XY.y + (16*Canvas->TextHeight("1")) - Height;
        SetBounds(Left, Top, Width+(X-m_XY.x), Height+(Y-m_XY.y));
        m_resize = false;
    }
//    else if((((X>9)&&(X<(Width-19))&&(Y<17)&&(Y>2))||(X<7))&&(Align == alNone))
    else if(Align == alNone)
    	TBlock::MouseUp(Button, Shift, X, Y);
    else
    {
//		m_graph.Client = TPoint(ClientWidth, ClientHeight);
//	    if(m_graph.MouseUp(Button, Shift, X, Y, Canvas)) Invalidate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::MouseMove(TShiftState Shift, int X, int Y)
{
	m_SetCursor(X, Y);
    if(Align == alNone)
		TBlock::MouseMove(Shift, X, Y);
    else
    {
//		m_graph.Client = TPoint(ClientWidth, ClientHeight);
//	    m_graph.MouseMove(Shift, X, Y, Canvas);
    }
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::m_SetCursor(int X, int Y)
{
	if((X>(Width-7))&(Y>(Height-7))&(Align == alNone)) Cursor = crSizeNWSE;
    else TBlock::m_SetCursor(X, Y);
}
//---------------------------------------------------------------------------

void __fastcall TGraphBlk::m_Nastr()
{
//
}
//---------------------------------------------------------------------------



void __fastcall TGraphFrm::AShowFilteredExecute(TObject *Sender)
{
	if(m_graph.m_file == m_graph.m_file_orig) m_graph.m_file = m_graph.m_file_filter;
    else m_graph.m_file = m_graph.m_file_orig;
    Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::AShowFilteredUpdate(TObject *Sender)
{
	TAction* pa = dynamic_cast<TAction*>(Sender);
	if(pa)
    {
    	pa->Enabled = m_graph.m_filtered;
		if(pa->Enabled)
        {
	    	pa->Checked = (m_graph.m_file == m_graph.m_file_filter);
        }
        else pa->Checked = false;
    }
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ASaveFilteredExecute(TObject *Sender)
{
if(Application->MessageBox("      ",
							"  ",MB_OKCANCEL|MB_ICONWARNING)==IDOK)
{
	m_graph.m_SaveFiltered();
    Invalidate();
}
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::ASaveFilteredUpdate(TObject *Sender)
{
	TAction* pa = dynamic_cast<TAction*>(Sender);
	if(pa) pa->Enabled = m_graph.m_filtered;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::NonStaticFilterUpdate(TObject *Sender)
{
	TAction* pa = dynamic_cast<TAction*>(Sender);
	if(pa) pa->Visible = !m_graph.m_static;
}
//---------------------------------------------------------------------------

void __fastcall TGraphFrm::StaticFilterUpdate(TObject *Sender)
{
	TAction* pa = dynamic_cast<TAction*>(Sender);
	if(pa) pa->Visible = m_graph.m_static;
}
//---------------------------------------------------------------------------

