//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "scanthr.h"
#include "Main.h"
#include "perehdlg.h"
#include "asmcode.h"
#include <stdio.h>
#pragma package(smart_init)
//---------------------------------------------------------------------------
//   Important: Methods and properties of objects in VCL can only be
//   used in a method called using Synchronize, for example:
//
//      Synchronize(UpdateCaption);
//
//   where UpdateCaption could look like:
//
//      void __fastcall TScanThr::UpdateCaption()
//      {
//        Form1->Caption = "Updated in a thread";
//      }
//---------------------------------------------------------------------------
__fastcall TScanThr::TScanThr(bool CreateSuspended)
	: TThread(CreateSuspended)
{
	dlg = NULL;
}
//---------------------------------------------------------------------------
void __fastcall TScanThr::Execute()
{
Synchronize(SetWaitCursor);
try
{
	SetPriorityClass(GetCurrentProcess(), ((TMainForm*)MainForm)->ScanPriorClass);
	SetThreadPriority(GetCurrentThread(), ((TMainForm*)MainForm)->ScanThreadPrior);
    FILE* data_file = fopen(m_file.c_str(),"wb");
    unsigned short channel, i, col_can_CAP = (short)((TMainForm*)MainForm)->m_col_can_CAP;
	((TMainForm*)MainForm)->ResetCAP();
    for(channel=0; channel<col_can_CAP; channel++)
    	m_send_CAP[channel] = (m_coords_mask[1] >> channel)& 1;
//==========================================================================
    short tmp[32];
    short CAP_tmp[16];
    for(i=0; i<16; i++) CAP_tmp[i] = 0;
    unsigned long nagr_clock[16];
	double zi_step[16];
	for(i=0; i<col_can_CAP; i++)
    {
        if(m_val_CAP[i] == 0) m_send_CAP[i] = false;
        else
        {
		    nagr_clock[i] = (unsigned int)(m_nagr_time[i]*1000);
    	    if(m_zi_time[i] != 0)
	    	    zi_step[i] = (((TMainForm*)MainForm)->m_real_base[1][i]/((TMainForm*)MainForm)->m_base[1][i])
                *511/(m_zi_time[i]*1000)*(m_val_CAP[i]/abs(m_val_CAP[i]));
	        else zi_step[i] = 1024;
        }
    }
    rewind(data_file);
    col_points = 0;
    req_clock = (unsigned int)(m_req_time*1000);
    end_clock = 0;
	beg_clock = GetTickCount();

	while((!Terminated)&&(end_clock<req_clock))
	{
		if(m_auto)
		{
            for(channel=0; channel<col_can_CAP; channel++)
            {
				if(m_send_CAP[channel])
                {
                	if(end_clock > nagr_clock[channel])
		            {
    		        	CAP_tmp[channel] = (short)(zi_step[channel]*(double)(end_clock-nagr_clock[channel]));
                        if(abs(CAP_tmp[channel]) >= abs(m_val_CAP[channel]))
                        {
	    		        	CAP_tmp[channel] = m_val_CAP[channel];
	            		    m_send_CAP[channel] = false;
                        }
        		        SendCAP(channel, (short)(CAP_tmp[channel] + m_offs_CAP[channel]));
	            	}
                }
            }
        }
        i = 0;
        for(channel=0; channel<16; channel++)
        {
        	if ((m_coords_mask[0] >> channel)& 1)
            {
            	tmp[i] = (short)(GetACP(channel) + m_offs_ACP[channel]);
                i++;
            }
        }
        for(channel=0; channel<col_can_CAP; channel++)
        {
        	if ((m_coords_mask[1] >> channel)& 1)
            {
		        tmp[i] = CAP_tmp[channel];
                i++;
            }
        }
        fwrite(tmp, 2, i, data_file);
        end_clock = GetTickCount() - beg_clock;
        col_points++;
    }
    fclose(data_file);
//==========================================================================
    Synchronize(DisableStop);
    ((TMainForm*)MainForm)->ResetCAP(CAP_tmp);
	SetPriorityClass(GetCurrentProcess(), ((TMainForm*)MainForm)->AppPriorClass);
	SetThreadPriority(GetCurrentThread(), ((TMainForm*)MainForm)->AppThreadPrior);
}
__finally
{
	Synchronize(RestoreCursor);
}
}
//---------------------------------------------------------------------------
void __fastcall TScanThr::DisableStop()
{
    if(dlg) ((TPerDlg*)dlg)->Button3->Enabled = false;
}
//---------------------------------------------------------------------------
void __fastcall TScanThr::SetWaitCursor()
{
	Save_Cursor = Screen->Cursor;
	Screen->Cursor = crHourGlass;
}
//---------------------------------------------------------------------------
void __fastcall TScanThr::RestoreCursor()
{
	Screen->Cursor = Save_Cursor;
}
//---------------------------------------------------------------------------
