//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "statdlg.h"
#include "asmcode.h"
#include "Main.h"
#include "selcombo.h"
#include "stnastr.h"
#include "AStDlg.h"
#include <registry.hpp>
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TStaticDlg *StaticDlg;
//---------------------------------------------------------------------------

__fastcall TStaticDlg::TStaticDlg(TComponent* Owner)
	: TForm(Owner)
{
	m_file = _tempnam("","PrSt");
	m_col_points = 0;
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::ASavePointExecute(TObject *Sender)
{
    m_SavePoint();
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::m_SavePoint()
{
TCursor Save_Cursor = Screen->Cursor;
Screen->Cursor = crHourGlass;
try
{
	SetPriorityClass(GetCurrentProcess(),((TMainForm*)MainForm)->ScanPriorClass);
	SetThreadPriority(GetCurrentThread(),((TMainForm*)MainForm)->ScanThreadPrior);
	unsigned short coords, channel, i, col_can = 16, col_can_CAP = (short)((TMainForm*)MainForm)->m_col_can_CAP;
	short m_filter_mask = ((TMainForm*)MainForm)->m_filter_mask;
	unsigned long clock_beg, req_clock;
	unsigned long col_points = 0;
	double tmp_double[16];
	short tmp_short[18];
    for(channel=0; channel<16; channel++)
    {
     	tmp_double[channel] = 0;
        tmp_short[channel] = 0;
    }
	coords = 0xffff;
	req_clock = (int)(1*1000);
	clock_beg = GetTickCount();
	do {
		for(channel=0; channel<16; channel++)
		{
			if((coords >> channel)& 1)
			{
				tmp_short[channel] = (short)(GetACP(channel) + ((TMainForm*)MainForm)->m_offset[0][channel]);
				if((m_filter_mask >> channel)& 1) tmp_double[channel] += (tmp_short[channel]*tmp_short[channel]);
                else tmp_double[channel] += tmp_short[channel];
			}
		}
		col_points++;
	} while((GetTickCount()-clock_beg) < req_clock);
	i = 0;
	for(channel=0; channel<16; channel++)
	{
		if((coords >> channel)& 1)
		{
			if((m_filter_mask >> channel)& 1) tmp_short[i] = (short)sqrt((double)(tmp_double[channel]/col_points));
			else tmp_short[i] = (short)(tmp_double[channel]/col_points);
			i++;
		}
	}
	for(channel=0; channel<col_can_CAP; channel++) tmp_short[16+channel] = CAP_val[channel];
	FILE* static_file = fopen(m_file.c_str(),"a+b");
	fwrite(tmp_short,2,col_can+col_can_CAP,static_file);
    fclose(static_file);

    for(int j=0; j<16; j++)
    	StringGrid1->Cells[j][StringGrid1->RowCount-1] = FloatToStrF((double)tmp_short[j]/511*((TMainForm*)MainForm)->m_base[0][j],ffFixed,10,3);
    for(int j=0; j<col_can_CAP; j++)
    	StringGrid1->Cells[j+16][StringGrid1->RowCount-1] = FloatToStrF((double)tmp_short[j+16]/511*((TMainForm*)MainForm)->m_base[1][j],ffFixed,10,3);
	m_col_points++;
	StringGrid1->RowCount++;
    StringGrid1->Row = StringGrid1->RowCount-1;
	SetPriorityClass(GetCurrentProcess(),((TMainForm*)MainForm)->AppPriorClass);
	SetThreadPriority(GetCurrentThread(),((TMainForm*)MainForm)->AppThreadPrior);
}
__finally
{
	Screen->Cursor = Save_Cursor;
}
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::FormShow(TObject *Sender)
{
	m_SetCaptions();
    PaintBox1->Invalidate();
    clock_beg = GetTickCount();
	TrackBar1->Min = -((TMainForm*)MainForm)->m_offset[1][0];
	TrackBar1->Max = 1022 + TrackBar1->Min;
    TrackBar1->Position = 0;
    CAP_val[0] = 0;
	TrackBar2->Min = -((TMainForm*)MainForm)->m_offset[1][1];
	TrackBar2->Max = 1022 + TrackBar2->Min;
    TrackBar2->Position = 0;
    CAP_val[1] = 0;
    TrackBar1->OnChange(NULL);//TrackBar1Change(NULL);
    TrackBar2->OnChange(NULL);//TrackBar2Change(NULL);
	((TMainForm*)MainForm)->ResetCAP(CAP_val);
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::m_SetCaptions()
{
	int i;
	for(i=0; i<16; i++)
	{
     	if(((TMainForm*)MainForm)->m_razmern[0][i] == "") StringGrid1->Cells[i][0] = ((TMainForm*)MainForm)->m_labels[0][i];
     	else StringGrid1->Cells[i][0] = ((TMainForm*)MainForm)->m_labels[0][i]+", "+((TMainForm*)MainForm)->m_razmern[0][i];
	}
	for(i=0; i<(((TMainForm*)MainForm)->m_col_can_CAP); i++)
	{
     	if(((TMainForm*)MainForm)->m_razmern[1][i] == "") StringGrid1->Cells[i+16][0] = ((TMainForm*)MainForm)->m_labels[1][i];
     	else StringGrid1->Cells[i+16][0] = ((TMainForm*)MainForm)->m_labels[1][i]+", "+((TMainForm*)MainForm)->m_razmern[1][i];
	}
    Label1->Caption = ((TMainForm*)MainForm)->m_labels[1][0];// + ", " + ((TMainForm*)MainForm)->m_razmern[1][0];
    Label2->Caption = ((TMainForm*)MainForm)->m_labels[1][1];// + ", " + ((TMainForm*)MainForm)->m_razmern[1][1];
    ERazm1->Text = ((TMainForm*)MainForm)->m_razmern[1][0];
    ERazm2->Text = ((TMainForm*)MainForm)->m_razmern[1][1];

}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::TrackBar1ChangeComplex(TObject *Sender)
{
    TrackBar1->OnChange = NULL;
    unsigned long beg_clock;
    int CAP_prv = CAP_val[0];
    CAP_val[0] = (short)TrackBar1->Position;
    double zi_step;
    if(((TMainForm*)MainForm)->m_Tzi > 0)
    {
        zi_step = ((TMainForm*)MainForm)->m_real_base[1][0]/
            ((TMainForm*)MainForm)->m_base[1][0]*511/(((TMainForm*)MainForm)->m_Tzi*1000);
        if(CAP_prv > CAP_val[0]) zi_step *= -1;
    }
    else zi_step = 1024;
    if(CAP_prv < CAP_val[0])
    {
        TrackBar1->SelStart = CAP_prv;
        TrackBar1->SelEnd = CAP_val[0];
    }
    else
    {
        TrackBar1->SelStart = CAP_val[0];
        TrackBar1->SelEnd = CAP_prv;
    }
	beg_clock = GetTickCount();
    TrackBar1->Position = CAP_prv;
    while(TrackBar1->Position != CAP_val[0])
    {
        CAP_tmp[0] = (short)(CAP_prv+zi_step*(GetTickCount()-beg_clock));
        if((CAP_prv < CAP_val[0])&&(CAP_tmp[0] > CAP_val[0])) CAP_tmp[0] = CAP_val[0];
        else if((CAP_prv > CAP_val[0])&&(CAP_tmp[0] < CAP_val[0])) CAP_tmp[0] = CAP_val[0];
        TrackBar1->Position = CAP_tmp[0];
    	SendCAP(0,(short)(CAP_tmp[0]+((TMainForm*)MainForm)->m_offset[1][0]));
        Edit1->Text = FloatToStrF((double)CAP_tmp[0]/511*((TMainForm*)MainForm)->m_base[1][0],ffFixed,10,2);
        Application->ProcessMessages();
    }
    TrackBar1->SelStart = 0;
    TrackBar1->SelEnd = 0;
    TrackBar1->OnChange = TrackBar1ChangeComplex;
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::TrackBar2ChangeComplex(TObject *Sender)
{
    TrackBar2->OnChange = NULL;
    unsigned long beg_clock;
    int CAP_prv = CAP_val[1];
    CAP_val[1] = (short)TrackBar2->Position;
    double zi_step;
    if(((TMainForm*)MainForm)->m_Tzi > 0)
    {
        zi_step = ((TMainForm*)MainForm)->m_real_base[1][1]/
            ((TMainForm*)MainForm)->m_base[1][1]*511/(((TMainForm*)MainForm)->m_Tzi*1000);
        if(CAP_prv > CAP_val[1]) zi_step *= -1;
    }
    else zi_step = 1024;
    if(CAP_prv < CAP_val[1])
    {
        TrackBar2->SelStart = CAP_prv;
        TrackBar2->SelEnd = CAP_val[1];
    }
    else
    {
        TrackBar2->SelStart = CAP_val[1];
        TrackBar2->SelEnd = CAP_prv;
    }
	beg_clock = GetTickCount();
    TrackBar2->Position = CAP_prv;
    while(TrackBar2->Position != CAP_val[1])
    {
        CAP_tmp[1] = (short)(CAP_prv+zi_step*(GetTickCount()-beg_clock));
        if((CAP_prv < CAP_val[1])&&(CAP_tmp[1] > CAP_val[1])) CAP_tmp[1] = CAP_val[1];
        else if((CAP_prv > CAP_val[1])&&(CAP_tmp[1] < CAP_val[1])) CAP_tmp[1] = CAP_val[1];
        TrackBar2->Position = CAP_tmp[1];
    	SendCAP(1,(short)(CAP_tmp[1]+((TMainForm*)MainForm)->m_offset[1][1]));
        Edit2->Text = FloatToStrF((double)CAP_tmp[1]/511*((TMainForm*)MainForm)->m_base[1][1],ffFixed,10,2);
        Application->ProcessMessages();
    }
    TrackBar2->SelStart = 0;
    TrackBar2->SelEnd = 0;
    TrackBar2->OnChange = TrackBar2ChangeComplex;
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::TrackBar1ChangeSimple(TObject *Sender)
{
    CAP_val[0] = (double)TrackBar1->Position;
    SendCAP(0,(short)(CAP_val[0]+((TMainForm*)MainForm)->m_offset[1][0]));
    Edit1->Text = FloatToStrF((double)CAP_val[0]/511*((TMainForm*)MainForm)->m_base[1][0],ffFixed,10,2);
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::TrackBar2ChangeSimple(TObject *Sender)
{
    CAP_val[1] = (double)TrackBar2->Position;
    SendCAP(1,(short)(CAP_val[1]+((TMainForm*)MainForm)->m_offset[1][1]));
    Edit2->Text = FloatToStrF((double)CAP_val[1]/511*((TMainForm*)MainForm)->m_base[1][1],ffFixed,10,2);
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::TimerBgTimer(TObject *Sender)
{
	if((GetTickCount()-clock_beg)>30000)
	{
		PaintBox1->Invalidate();
	    clock_beg = GetTickCount();
	}
	int x = (double)(GetTickCount()-clock_beg)/30000*PaintBox1->Width;
	double ACP1_val = (double)/*CAP_tmp[0]/511;//*/(GetACP(coords_to_show[0]) + ((TMainForm*)MainForm)->m_offset[0][coords_to_show[0]])/511;
	double ACP2_val = (double)/*CAP_tmp[1]/511;//*/(GetACP(coords_to_show[1]) + ((TMainForm*)MainForm)->m_offset[0][coords_to_show[1]])/511;
	int y1 = (1-ACP1_val)*PaintBox1->Height/2;
	int y2 = (1-ACP2_val)*PaintBox1->Height/2;
	Label3->Caption = ((TMainForm*)MainForm)->m_labels[0][coords_to_show[0]]
    + " = " + FloatToStrF(ACP1_val*((TMainForm*)Owner)->m_base[0][coords_to_show[0]],ffFixed,10,3)
    + " " + ((TMainForm*)MainForm)->m_razmern[0][coords_to_show[0]];
	Label4->Caption = ((TMainForm*)MainForm)->m_labels[0][coords_to_show[1]]
    + " = " + FloatToStrF(ACP2_val*((TMainForm*)Owner)->m_base[0][coords_to_show[1]],ffFixed,10,3)
    + " " + ((TMainForm*)MainForm)->m_razmern[0][coords_to_show[1]];
	PaintBox1->Canvas->Pixels[x][y1] = clRed;
	PaintBox1->Canvas->Pixels[x][y2] = clLime;
    if(ChBStartFromStend->Enabled && ChBStartFromStend->Checked && CheckStartBtn()) m_SavePoint();
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::PaintBox1Paint(TObject *Sender)
{
    PaintBox1->Canvas->Pen->Color = clGreen;
	PaintBox1->Canvas->Rectangle(0,0,PaintBox1->Width,PaintBox1->Height);
    PaintBox1->Canvas->MoveTo(0,PaintBox1->Height/2);
    PaintBox1->Canvas->LineTo(PaintBox1->Width,PaintBox1->Height/2);
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::PaintBox1MouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if(Button == mbRight)
    {
     	ComboDlg = new TComboDlg(this);
        ComboDlg->Label1->Visible = true;		ComboDlg->Label2->Visible = true;
        ComboDlg->ComboBox1->Visible = true;	ComboDlg->ComboBox2->Visible = true;
        ComboDlg->Label1->Caption = ".1";
        ComboDlg->Label2->Caption = ".2";
	    TStringList* strs = new TStringList();
    	strs->Clear();
        for(int channel=0; channel<16; channel++)
			strs->Add(((TMainForm*)MainForm)->m_labels[0][channel]);
        ComboDlg->ComboBox1->Items = strs;
        ComboDlg->ComboBox2->Items = strs;
        ComboDlg->ComboBox1->ItemIndex = coords_to_show[0];
        ComboDlg->ComboBox2->ItemIndex = coords_to_show[1];
        if(ComboDlg->ShowModal() == mrOk)
        {
			coords_to_show[0] = (short)ComboDlg->ComboBox1->ItemIndex;
			coords_to_show[1] = (short)ComboDlg->ComboBox2->ItemIndex;
            SaveIniFile();
        }
        delete strs;
        delete ComboDlg;
    }
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	((TMainForm*)MainForm)->ResetCAP(CAP_val);
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::AStNastrExecute(TObject *Sender)
{
	StatNastr = new TStatNastr(this);
    StatNastr->SetCaptions();
	StatNastr->m_filter_mask = ((TMainForm*)MainForm)->m_filter_mask;
    StatNastr->UpdateFields();

    if(StatNastr->ShowModal() == mrOk)
    {
    	StatNastr->SaveFields();
		((TMainForm*)MainForm)->m_filter_mask = StatNastr->m_filter_mask;
    }
    delete StatNastr;
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::ReadIniFile()
{
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
	coords_to_show[0] = (short)RegFile->ReadInteger("  (defaults)"," 1",5);
	coords_to_show[1] = (short)RegFile->ReadInteger("  (defaults)"," 2",6);
    ChBStartFromStend->Checked = RegFile->ReadBool("  (defaults)","  ",true);
    delete RegFile;
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::SaveIniFile()
{
	TIniFile* RegFile = new TIniFile(((TMainForm*)MainForm)->m_ini_name);
	RegFile->WriteInteger("  (defaults)"," 1",coords_to_show[0]);
	RegFile->WriteInteger("  (defaults)"," 2",coords_to_show[1]);
    RegFile->WriteBool("  (defaults)","  ",ChBStartFromStend->Checked);
    delete RegFile;
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::AAutoStartExecute(TObject *Sender)
{
    if(AAutoStart->Caption == "")
    {
        AutoStatDlg = new TAutoStatDlg(this);
        AutoStatDlg->SetCaptions();
        AutoStatDlg->ReadIniFile();
        AutoStatDlg->UpdateFields();
        if(AutoStatDlg->ShowModal() == mrOk)
        {
            AutoStatDlg->SaveFields();
            m_CAP_index = AutoStatDlg->TabControl->TabIndex;
            if((AutoStatDlg->m_kol[m_CAP_index] != 0)&&
               (AutoStatDlg->m_shag_vrem[m_CAP_index] != 0)&&
               ((AutoStatDlg->m_kon_zn[m_CAP_index]-AutoStatDlg->m_nach_zn[m_CAP_index]) != 0))
            {
                AutoStatDlg->SaveIniFile();
                m_auto_beg = AutoStatDlg->m_nach_zn[m_CAP_index];
                m_auto_end = AutoStatDlg->m_kon_zn[m_CAP_index];
                m_auto_step = (m_auto_end-m_auto_beg)/(double)(AutoStatDlg->m_kol[m_CAP_index]-1);
                m_auto_time_step = AutoStatDlg->m_shag_vrem[m_CAP_index];
                m_auto_finish = false;
                AAutoStart->Caption = "";
                BitBtn1->Enabled = false;
                BitBtn2->Enabled = false;
                Button3->Enabled = false;
                ChBStartFromStend->Enabled = false;
                TTrackBar* Bar;
                switch(m_CAP_index)
                {
                    case 0: Bar = TrackBar1; break;
                    case 1: Bar = TrackBar2; break;
                }
                Bar->Enabled = false;
                switch(m_CAP_index)
                {
                    case 0: Bar->OnChange = TrackBar1ChangeComplex; break;
                    case 1: Bar->OnChange = TrackBar2ChangeComplex; break;
                }
                m_auto_tmp = m_auto_beg;
                Bar->Position = (int)(m_auto_tmp/((TMainForm*)MainForm)->m_base[1][m_CAP_index]*511);
                Application->ProcessMessages();
                TimerAuto->Interval = m_auto_time_step*1000;
                TimerAuto->Enabled = true;
            }
        }
        delete AutoStatDlg;
    }
    else if(AAutoStart->Caption == "")
    {
        m_auto_finish = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::TimerAutoTimer(TObject *Sender)
{
    TTrackBar* Bar;
    switch(m_CAP_index)
    {
        case 0: Bar = TrackBar1; break;
        case 1: Bar = TrackBar2; break;
    }
    TimerAuto->Enabled = false;
    m_SavePoint();
    m_auto_tmp += m_auto_step;
    if(fabs(m_auto_end-m_auto_tmp) < fabs(m_auto_step/2)) m_auto_tmp = m_auto_end;
    if(m_auto_finish)
    {
        Bar->Position = 0;
        switch(m_CAP_index)
        {
            case 0: Bar->OnChange = TrackBar1ChangeSimple; break;
            case 1: Bar->OnChange = TrackBar2ChangeSimple; break;
        }
        Bar->Enabled = true;
        AAutoStart->Caption = "";
        BitBtn1->Enabled = true;
        BitBtn2->Enabled = true;
        Button3->Enabled = true;
        ChBStartFromStend->Enabled = true;
    }
    else
    {
        if(m_auto_tmp == m_auto_end) m_auto_finish = true;
        Bar->Position = (int)(m_auto_tmp/((TMainForm*)MainForm)->m_base[1][m_CAP_index]*511);
        TimerAuto->Enabled = true;
    }
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::ADeletePointExecute(TObject *Sender)
{
	int i;
    short tmp_short[32];
	unsigned short col_can = 16, col_can_CAP = (short)((TMainForm*)MainForm)->m_col_can_CAP;
	FILE* static_file = fopen(m_file.c_str(),"r+b");
	for(i=(StringGrid1->Row); i<(StringGrid1->RowCount-2); i++)
    {
		fseek(static_file,sizeof(short)*(col_can+col_can_CAP)*i,SEEK_SET);
		fread(tmp_short,sizeof(short),col_can+col_can_CAP,static_file);
		fseek(static_file,sizeof(short)*(col_can+col_can_CAP)*(i-1),SEEK_SET);
		fwrite(tmp_short,sizeof(short),col_can+col_can_CAP,static_file);
     	StringGrid1->Rows[i]->Assign(StringGrid1->Rows[i+1]);
    }
	m_col_points--;
    chsize(fileno(static_file),sizeof(short)*(col_can+col_can_CAP)*m_col_points);
    fclose(static_file);
	StringGrid1->Rows[i]->Clear();
    (StringGrid1->RowCount)--;
    StringGrid1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::ADeletePointUpdate(TObject *Sender)
{
    TAction* pa = dynamic_cast<TAction*>(Sender);
    if (pa)
		pa->Enabled = ((StringGrid1->Row > 0)&&(StringGrid1->Row < (StringGrid1->RowCount-1)));
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::ADeleteAllExecute(TObject *Sender)
{
    int i;
	FILE* static_file = fopen(m_file.c_str(),"wb");
	fclose(static_file);
    m_col_points = 0;
	for(i=1; i<(StringGrid1->RowCount); i++) StringGrid1->Rows[i]->Clear();
    StringGrid1->RowCount = 2;
    StringGrid1->Row = StringGrid1->RowCount-1;
    StringGrid1->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TStaticDlg::ADeleteAllUpdate(TObject *Sender)
{
    TAction* pa = dynamic_cast<TAction*>(Sender);
    if (pa)
		pa->Enabled = ((StringGrid1->RowCount) > 2);
}
//---------------------------------------------------------------------------

