/////////////////////////////////////////////////////////////////////////////
//  !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!
//
//              ,  
//              ,
//      (  ):
// -  ,     .;
// -   (      ) ,  
//     ;
// -         
//   .
//          (.. RK())    
//     generators()  equations().
/////////////////////////////////////////////////////////////////////////////
//---------------------------------------------------------------------------
#include <vcl.h>
#pragma hdrstop

#include "Main.h"
#include "asmcode.h"
#include "strucfrm.h"
#include "blocks1.h"
#include "generat.h"
#include "dynblks.h"
#include "graphunt.h"
#include "parrasch.h"
#include "rk_funcs.h"
#include "misc.h"
#include <stdio.h>
//---------------------------------------------------------------------------
#pragma package(smart_init)
#pragma resource "*.dfm"
TStructFrm *StructFrm;
//---------------------------------------------------------------------------
__fastcall TStructFrm::TStructFrm(TComponent* Owner)
	: TForm(Owner)
{
	TracingLine = NULL;
    sel_fl = false;
    cur_block = b_none;
    m_FileName = "";
    h = 0.001;
    rasch_time = 1;
    SB->DoubleBuffered = true;
}
//---------------------------------------------------------------------------
__fastcall TStructFrm::~TStructFrm()
{
}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::FormMouseDown(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if(Button == mbLeft)
    {
        if(cur_block != b_none)
        {
            m_set_block(X+PB->Left, Y+PB->Top);
            cur_block = b_none;
            PB->Cursor = crDefault;
        }
        else
        {
            sel_fl = true;
            startPt.x = X; startPt.y = Y;
            endPt.x = X; endPt.y = Y;
            TPenMode oldMode = PB->Canvas->Pen->Mode;
            PB->Canvas->Pen->Mode = pmNot;
            TBrushStyle oldBs = PB->Canvas->Brush->Style;
            PB->Canvas->Brush->Style = bsClear;
            TPenStyle oldPs = PB->Canvas->Pen->Style;
            PB->Canvas->Pen->Style = psDot;
            PB->Canvas->Rectangle(startPt.x,startPt.y,endPt.x,endPt.y);
            PB->Canvas->Pen->Mode = oldMode;
            PB->Canvas->Brush->Style = oldBs;
            PB->Canvas->Pen->Style = oldPs;
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::FormMouseMove(TObject *Sender,
      TShiftState Shift, int X, int Y)
{
    if(cur_block != b_none) PB->Cursor = crDrag;
    else if(TracingLine)
    {
        PB->Cursor = crCross;
        TPenMode oldMode = PB->Canvas->Pen->Mode;
        PB->Canvas->Pen->Mode = pmNot;
        PB->Canvas->Pen->Width = 3;
        TracingLine->Paint(PB->Canvas->Handle);
        TracingLine->m_EndPt = TPoint(X,Y);
        TracingLine->Paint(PB->Canvas->Handle);
        PB->Canvas->Pen->Width = 1;
        PB->Canvas->Pen->Mode = oldMode;
    }
    else PB->Cursor = crDefault;
    if(sel_fl)
    {
        TPenMode oldMode = PB->Canvas->Pen->Mode;
        PB->Canvas->Pen->Mode = pmNot;
        TBrushStyle oldBs = PB->Canvas->Brush->Style;
        PB->Canvas->Brush->Style = bsClear;
        TPenStyle oldPs = PB->Canvas->Pen->Style;
        PB->Canvas->Pen->Style = psDot;
        PB->Canvas->Rectangle(startPt.x,startPt.y,endPt.x,endPt.y);
        endPt.x = X; endPt.y = Y;
        PB->Canvas->Rectangle(startPt.x,startPt.y,endPt.x,endPt.y);
        PB->Canvas->Pen->Mode = oldMode;
        PB->Canvas->Brush->Style = oldBs;
        PB->Canvas->Pen->Style = oldPs;
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::FormMouseUp(TObject *Sender,
      TMouseButton Button, TShiftState Shift, int X, int Y)
{
	if(TracingLine)
    {
        TracingLine->m_StartBlock->m_out_per_chan[TracingLine->m_outCnt] --;
        if(TracingLine->m_StartBlock->m_out_per_chan[TracingLine->m_outCnt] == 0)
            TracingLine->m_StartBlock->m_selOut[TracingLine->m_outCnt] = false;
        TracingLine->m_StartBlock->Invalidate();
        delete TracingLine;
        TracingLine = NULL;
        PB->Invalidate();
    }
    if(sel_fl)
    {
        TPenMode oldMode = PB->Canvas->Pen->Mode;
        PB->Canvas->Pen->Mode = pmNot;
        TBrushStyle oldBs = PB->Canvas->Brush->Style;
        PB->Canvas->Brush->Style = bsClear;
        TPenStyle oldPs = PB->Canvas->Pen->Style;
        PB->Canvas->Pen->Style = psDot;
        PB->Canvas->Rectangle(startPt.x,startPt.y,endPt.x,endPt.y);
        endPt.x = X; endPt.y = Y;
        PB->Canvas->Pen->Mode = oldMode;
        PB->Canvas->Brush->Style = oldBs;
        PB->Canvas->Pen->Style = oldPs;
        int tmp;
        if(startPt.x > endPt.x)
        {
            tmp = endPt.x;
            endPt.x = startPt.x;
            startPt.x = tmp;
        }
        if(startPt.y > endPt.y)
        {
            tmp = endPt.y;
            endPt.y = startPt.y;
            startPt.y = tmp;
        }
        sel_fl = false;
		startPt = SB->ScreenToClient(PB->ClientToScreen(startPt));
		endPt = SB->ScreenToClient(PB->ClientToScreen(endPt));
        TRect sel_rect = TRect(startPt,endPt);
        TRect blk_rect, tmp_rect;
        for(int i=0; i<(SB->ComponentCount); i++)
        {
            TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
            if(blk)
            {
                blk_rect = TRect(blk->Left,blk->Top,blk->Left+blk->Width,blk->Top+blk->Height);
                if(IntersectRect(&tmp_rect,&blk_rect,&sel_rect))
                {
                    if(!blk->m_sel)
                    {
                        blk->m_sel = true;
                        blk->Repaint();
                    }
                }
                else
                {
                    if(blk->m_sel)
                    {
                        blk->m_sel = false;
                        blk->Repaint();
                    }
                }
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::FormPaint(TObject *Sender)
{
    TPenMode oldMode = PB->Canvas->Pen->Mode;
    PB->Canvas->Pen->Mode = pmBlack;
	for(int i=0; i<(SB->ComponentCount); i++)
    {
        TConnectLine* t_line = dynamic_cast<TConnectLine*>(SB->Components[i]);
		if(t_line)
        {
        	if((t_line != TracingLine)&&(t_line->Visible))
            	t_line->Paint(PB->Canvas->Handle);
        }
    }
	if(TracingLine)
    {
    	PB->Canvas->Pen->Mode = pmNot;
        PB->Canvas->Pen->Width = 3;
        TracingLine->Paint(PB->Canvas->Handle);
        PB->Canvas->Pen->Width = 1;
        PB->Canvas->Pen->Mode = pmBlack;
    }
    PB->Canvas->Pen->Mode = oldMode;
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::FormClose(TObject *Sender,
      TCloseAction &Action)
{
	Action = caFree;
}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGenStepExecute(TObject *Sender)
{   cur_block = b_gstep;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGenLineExecute(TObject *Sender)
{   cur_block = b_gline;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGenMeandrExecute(TObject *Sender)
{   cur_block = b_gmeandr;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::ASumBlkExecute(TObject *Sender)
{   cur_block = b_sumblk;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AAperiodExecute(TObject *Sender)
{   cur_block = b_aperiod;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGraphExecute(TObject *Sender)
{   cur_block = b_graph;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGenImpExecute(TObject *Sender)
{   cur_block = b_gimp;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGenSinTExecute(TObject *Sender)
{   cur_block = b_gsint;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AGenCosTExecute(TObject *Sender)
{   cur_block = b_gcost;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AIntegrExecute(TObject *Sender)
{   cur_block = b_integr;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::APIRegExecute(TObject *Sender)
{   cur_block = b_pireg;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::ACAPExecute(TObject *Sender)
{   cur_block = b_cap;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AACPExecute(TObject *Sender)
{   cur_block = b_acp;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AProporcExecute(TObject *Sender)
{   cur_block = b_proporc;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AMulBlkExecute(TObject *Sender)
{   cur_block = b_mulblk;}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AUnselectExecute(TObject *Sender)
{	cur_block = b_none;}
//---------------------------------------------------------------------------

TBlock* __fastcall TStructFrm::m_get_block(blks t_block)
{
    TBlock* block;
    switch(t_block)
    {
        case b_gstep:     block = new TGStep(this, GeneratList, 0); break;
        case b_gline:     block = new TGLine(this, GeneratList, 1); break;
        case b_gimp:      block = new TGImp(this, GeneratList, 2); break;
        case b_gsint:     block = new TGSinT(this, GeneratList, 3); break;
        case b_gcost:     block = new TGCosT(this, GeneratList, 4); break;
        case b_gmeandr:   block = new TGMeandr(this, GeneratList, 5); break;
        case b_sumblk:    block = new TSumBlock(this); break;
        case b_mulblk:    block = new TMulBlock(this); break;
        case b_graph:     block = new TGraphBlk(this); break;
        case b_integr:    block = new TIntegr(this); break;
        case b_aperiod:   block = new TAperiod(this); break;
        case b_proporc:   block = new TProporc(this); break;
        case b_pireg:     block = new TPIReg(this); break;
        case b_cap:       block = new TCAPBlk(this); break;
        case b_acp:       block = new TACPBlk(this); break;
        case b_ziblk:     block = new TZiBlk(this, StaticList, 0); break;
		case b_ogrblk:    block = new TOgrBlk(this, StaticList, 1); break;
        default:		  block = new TProporc(this);
    }
    return block;
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::m_set_block(int X, int Y)
{
    TBlock* block = m_get_block(cur_block);
    block->Left = X;
    block->Top = Y;
    block->Show();
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::ABlockUpdate(TObject *Sender)
{
    TAction* pa = dynamic_cast<TAction*>(Sender);
    if (pa)
    {
		if((pa->Name == "AUnselect")&&(cur_block == b_none))    		pa->Checked = true;
        else if((pa->Name == "AAperiod")&&(cur_block == b_aperiod))    	pa->Checked = true;
        else if((pa->Name == "AIntegr")&&(cur_block == b_integr))      	pa->Checked = true;
        else if((pa->Name == "APIReg")&&(cur_block == b_pireg))        	pa->Checked = true;
        else if((pa->Name == "AProporc")&&(cur_block == b_proporc))    	pa->Checked = true;
        else if((pa->Name == "AGenStep")&&(cur_block == b_gstep))      	pa->Checked = true;
        else if((pa->Name == "AGenLine")&&(cur_block == b_gline))      	pa->Checked = true;
        else if((pa->Name == "AGenMeandr")&&(cur_block == b_gmeandr))  	pa->Checked = true;
        else if((pa->Name == "AGenImp")&&(cur_block == b_gimp))        	pa->Checked = true;
        else if((pa->Name == "AGenSinT")&&(cur_block == b_gsint))      	pa->Checked = true;
        else if((pa->Name == "AGenCosT")&&(cur_block == b_gcost))      	pa->Checked = true;
        else if((pa->Name == "ASumBlk")&&(cur_block == b_sumblk))      	pa->Checked = true;
        else if((pa->Name == "AMulBlk")&&(cur_block == b_mulblk))      	pa->Checked = true;
        else if((pa->Name == "ACAP")&&(cur_block == b_cap))            	pa->Checked = true;
        else if((pa->Name == "AACP")&&(cur_block == b_acp))            	pa->Checked = true;
        else if((pa->Name == "AGraph")&&(cur_block == b_graph))        	pa->Checked = true;
        else if((pa->Name == "AZi")&&(cur_block == b_ziblk))           	pa->Checked = true;
        else if((pa->Name == "AOgr")&&(cur_block == b_ogrblk))         	pa->Checked = true;
        else pa->Checked = false;

        if(pa->Name == "AGraph")
        {
            int i;
            for(i=0; i<(SB->ComponentCount); i++)
            {
                TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
                if(blk) break;
            }
            pa->Enabled = !(i<(SB->ComponentCount));
        }
	}
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::ARotateExecute(TObject *Sender)
{
    int i;
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk)
            if((blk->m_sel)&(blk->m_have_in)&(blk->m_have_out)) blk->m_rotate();
    }
    PB->Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::ADeleteExecute(TObject *Sender)
{
    int i, j;
    for(i=0; i<(SB->ComponentCount); i++) //   
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk)
            if(blk->m_sel)
            {
                for(j=0; j<(SB->ComponentCount); j++) //      
                {
                    TConnectLine* m_line = dynamic_cast<TConnectLine*>(SB->Components[j]);
                    if(m_line)
                    {
                        if(m_line->m_StartBlock == blk)
                        {
                            m_line->m_EndBlock->m_selIn[m_line->m_inCnt] = false;
                            m_line->m_EndBlock->m_InpLine[m_line->m_inCnt] = NULL;
                            delete m_line;
                            j--; //..          1
                        }
                        else if(m_line->m_EndBlock == blk)
                        {
                            m_line->m_StartBlock->m_out_per_chan[m_line->m_outCnt] --;
                            if(m_line->m_StartBlock->m_out_per_chan[m_line->m_outCnt] == 0)
                            m_line->m_StartBlock->m_selOut[m_line->m_outCnt] = false;
                            delete m_line;
                            j--; //..          1
                        }
                    }
                }
                delete blk;
                i--; //..          1
            }
    }
    PB->Invalidate(); //  
    for(i=0; i<(SB->ComponentCount); i++) //   
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk) blk->Invalidate();
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::ASaveExecute(TObject *Sender)
{
	if(m_FileName == "") ASaveAs->Execute();
    else SaveToFile(m_FileName);
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::ASaveAsExecute(TObject *Sender)
{
	if(SaveDialog1->Execute())
    {
    	if(ExtractFileExt(SaveDialog1->FileName) == ".str")
        	SaveToFile(SaveDialog1->FileName);
        if(ExtractFileExt(SaveDialog1->FileName) == ".dta")
        {
        	int i;
            for(i=0; i<(SB->ComponentCount); i++)
            {
            	TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
                if(blk)
                {
                	blk->m_graph.SaveToFile(SaveDialog1->FileName);
                    break;
                }
            }
        }
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::SaveToFile(AnsiString m_file)
{
    int i, j;
    for(i=0, j=0; i<(SB->ComponentCount); i++)
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk)
        {
        	blk->Tag = j;
            j++;
        }
    }
	FILE* data_file = fopen(m_file.c_str(),"wb");
	fwrite(&j, sizeof(int), 1, data_file);
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk)
        {
            fwrite(&(blk->m_blk_type), sizeof(blks), 1, data_file);
            fwrite(&(blk->Left), sizeof(int), 1, data_file);
            fwrite(&(blk->Top), sizeof(int), 1, data_file);
            fwrite(&(blk->m_rot), sizeof(bool), 1, data_file);
            fwrite(&(blk->m_flag), sizeof(bool), 1, data_file);
            fwrite(&(blk->Tag), sizeof(int), 1, data_file);
     		fwrite(blk->m_arg, sizeof(blk->m_arg), 1, data_file);
        }
    }
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TConnectLine* line = dynamic_cast<TConnectLine*>(SB->Components[i]);
        if(line)
        {
			fwrite(&(line->m_StartBlock->Tag), sizeof(int), 1, data_file);
			fwrite(&(line->m_EndBlock->Tag), sizeof(int), 1, data_file);
			fwrite(&(line->m_outCnt), sizeof(int), 1, data_file);
			fwrite(&(line->m_inCnt), sizeof(int), 1, data_file);
        }
	}
    fclose(data_file);
    Caption = " [" + m_file + "]";
    m_FileName = m_file;
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::LoadFromFile(AnsiString m_file)
{
    blks m_blk_type;
    bool m_rot;
    int m_left, m_top, N_blocks, i, Tags[2], Cnts[2];
    TBlock* blk;
    TBlock* StartBlock;
    TBlock* EndBlock;
    TConnectLine* line;
	Application->ProcessMessages();
	FILE* data_file = fopen(m_file.c_str(),"rb");
    fread(&N_blocks, sizeof(int), 1, data_file);
    for(i=0; i<N_blocks; i++)
    {
		fread(&m_blk_type, sizeof(blks), 1, data_file);
        blk = m_get_block(m_blk_type);
        fread(&m_left, sizeof(int), 1, data_file);
        fread(&m_top, sizeof(int), 1, data_file);
        fread(&m_rot, sizeof(bool), 1, data_file);
        fread(&(blk->m_flag), sizeof(bool), 1, data_file);
        fread(&(blk->Tag), sizeof(int), 1, data_file);
        fread(blk->m_arg, sizeof(blk->m_arg), 1, data_file);
        blk->Left = m_left;
        blk->Top = m_top;
        if(m_rot) blk->m_rotate();
	    blk->Show();
    }
	while(fread(Tags, sizeof(int), 2, data_file))
    {
    	fread(Cnts, sizeof(int), 2, data_file);
	    for(i=0; i<(SB->ComponentCount); i++)
    	{
        	TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
	        if(blk)
            {
            	if(blk->Tag == Tags[0]) StartBlock = blk;
                if(blk->Tag == Tags[1]) EndBlock = blk;
            }
        }
		line = new TConnectLine(SB, StartBlock, Cnts[0], EndBlock, Cnts[1]);
	    line->m_StartBlock->Invalidate();
    	line->m_EndBlock->Invalidate();
    }
    fclose(data_file);
    Caption = " [" + m_file + "]";
    m_FileName = m_file;
    Invalidate();
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::RK(int N_difur, int N_gener, int N_proporc, int N_sumblk, int N_mulblk, int N_zi, int N_ogr, TBlkMassiv* m_m)
{
// "  - 4  "

    double h1 = 0;
    double h2 = h/2;
    double t0 = t;
    double Q;
    int i, j;
    int pr_offs = N_difur + N_gener;
    int sum_offs = pr_offs + N_proporc;
    int mul_offs = sum_offs + N_sumblk;
    int zi_offs = mul_offs + N_mulblk;
    int ogr_offs = zi_offs + N_zi;
    for(i=0; i<N_difur; i++)
    {
        m_m->Y0[i] = m_m->Y[i];
        m_m->Y1[i] = m_m->Y[i];
    }
    for(j=1; j<=4; j++)
    {
        t = t0 + h1;
//---  ---------------------------------------------------------------
        for(i=0; i<N_gener; i++)
        {
            m_m->X[i+N_difur] = generators(m_m->g_type[i],m_m->arg1[i+N_difur],m_m->arg2[i+N_difur],m_m->arg3[i+N_difur]);
        }
        for(i=0; i<N_proporc; i++)
        {
            m_m->X[i+pr_offs] = m_m->arg1[i+pr_offs]*m_m->X[m_m->ur_in[i+N_difur]];
        }
        for(i=0; i<N_sumblk; i++)
        {
            if(m_m->arg3[i+sum_offs] == 1)
                m_m->X[i+sum_offs] = m_m->X[(int)(m_m->arg1[i+sum_offs])] + m_m->X[(int)(m_m->arg2[i+sum_offs])];
            else
                m_m->X[i+sum_offs] = m_m->X[(int)(m_m->arg1[i+sum_offs])] - m_m->X[(int)(m_m->arg2[i+sum_offs])];
        }
        for(i=0; i<N_mulblk; i++)
        {
            m_m->X[i+mul_offs] = m_m->X[(int)(m_m->arg1[i+mul_offs])] * m_m->X[(int)(m_m->arg2[i+mul_offs])];
        }
        for(i=0; i<N_zi; i++)
        {
			if(m_m->X[i+zi_offs]>=m_m->X[m_m->ur_in[N_difur+N_proporc+i]]) m_m->X[i+zi_offs] = m_m->X[m_m->ur_in[N_difur+N_proporc+i]];
            else m_m->X[i+zi_offs] += h/(4*m_m->arg1[i+zi_offs]);
        }
        for(i=0; i<N_ogr; i++)
        {
			if(fabs(m_m->X[m_m->ur_in[N_difur+N_proporc+N_zi+i]])>m_m->arg1[i+ogr_offs]) m_m->X[i+ogr_offs]= m_m->arg1[i+ogr_offs]*fabs(m_m->X[m_m->ur_in[N_difur+N_proporc+N_zi+i]])/m_m->X[m_m->ur_in[N_difur+N_proporc+N_zi+i]];
            else m_m->X[i+ogr_offs]= m_m->X[m_m->ur_in[N_difur+N_proporc+N_zi+i]];
        }
        for(i=0; i<N_difur; i++)
        {
            m_m->D[i] = equations(m_m->ur_type[i], m_m->X[m_m->ur_in[i]], m_m->Y[i], m_m->arg1[i], m_m->arg2[i], m_m->arg3[i]);
        }
//-----------------------------------------------------------------------------
        h1 = h2;
        if(j==3) h1 = h;
        for(i=0; i<N_difur; i++)
        {
            Q = h1 * m_m->D[i];
            m_m->Y[i] = m_m->Y0[i] + Q;
            if(j==2) Q = 2*Q;
            m_m->Y1[i] = m_m->Y1[i] + Q/3;
            switch(m_m->ur_type[i])
            {
                case b_pireg: m_m->X[i] = m_m->Y[i] + m_m->arg1[i]*m_m->X[m_m->ur_in[i]]; break;
                default: m_m->X[i] = m_m->Y[i];
            }
        }
    }
    for(i=0; i<N_difur; i++) m_m->Y[i] = m_m->Y1[i];
}
//---------------------------------------------------------------------------

double __fastcall TStructFrm::generators(blks g_type, double arg1, double arg2, double arg3)
{
    switch(g_type)
    {
        case b_gstep:   return gen_step(arg1,arg2,t);          	// U max, Tvk
        case b_gmeandr: return gen_meandr(arg1,arg2,t);        	// U max, T
        case b_gline:   return gen_line(arg1,arg2,t);          	// k, Tvk
        case b_gimp:    return gen_imp(arg1,arg2,h,t);         	// U max, T
        case b_gpila:   return gen_pila(arg1,arg2,t);          	// U max, T
        case b_gsint:   return gen_sinT(arg1,arg2,t);          	// U max, T
        case b_gcost:   return gen_cosT(arg1,arg2,t);          	// U max, T
        case b_gsin:    return gen_sin(arg1,arg2,arg3,t);    	// U max, w, f
        default: 	   	return 0;
    }
}
//---------------------------------------------------------------------------

double  __fastcall TStructFrm::equations(blks ur_type, double ur_in, double ur_out, double arg1, double arg2, double arg3)
{
    switch(ur_type)
    {
        case b_integr:  return deriv_integ(arg1,ur_in);
        case b_aperiod: return deriv_aper(arg1,arg2,ur_in,ur_out);
        case b_pireg:   return deriv_integ(arg2,ur_in);
        default:		return 0;
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::calculate()
{
    TBlkMassiv* m_massiv = new TBlkMassiv();

    int N_difur = 0;
    int N_gener = 0;
    int N_proporc = 0;
    int N_sumblk = 0;
    int N_mulblk = 0;
    int N_zi = 0;
    int N_ogr = 0;
    int N_ACP = 16;
    int N_CAP = ((TMainForm*)MainForm)->m_col_can_CAP;
    unsigned short coords_to_scan = 0;
    unsigned short coords_to_send = 0;
    unsigned short coords_to_plot = 0;
    int col_can = 0;
    AnsiString m_file = NULL;
    AnsiString m_filter_file = NULL;
    int jj = 0;
    int graph_in[16];
    int i, j;
    unsigned short channel;
    double /*rasch_time,*/ end_time=0;
    unsigned long clock_beg, clock_end, cnt;
    int N_test_rep;

    for(j=t_dynblk; j<t_last; j++)
    {
	    for(i=0; i<(SB->ComponentCount); i++)
    	{
        	TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
	        if(blk)
    	        if(blk->m_type == j)
        	    {
					switch(j)
                    {
                    	case t_dynblk:		SB->Components[i]->Tag = jj; jj++; N_difur++; break;
                        case t_generator:   SB->Components[i]->Tag = jj; jj++; N_gener++; break;
                        case t_proporc:     SB->Components[i]->Tag = jj; jj++; N_proporc++; break;
                        case t_sumblk:		SB->Components[i]->Tag = jj; jj++; N_sumblk++; break;
                        case t_mulblk:		SB->Components[i]->Tag = jj; jj++; N_mulblk++; break;
                        case t_ziblk:		SB->Components[i]->Tag = jj; jj++; N_zi++; break;
                        case t_ogrblk:		SB->Components[i]->Tag = jj; jj++; N_ogr++; break;
                    }
	            }
    	}
    }
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TACPBlk* blk = dynamic_cast<TACPBlk*>(SB->Components[i]);
        if(blk)
        {
        	SB->Components[i]->Tag = jj + blk->ch;
            coords_to_scan |= (short)(1<< blk->ch);
        }
    }
	jj += N_ACP;
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TCAPBlk* blk = dynamic_cast<TCAPBlk*>(SB->Components[i]);
        if(blk)
        {
        	SB->Components[i]->Tag = jj + blk->ch;
            coords_to_send |= (short)(1<< blk->ch);
        }
    }

    m_massiv->Y  = (double*)calloc(N_difur,sizeof(double));
    m_massiv->Y0 = (double*)calloc(N_difur,sizeof(double));
    m_massiv->Y1 = (double*)calloc(N_difur,sizeof(double));
    m_massiv->D  = (double*)calloc(N_difur,sizeof(double));
    m_massiv->X  = (double*)calloc((N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP+1),sizeof(double));
    m_massiv->g_type  = (blks*)calloc(N_gener,sizeof(blks));
    m_massiv->ur_type = (blks*)calloc(N_difur,sizeof(blks));
    m_massiv->ur_in   = (int*)calloc(N_difur+N_proporc+N_zi+N_ogr+N_CAP,sizeof(int));
    m_massiv->arg1 = (double*)calloc((N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr),sizeof(double));
    m_massiv->arg2 = (double*)calloc((N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr),sizeof(double));
    m_massiv->arg3 = (double*)calloc((N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr),sizeof(double));

    for(i=0; i<N_difur; i++)
    {
        m_massiv->Y[i] = 0;
        m_massiv->X[i] = 0;
    }
    m_massiv->X[N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP] = 0;

    for(i=0; i<(SB->ComponentCount); i++)
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk)
        {
            if(blk->m_type == t_generator)
            {
				m_massiv->g_type[SB->Components[i]->Tag - N_difur] = ((TBlock*)SB->Components[i])->m_blk_type;
                m_massiv->arg1[SB->Components[i]->Tag] = ((TBlock*)SB->Components[i])->m_arg[0];
                m_massiv->arg2[SB->Components[i]->Tag] = ((TBlock*)SB->Components[i])->m_arg[1];
            }
        }
    }
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TBlock* blk = dynamic_cast<TBlock*>(SB->Components[i]);
        if(blk)
        {
            if(blk->m_type == t_dynblk)
            {
				m_massiv->ur_type[SB->Components[i]->Tag] = ((TBlock*)SB->Components[i])->m_blk_type;
                m_massiv->arg1[SB->Components[i]->Tag] = ((TBlock*)SB->Components[i])->m_arg[0];
                m_massiv->arg2[SB->Components[i]->Tag] = ((TBlock*)SB->Components[i])->m_arg[1];
                m_massiv->Y[SB->Components[i]->Tag] = ((TBlock*)SB->Components[i])->m_arg[2];
                if(blk->m_InpLine[0]) m_massiv->ur_in[SB->Components[i]->Tag] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
                else m_massiv->ur_in[SB->Components[i]->Tag] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
            }
        }
    }
    for(i=0; i<(SB->ComponentCount); i++) // .
    {
        TProporc* blk = dynamic_cast<TProporc*>(SB->Components[i]);
        if(blk)
        {
            m_massiv->arg1[SB->Components[i]->Tag] = blk->m_arg[0];
            if(((TBlock*)SB->Components[i])->m_InpLine[0]) m_massiv->ur_in[SB->Components[i]->Tag - N_gener] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
            else m_massiv->ur_in[SB->Components[i]->Tag - N_gener] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
        }
    }
    for(i=0; i<(SB->ComponentCount); i++) // 
    {
        TZiBlk* blk = dynamic_cast<TZiBlk*>(SB->Components[i]);
        if(blk)
        {
            m_massiv->arg1[SB->Components[i]->Tag] = blk->m_arg[0];
            if(((TBlock*)SB->Components[i])->m_InpLine[0]) m_massiv->ur_in[SB->Components[i]->Tag-N_gener-N_sumblk-N_mulblk] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
            else m_massiv->ur_in[SB->Components[i]->Tag-N_gener-N_sumblk-N_mulblk] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
        }
    }
    for(i=0; i<(SB->ComponentCount); i++) // 
    {
        TOgrBlk* blk = dynamic_cast<TOgrBlk*>(SB->Components[i]);
        if(blk)
        {
            m_massiv->arg1[SB->Components[i]->Tag] = blk->m_arg[0];
            if(((TBlock*)SB->Components[i])->m_InpLine[0]) m_massiv->ur_in[SB->Components[i]->Tag-N_gener-N_sumblk-N_mulblk] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
            else m_massiv->ur_in[SB->Components[i]->Tag-N_gener-N_sumblk-N_mulblk] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
        }
    }
    for(i=0; i<(SB->ComponentCount); i++) // 
    {
        TCAPBlk* blk = dynamic_cast<TCAPBlk*>(SB->Components[i]);
        if(blk)
        {
            if(((TBlock*)SB->Components[i])->m_InpLine[0]) m_massiv->ur_in[SB->Components[i]->Tag-jj+N_gener+N_proporc+N_zi+N_ogr] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
            else m_massiv->ur_in[SB->Components[i]->Tag-jj+N_gener+N_proporc+N_zi+N_ogr] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
        }
    }
    for(i=0; i<(SB->ComponentCount); i++) // 
    {
        TSumBlock* blk = dynamic_cast<TSumBlock*>(SB->Components[i]);
        if(blk)
        {
            if(blk->m_flag) m_massiv->arg3[SB->Components[i]->Tag] = 1;
            else m_massiv->arg3[SB->Components[i]->Tag] = 0;
            if(blk->m_InpLine[0]) m_massiv->arg1[SB->Components[i]->Tag] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
            else m_massiv->arg1[SB->Components[i]->Tag] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
            if(blk->m_InpLine[1]) m_massiv->arg2[SB->Components[i]->Tag] = ((TConnectLine*)(blk->m_InpLine[1]))->m_StartBlock->Tag;
            else m_massiv->arg2[SB->Components[i]->Tag] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
        }
    }
    for(i=0; i<(SB->ComponentCount); i++) //  
    {
        TMulBlock* blk = dynamic_cast<TMulBlock*>(SB->Components[i]);
        if(blk)
        {
            if(blk->m_InpLine[0]) m_massiv->arg1[SB->Components[i]->Tag] = ((TConnectLine*)(blk->m_InpLine[0]))->m_StartBlock->Tag;
            else m_massiv->arg1[SB->Components[i]->Tag] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
            if(blk->m_InpLine[1]) m_massiv->arg2[SB->Components[i]->Tag] = ((TConnectLine*)(blk->m_InpLine[1]))->m_StartBlock->Tag;
            else m_massiv->arg2[SB->Components[i]->Tag] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
        }
    }
    for(j=0; j<16; j++) graph_in[j] = N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+N_ACP;
    for(i=0; i<(SB->ComponentCount); i++)
    {
        TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
        if(blk)
        {
            col_can = 0;
            for(j=0; j<16; j++)
            {
                if(blk->m_InpLine[j])
                {
                    coords_to_plot |= (short)(1<<j);
                    graph_in[col_can] = ((TConnectLine*)(blk->m_InpLine[j]))->m_StartBlock->Tag;
                    col_can++;
                }
            }
            if(col_can != 0) m_file = blk->m_graph.m_file;
        }
    }

    RaschDlg = new TRaschDlg(this);
    RaschDlg->Edit1->Text = FloatToStrF(rasch_time,ffFixed,10,5);
    RaschDlg->Edit2->Text = FloatToStrF(h,ffFixed,10,5);

    if(RaschDlg->ShowModal() == mrOk)
    {
		short CAP_tmp[16];
	    double tmp[16];
		for(int i=0; i<((TMainForm*)MainForm)->m_col_can_CAP; i++) CAP_tmp[i] = 0;
		((TMainForm*)MainForm)->ResetCAP(CAP_tmp);
        rasch_time = myStrToFloat(RaschDlg->Edit1->Text);
        h = myStrToFloat(RaschDlg->Edit2->Text);
        t = 0;
//>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>1<
        if(RaschDlg->ChBRealTime->Checked)
        {
            N_test_rep = 10;
            cnt = 0;
            FILE* data_file = NULL;
            if(m_file != NULL) data_file = fopen(m_file.c_str(),"wb");
            clock_beg = GetTickCount();
            while(end_time<rasch_time)
            {
                cnt ++;
                for(i=0; i<N_test_rep; i++)
                {
                	for (channel=0; channel<N_ACP; channel++)
                    {
                    	if ((coords_to_scan >> channel)& 1)
                        {
                        	m_massiv->X[N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+channel]
                            = (double)(GetACP(channel) + ((TMainForm*)MainForm)->m_offset[0][channel])/511;
                        }
                    }
                    RK(N_difur, N_gener, N_proporc, N_sumblk, N_mulblk, N_zi, N_ogr, m_massiv);
                	for (channel=0; channel<N_CAP; channel++)
                    {
                    	if ((coords_to_send >> channel)& 1)
                        {
                            SendCAP(channel, (short)((m_massiv->X[m_massiv->ur_in[N_difur+N_proporc+N_zi+N_ogr+channel]])*511
                            						+((TMainForm*)MainForm)->m_offset[1][channel]));
                        }
                    }
                    if(data_file)
                    {
                        for(channel=0; channel<col_can; channel++)
                            tmp[channel] = m_massiv->X[graph_in[channel]];
                        fwrite(tmp,sizeof(double),col_can,data_file);
                    }
                    clock_end = GetTickCount();
                    end_time = ((double)(clock_end - clock_beg))/1000;
                    if(end_time>=rasch_time) break;
                }
                h = end_time/(double)N_test_rep/(double)cnt;
            }
            if(data_file)
            {
                fclose(data_file);
                for(i=0; i<(SB->ComponentCount); i++)
                {
                    TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
                    if(blk)
                    {
                        blk->m_graph.elp_time = rasch_time;
                        blk->m_graph.end_time = rasch_time;
                        blk->m_graph.m_coords_mask[0] = coords_to_plot;
                        blk->m_graph.m_coords_to_show[0] = coords_to_plot;
                        blk->Invalidate();
                    }
                }
            }
        }
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
        else
        {
        	FILE* data_file = NULL;
            if(m_file != NULL) data_file = fopen(m_file.c_str(),"wb");
            while(t<rasch_time)
            {
            	for (channel=0; channel<N_ACP; channel++)
                {
                	if ((coords_to_scan >> channel) & 0x01)
                    {
                    	m_massiv->X[N_difur+N_gener+N_proporc+N_sumblk+N_mulblk+N_zi+N_ogr+channel]
                        = (double)(GetACP(channel) + ((TMainForm*)MainForm)->m_offset[0][channel])/511;
                    }
                }
                RK(N_difur, N_gener, N_proporc, N_sumblk, N_mulblk, N_zi, N_ogr, m_massiv);
                for (channel=0; channel<N_CAP; channel++)
                {
                	if ((coords_to_send >> channel)& 1)
                    {
                        CAP_tmp[channel] = (short)((m_massiv->X[m_massiv->ur_in[N_difur+N_proporc+N_zi+N_ogr+channel]])*511);
                    	SendCAP(channel, (short)(CAP_tmp[channel]+((TMainForm*)MainForm)->m_offset[1][channel]));
                    }
                }
                if(data_file)
                {
                	for(channel=0; channel<col_can; channel++)
                    	tmp[channel] = m_massiv->X[graph_in[channel]];
                    fwrite(tmp,sizeof(double),col_can,data_file);
                }
            }
            if(data_file)
            {
            	fclose(data_file);
                for(i=0; i<(SB->ComponentCount); i++)
                {
                	TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
                    if(blk)
                    {
                    	blk->m_graph.elp_time = rasch_time;
                        blk->m_graph.end_time = rasch_time;
                        blk->m_graph.m_coords_mask[0] = coords_to_plot;
                        blk->m_graph.m_coords_to_show[0] = coords_to_plot;
                        blk->Invalidate();
                    }
                }
            }
        }
//<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
		((TMainForm*)MainForm)->ResetCAP(CAP_tmp);
		ShowMessage("h = " + FloatToStrF(h,ffFixed,10,5));
	}

    free(m_massiv->Y);
    free(m_massiv->Y0);
    free(m_massiv->Y1);
    free(m_massiv->D);
    free(m_massiv->X);
    free(m_massiv->g_type);
    free(m_massiv->ur_type);
    free(m_massiv->ur_in);
    free(m_massiv->arg1);
    free(m_massiv->arg2);
    free(m_massiv->arg3);
    delete m_massiv;
    delete RaschDlg;
}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::ACalcExecute(TObject *Sender)
{
	calculate();
}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AZiExecute(TObject *Sender)
{
	cur_block = b_ziblk;
}
//---------------------------------------------------------------------------
void __fastcall TStructFrm::AOgrExecute(TObject *Sender)
{
	cur_block = b_ogrblk;
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::APrintGraphUpdate(TObject *Sender)
{
    TAction* pa = dynamic_cast<TAction*>(Sender);
    if(pa)
    {
		int i;
    	for(i=0; i<(SB->ComponentCount); i++)
	    {
    		TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
        	if(blk) break;
	    }
    	pa->Enabled = (i<(SB->ComponentCount));
    }
}
//---------------------------------------------------------------------------

void __fastcall TStructFrm::APrintGraphExecute(TObject *Sender)
{
	int i;
    for(i=0; i<(SB->ComponentCount); i++)
    {
    	TGraphBlk* blk = dynamic_cast<TGraphBlk*>(SB->Components[i]);
        if(blk)
        {
         	blk->m_Print();
            break;
        }
    }
}
//---------------------------------------------------------------------------



